// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(v) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function Te(e, n) {
        return n.indexOf(e) >= 0;
    }
    function De(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function le(e, n, t) {
        if (t) for (var i in e) {
            if (Ie(e, i) && !Ie(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (Ie(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (Ie(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Oe() {}
    function Ae() {
        return false;
    }
    function ze() {
        return true;
    }
    function $e() {
        return this;
    }
    function Me() {
        return null;
    }
    var je = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === a) continue;
                if (r instanceof o) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Fe(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function qe(e, i) {
        return e.replace(/\{([^}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof Ue ? t.print_to_string() : t;
        });
    }
    function Ce(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function Ne(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function Pe(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function He() {
        this._values = Object.create(null);
        this._size = 0;
    }
    He.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new He();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    He.fromObject = function(e) {
        var n = new He();
        n._size = t(n._values, e);
        return n;
    };
    function Ie(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function Re(e, n) {
        var t = e.parent(-1);
        for (var i = 0, r; r = e.parent(i++); t = r) {
            if (r instanceof pn) {
                return n && r.value === t;
            } else if (r instanceof Xn) {
                if (r.left === t) continue;
            } else if (r.TYPE == "Call") {
                if (r.expression === t) continue;
            } else if (r instanceof Kn) {
                if (r.condition === t) continue;
            } else if (r instanceof Bn) {
                if (r.expression === t) continue;
            } else if (r instanceof Un) {
                if (r.expressions[0] === t) continue;
            } else if (r instanceof Be) {
                return r.body === t;
            } else if (r instanceof Gn) {
                if (r.expression === t) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = Ue;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var a = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        var o = i && new i();
        if (o && o.initialize || t && t.initialize) a.push("this.initialize();");
        a.push("}}");
        var s = new Function(a.join(""))();
        if (o) {
            s.prototype = o;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (Ie(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof v !== "undefined") {
            v["AST_" + e] = s;
        }
        return s;
    }
    var Q = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var Ue = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Ht(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: Oe,
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new jt(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(qe("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (Ue.log_function = function(n, e) {
        if (!n) {
            Ue.info = Ue.warn = Oe;
            return;
        }
        var t = Object.create(null);
        Ue.info = e ? function(e, n) {
            i("INFO: " + qe(e, n));
        } : Oe;
        Ue.warn = function(e, n) {
            i("WARN: " + qe(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    Ue.enable_validation = function() {
        Ue.disable_validation();
        (function e(n) {
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof Ue) {
                    t.validate();
                } else if (!(t === null || n && je.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = i;
            });
            n.SUBCLASSES.forEach(e);
        })(this);
    };
    Ue.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var Be = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var Ye = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Be);
    var Le = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Be);
    var Ve = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Be);
    function o(e, n, t, i, r) {
        t = t ? "contain" : "be";
        if (!(e instanceof Ue)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof Hn) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof nt) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Ot && !r) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof Vn && !i) throw new Error(n + " cannot " + t + " AST_Spread");
        if (e instanceof Be && !ln(e)) {
            throw new Error(n + " cannot " + t + " AST_Statement");
        }
        if (e instanceof lt) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function s(e, n) {
        o(e[n], n);
    }
    var We = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "body");
        }
    }, Be);
    var Je = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof Je)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof sn)) throw new Error("must be contained within AST_Scope");
        }
    }, Be);
    function Ge(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var Xe = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Ge(n, e);
            });
        },
        _validate: function() {
            this.body.forEach(function(e) {
                if (!(e instanceof Be)) throw new Error("body must be AST_Statement[]");
                if (ln(e)) throw new Error("body cannot contain AST_Function");
            });
        }
    }, Je);
    var Ke = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, Xe);
    var T = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (!(this.body instanceof Be)) throw new Error("body must be AST_Statement");
            if (ln(this.body)) throw new Error("body cannot be AST_Function");
        }
    }, Je);
    var Qe = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new jt(function(e) {
                    if (e instanceof kn) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof sn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof pe)) throw new Error("label must be AST_Label");
        }
    }, T);
    var Ze = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, T);
    var en = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            s(this, "condition");
        }
    }, Ze);
    var nn = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, en);
    var tn = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, en);
    var rn = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof Ue)) throw new Error("init must be AST_Node");
                if (this.init instanceof Be && !(this.init instanceof Fn || ln(this.init))) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) s(this, "condition");
            if (this.step != null) s(this, "step");
        }
    }, Ze);
    var an = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init instanceof Fn) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof Bn || e instanceof bt)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            s(this, "object");
        }
    }, Ze);
    var on = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, T);
    var sn = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: $e
    }, Xe);
    var fn = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return Pt([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Ht(function(e) {
                if (e instanceof Le && e.value == "$ORIG") {
                    return je.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return Pt([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Ht(function(e) {
                if (e instanceof Le && e.value == "$ORIG") {
                    return je.splice(t);
                }
            }));
        }
    }, sn);
    var un = i("Lambda", "argnames length_read uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new jt(function(e) {
                if (e instanceof it) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof ht) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                Ge(e, n);
            });
        },
        _validate: function() {
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof ht)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
        }
    }, sn);
    var cn = i("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, un);
    function ln(e) {
        return e instanceof pn || e instanceof vn || e instanceof hn;
    }
    var pn = i("Arrow", "inlined value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.value) {
                    e.value.walk(n);
                } else {
                    Ge(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, un);
    function dn(e) {
        return e instanceof _n || e instanceof vn;
    }
    var vn = i("AsyncFunction", "inlined name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof _t)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, un);
    var hn = i("Function", "inlined name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof _t)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, un);
    function mn(e) {
        return e instanceof _n || e instanceof gn;
    }
    var _n = i("AsyncDefun", "inlined name", {
        $documentation: "An asynchronous function definition",
        $propdoc: {
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (!(this.name instanceof mt)) throw new Error("name must be AST_SymbolDefun");
        }
    }, un);
    var gn = i("Defun", "inlined name", {
        $documentation: "A function definition",
        $propdoc: {
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (!(this.name instanceof mt)) throw new Error("name must be AST_SymbolDefun");
        }
    }, un);
    var bn = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, Be);
    var yn = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        }
    }, bn);
    var wn = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, yn);
    var xn = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            s(this, "value");
        }
    }, yn);
    var kn = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.label != null) {
                if (!(this.label instanceof de)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, bn);
    var En = i("Break", null, {
        $documentation: "A `break` statement"
    }, kn);
    var Sn = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, kn);
    var Tn = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            if (this.alternative != null) {
                if (!(this.alternative instanceof Be)) throw new Error("alternative must be AST_Statement");
                if (ln(this.alternative)) throw new error("alternative cannot be AST_Function");
            }
        }
    }, T);
    var Dn = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Ge(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof On)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, Xe);
    var On = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, Xe);
    var An = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, On);
    var zn = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Ge(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, On);
    var $n = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Ge(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof Mn)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof jn)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, Xe);
    var Mn = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                Ge(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof gt)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, Xe);
    var jn = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, Xe);
    var Fn = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, Be);
    var qn = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Pn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof pt)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, Fn);
    var Cn = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Pn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof dt)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, Fn);
    var Nn = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Pn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof vt)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, Fn);
    var Pn = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    });
    var Hn = i("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            s(this, "value");
        }
    });
    function f(e, n, t, i) {
        e[n].forEach(function(e) {
            o(e, n, true, t, i);
        });
    }
    var In = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "expression");
            f(this, "args", true);
        }
    });
    var Rn = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, In);
    var Un = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    var Bn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof wt) {
                return e.value;
            }
            if (e instanceof Jn && e.operator == "void" && e.expression instanceof wt) {
                return;
            }
            return e;
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Yn = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Bn);
    var Ln = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            s(this, "property");
        }
    }, Bn);
    var Vn = i("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Wn = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "expression");
        }
    });
    var Jn = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Wn);
    var Gn = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Wn);
    var Xn = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Qn)) s(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "right");
        }
    });
    var Kn = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            s(this, "consequent");
            s(this, "alternative");
        }
    });
    var Qn = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof nt) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof Bn || e instanceof bt)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            }
        }
    }, Xn);
    var Zn = i("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var et = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var nt = i("Destructured", null, {
        $documentation: "Base class for destructured literal"
    });
    function u(e, n, t) {
        if (e instanceof Hn && t) return u(e.name, n);
        if (e instanceof tt) return e.elements.forEach(function(e) {
            if (!(e instanceof Ot)) u(e, n, true);
        });
        if (e instanceof rt) return e.properties.forEach(function(e) {
            u(e.value, n, true);
        });
        n(e);
    }
    var tt = i("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        }
    }, nt);
    var it = i("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof Ue) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof Ue)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof Ue)) throw new Error("value must be AST_Node");
        }
    });
    var rt = i("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof it)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, nt);
    var at = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof ot || e instanceof Vn)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var ot = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof Ue) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof Ue)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof Ue)) throw new Error("value must be AST_Node");
        }
    });
    var st = i("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            s(this, "value");
        }
    }, ot);
    var ft = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof cn)) throw new Error("value must be AST_Accessor");
        }
    }, ot);
    var ut = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof cn)) throw new Error("value must be AST_Accessor");
        }
    }, ot);
    var ct = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var lt = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, ct);
    var pt = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, lt);
    var dt = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, lt);
    var vt = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, lt);
    var ht = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, vt);
    var mt = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, lt);
    var _t = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, lt);
    var gt = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, lt);
    var pe = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, ct);
    var bt = i("SymbolRef", "fixed in_arg", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, ct);
    var de = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, ct);
    var yt = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.name !== "this") throw new Error('name must be "this"');
        }
    }, ct);
    var wt = i("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var xt = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, wt);
    var kt = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
        }
    }, wt);
    var Et = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, wt);
    var h = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, wt);
    var St = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, h);
    var Tt = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, h);
    var Dt = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, h);
    var Ot = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, h);
    var At = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, h);
    var zt = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, h);
    var $t = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, zt);
    var Mt = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, zt);
    function jt(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    jt.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Oe);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof un) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Le && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof un) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof sn) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof Le)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Qe && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Ze || e instanceof En && i instanceof Dn) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof Kn && t.condition === e || t instanceof en && t.condition === e || t instanceof rn && t.condition === e || t instanceof Tn && t.condition === e || t instanceof wn && t.in_bool || t instanceof Un && t.tail_node() !== e || t instanceof We || t instanceof Jn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof Xn && (t.operator == "&&" || t.operator == "||") || t instanceof Kn || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof wn) {
                    for (var i, r = t; i = this.parent(++n); r = i) {
                        if (i.TYPE == "Call") {
                            if (!(r instanceof un) || r.name) return false;
                        } else if (r instanceof un) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var ve = "break case catch const continue debugger default delete do else finally for function if in instanceof let new return switch throw try typeof var void while with";
    var M = "false null true";
    var D = [ "await abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized this throws transient volatile yield", M, ve ].join(" ");
    var j = "return new delete throw else case";
    ve = Ne(ve);
    D = Ne(D);
    j = Ne(j);
    M = Ne(M);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var F = Ne([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var q = "\n\r\u2028\u2029";
    var C = "+-*&%=<>!?|~^";
    var N = "[{(,;:";
    var P = N + ")}]";
    var H = q + "  \t\f\v​             　\ufeff";
    var I = Ne(e("./'\"" + C + P + H));
    q = Ne(e(q));
    C = Ne(e(C));
    N = Ne(e(N));
    P = Ne(e(P));
    H = Ne(e(H));
    function Z(e) {
        return e >= 55296 && e <= 56319;
    }
    function ee(e) {
        return e >= 56320 && e <= 57343;
    }
    function R(e) {
        return e >= 48 && e <= 57;
    }
    function ne(e) {
        return !I[e];
    }
    function Ft(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function qt(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    qt.prototype = Object.create(Error.prototype);
    qt.prototype.constructor = qt;
    qt.prototype.name = "SyntaxError";
    n(qt);
    function he(e, n, t, i, r) {
        throw new qt(e, n, t, i, r);
    }
    function me(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var B = {};
    function _e(r, a, o, s) {
        var f = {
            text: r,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw B;
            if (q[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function v() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (q[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw B;
            return t;
        }
        function h() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !Ct[n] || e == "keyword" && j[n] || e == "punc" && N[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Q(i);
        }
        function _() {
            while (H[c()]) l();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = c()) && e(t, i++)) n += l();
            return n;
        }
        function g(e) {
            he(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function b(i) {
            var r = false, a = false, o = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return o ? false : o = true;

                  case 101:
                  case 69:
                    return o ? true : r ? false : r = a = true;

                  case 45:
                    return a || n == 0 && !i;

                  case 43:
                    return a;

                  case a = false, 46:
                    return !s && !o && !r ? s = true : false;
                }
                return R(t) || /[_0-9a-fo]/i.test(e);
            });
            if (i) e = i + e;
            if (/^0[0-7_]+$/.test(e)) {
                if ($.has_directive("use strict")) g("Legacy octal literals are not allowed in strict mode");
            } else {
                e = e.replace(o ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var n = U(e);
            if (!isNaN(n)) return m("num", n);
            g("Invalid syntax: " + e);
        }
        function y(e) {
            var n = l(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                if (c() != "{") return String.fromCharCode(x(4));
                l();
                var t = 0;
                do {
                    var i = parseInt(l(true), 16);
                    if (isNaN(i)) g("Invalid hex-character pattern in string");
                    t = t * 16 + i;
                } while (c() != "}");
                l();
                if (t < 65536) return String.fromCharCode(t);
                if (t > 1114111) g("Invalid character code: " + t);
                return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

              case 13:
                if (c() == "\n") l(true, e);

              case 10:
                return "";
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && $.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(l(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var k = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = y(true); else if (q[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = m("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = f.regex_allowed;
            var t = v(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, i, true));
            f.regex_allowed = n;
            return $;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return $;
        });
        function S() {
            var e = false, n = "", t, i = false, r;
            while (t = c()) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (ne(t)) n += l(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!ne(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (ve[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var T = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (q[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = S();
            try {
                var a = new RegExp(e, r);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                g(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return E("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? T("") : D("/");
        }
        function A() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return m("operator", n);
            }
            return R(e.charCodeAt(0)) ? b(".") : m("punc", ".");
        }
        function z() {
            var e = S();
            if (u) return m("name", e);
            return M[e] ? m("atom", e) : !ve[e] ? m("name", e) : F[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === B) g(n); else throw e;
                }
            };
        }
        function $(e) {
            if (e != null) return T(e);
            if (s && f.pos == 0 && d("#!")) {
                h();
                p(2);
                E("comment5");
            }
            for (;;) {
                _();
                h();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        E("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return k(n);

                  case 46:
                    return A();

                  case 47:
                    var i = O();
                    if (i === $) continue;
                    return i;
                }
                if (R(t)) return b();
                if (P[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (C[n]) return D();
                if (t == 92 || !I[n]) return z();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        $.context = function(e) {
            if (e) f = e;
            return f;
        };
        $.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        $.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        $.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        $.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return $;
    }
    var ge = Ne("typeof void delete -- ++ ! ~ - +");
    var Ct = Ne("-- ++");
    var be = Ne("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var Nt = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var ye = Ne("atom num regexp string");
    function Pt(e, f) {
        f = le(f, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var u = {
            input: typeof e == "string" ? _e(e, f.filename, f.html5_comments, f.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        u.token = p();
        function c(e, n) {
            return me(u.token, e, n);
        }
        function l() {
            return u.peeked || (u.peeked = u.input());
        }
        function p() {
            u.prev = u.token;
            if (u.peeked) {
                u.token = u.peeked;
                u.peeked = null;
            } else {
                u.token = u.input();
            }
            u.in_directives = u.in_directives && (u.token.type == "string" || c("punc", ";"));
            return u.token;
        }
        function d() {
            return u.prev;
        }
        function o(e, n, t, i) {
            var r = u.input.context();
            he(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function r(e, n) {
            o(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function v(e) {
            if (e == null) e = u.token;
            r(e, "Unexpected token: " + t(e.type, e.value));
        }
        function a(e, n) {
            if (c(e, n)) return p();
            r(u.token, "Unexpected token: " + t(u.token.type, u.token.value) + ", expected: " + t(e, n));
        }
        function h(e) {
            return a("punc", e);
        }
        function s(e) {
            return e.nlb || !Pe(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function m() {
            return !f.strict && (c("eof") || c("punc", "}") || s(u.token));
        }
        function _(e) {
            if (c("punc", ";")) p(); else if (!e && !m()) h(";");
        }
        function g() {
            h("(");
            var e = fe();
            h(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = u.token;
                var n = i.apply(null, arguments);
                var t = d();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function b() {
            if (c("operator", "/") || c("operator", "/=")) {
                u.peeked = null;
                u.token = u.input(u.token.value.substr(1));
            }
        }
        var y = n(function() {
            b();
            switch (u.token.type) {
              case "string":
                var e = u.in_directives;
                var n = fe();
                if (e) {
                    if (n instanceof xt) {
                        var t = n.start.raw.slice(1, -1);
                        u.input.add_directive(t);
                        n.value = t;
                    } else {
                        u.in_directives = e = false;
                    }
                }
                _();
                return e ? new Le(n) : new We({
                    body: n
                });

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return x();

              case "name":
                switch (u.token.value) {
                  case "async":
                    if (me(l(), "keyword", "function")) {
                        p();
                        p();
                        return O(_n);
                    }

                  case "await":
                    if (u.in_async) return x();

                  default:
                    return me(l(), "punc", ":") ? w() : x();
                }

              case "punc":
                switch (u.token.value) {
                  case "{":
                    return new Ke({
                        start: u.token,
                        body: z(),
                        end: d()
                    });

                  case "[":
                  case "(":
                    return x();

                  case ";":
                    u.in_directives = false;
                    p();
                    return new Ve();

                  default:
                    v();
                }

              case "keyword":
                switch (u.token.value) {
                  case "break":
                    p();
                    return k(En);

                  case "const":
                    p();
                    var i = F();
                    _();
                    return i;

                  case "continue":
                    p();
                    return k(Sn);

                  case "debugger":
                    p();
                    _();
                    return new Ye();

                  case "do":
                    p();
                    var n = ue(y);
                    a("keyword", "while");
                    var r = g();
                    _(true);
                    return new nn({
                        body: n,
                        condition: r
                    });

                  case "while":
                    p();
                    return new tn({
                        condition: g(),
                        body: ue(y)
                    });

                  case "for":
                    p();
                    return E();

                  case "function":
                    p();
                    return O(gn);

                  case "if":
                    p();
                    return A();

                  case "let":
                    p();
                    var i = q();
                    _();
                    return i;

                  case "return":
                    if (u.in_function == 0 && !f.bare_returns) o("'return' outside of function");
                    p();
                    var t = null;
                    if (c("punc", ";")) {
                        p();
                    } else if (!m()) {
                        t = fe();
                        _();
                    }
                    return new wn({
                        value: t
                    });

                  case "switch":
                    p();
                    return new Dn({
                        expression: g(),
                        body: ue($)
                    });

                  case "throw":
                    p();
                    if (s(u.token)) o("Illegal newline after 'throw'");
                    var t = fe();
                    _();
                    return new xn({
                        value: t
                    });

                  case "try":
                    p();
                    return M();

                  case "var":
                    p();
                    var i = C();
                    _();
                    return i;

                  case "with":
                    if (u.input.has_directive("use strict")) {
                        o("Strict mode may not include a with statement");
                    }
                    p();
                    return new on({
                        expression: g(),
                        body: y()
                    });
                }
            }
            v();
        });
        function w() {
            var n = J(pe);
            if (!Pe(u.labels, function(e) {
                return e.name != n.name;
            })) {
                o("Label " + n.name + " defined twice");
            }
            h(":");
            u.labels.push(n);
            var e = y();
            u.labels.pop();
            if (!(e instanceof Ze)) {
                n.references.forEach(function(e) {
                    if (e instanceof Sn) {
                        r(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new Qe({
                body: e,
                label: n
            });
        }
        function x() {
            var e = fe();
            _();
            return new We({
                body: e
            });
        }
        function k(e) {
            var n = null, t;
            if (!m()) {
                n = J(de, true);
            }
            if (n != null) {
                t = De(function(e) {
                    return e.name == n.name;
                }, u.labels);
                if (!t) r(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (u.in_loop == 0) o(e.TYPE + " not inside a loop or switch");
            _();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function E() {
            h("(");
            var e = null;
            if (!c("punc", ";")) {
                e = c("keyword", "const") ? (p(), F(true)) : c("keyword", "let") ? (p(), q(true)) : c("keyword", "var") ? (p(), 
                C(true)) : fe(true);
                if (c("operator", "in")) {
                    if (e instanceof Fn) {
                        if (e.definitions.length > 1) {
                            r(e.start, "Only one variable declaration allowed in for..in loop");
                        }
                    } else if (!(ae(e) || (e = oe(e)) instanceof nt)) {
                        r(e.start, "Invalid left-hand side in for..in loop");
                    }
                    p();
                    return S(e);
                }
            }
            return i(e);
        }
        function i(e) {
            h(";");
            var n = c("punc", ";") ? null : fe();
            h(";");
            var t = c("punc", ")") ? null : fe();
            h(")");
            return new rn({
                init: e,
                condition: n,
                step: t,
                body: ue(y)
            });
        }
        function S(e) {
            var n = fe();
            h(")");
            return new an({
                init: e,
                object: n,
                body: ue(y)
            });
        }
        function T(e) {
            if (e instanceof et) return new tt({
                start: e.start,
                elements: e.elements.map(T),
                end: e.end
            });
            if (e instanceof Qn) return new Hn({
                start: e.start,
                name: T(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof Hn) {
                e.name = T(e.name);
                return e;
            }
            if (e instanceof tt) {
                e.elements = e.elements.map(T);
                return e;
            }
            if (e instanceof rt) {
                e.properties.forEach(function(e) {
                    e.value = T(e.value);
                });
                return e;
            }
            if (e instanceof Ot) return e;
            if (e instanceof at) return new rt({
                start: e.start,
                properties: e.properties.map(function(e) {
                    if (!(e instanceof st)) r(e.start, "Invalid destructuring assignment");
                    return new it({
                        start: e.start,
                        key: e.key,
                        value: T(e.value),
                        end: e.end
                    });
                }),
                end: e.end
            });
            if (e instanceof bt) return new ht(e);
            r(e.start, "Invalid arrow parameter");
        }
        function D(e, n) {
            var t = u.in_async;
            u.in_async = false;
            var i = u.in_funarg;
            u.in_funarg = u.in_function;
            var r = e.map(T);
            u.in_funarg = i;
            h("=>");
            var a, o;
            var s = u.in_loop;
            var f = u.labels;
            ++u.in_function;
            u.in_directives = true;
            u.input.push_directives_stack();
            u.in_loop = 0;
            u.labels = [];
            if (c("punc", "{")) {
                a = z();
                o = null;
                if (u.input.has_directive("use strict")) {
                    r.forEach(W);
                }
            } else {
                a = [];
                o = se();
            }
            u.input.pop_directives_stack();
            --u.in_function;
            u.in_loop = s;
            u.labels = f;
            u.in_async = t;
            return new pn({
                start: n,
                argnames: r,
                body: a,
                value: o,
                end: d()
            });
        }
        var O = function(e) {
            var n = u.in_async;
            var t;
            if (e === _n) {
                t = J(mt);
                u.in_async = true;
            } else if (e === gn) {
                t = J(mt);
                u.in_async = false;
            } else {
                u.in_async = e === vn;
                t = J(_t, true);
            }
            if (t && e !== cn && !(t instanceof lt)) v(d());
            h("(");
            var i = u.in_funarg;
            u.in_funarg = u.in_function;
            var r = I(")", !f.strict, false, function() {
                return X(ht);
            });
            u.in_funarg = i;
            var a = u.in_loop;
            var o = u.labels;
            ++u.in_function;
            u.in_directives = true;
            u.input.push_directives_stack();
            u.in_loop = 0;
            u.labels = [];
            var s = z();
            if (u.input.has_directive("use strict")) {
                if (t) W(t);
                r.forEach(W);
            }
            u.input.pop_directives_stack();
            --u.in_function;
            u.in_loop = a;
            u.labels = o;
            u.in_async = n;
            return new e({
                name: t,
                argnames: r,
                body: s
            });
        };
        function A() {
            var e = g(), n = y(), t = null;
            if (c("keyword", "else")) {
                p();
                t = y();
            }
            return new Tn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function z() {
            h("{");
            var e = [];
            while (!c("punc", "}")) {
                if (c("eof")) h("}");
                e.push(y());
            }
            p();
            return e;
        }
        function $() {
            h("{");
            var e = [], n, t, i, r;
            while (!c("punc", "}")) {
                if (c("eof")) h("}");
                if (c("keyword", "case")) {
                    if (n) n.end = d();
                    t = [];
                    n = new zn({
                        start: (r = u.token, p(), r),
                        expression: fe(),
                        body: t
                    });
                    e.push(n);
                    h(":");
                } else if (c("keyword", "default")) {
                    if (n) n.end = d();
                    if (i) o("More than one default clause in switch statement");
                    t = [];
                    n = new An({
                        start: (r = u.token, p(), h(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) v();
                    t.push(y());
                }
            }
            if (n) n.end = d();
            p();
            return e;
        }
        function M() {
            var e = z(), n = null, t = null;
            if (c("keyword", "catch")) {
                var i = u.token;
                p();
                var r = null;
                if (c("punc", "(")) {
                    p();
                    r = G(gt);
                    h(")");
                }
                n = new Mn({
                    start: i,
                    argname: r,
                    body: z(),
                    end: d()
                });
            }
            if (c("keyword", "finally")) {
                var i = u.token;
                p();
                t = new jn({
                    start: i,
                    body: z(),
                    end: d()
                });
            }
            if (!n && !t) o("Missing catch/finally blocks");
            return new $n({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function j(e, n) {
            var t = [];
            for (;;) {
                var i = u.token;
                var r = G(e);
                var a = null;
                if (c("operator", "=")) {
                    p();
                    a = se(n);
                } else if (!n && (e === pt || r instanceof nt)) {
                    o("Missing initializer in declaration");
                }
                t.push(new Pn({
                    start: i,
                    name: r,
                    value: a,
                    end: d()
                }));
                if (!c("punc", ",")) break;
                p();
            }
            return t;
        }
        var F = function(e) {
            return new qn({
                start: d(),
                definitions: j(pt, e),
                end: d()
            });
        };
        var q = function(e) {
            return new Cn({
                start: d(),
                definitions: j(dt, e),
                end: d()
            });
        };
        var C = function(e) {
            return new Nn({
                start: d(),
                definitions: j(vt, e),
                end: d()
            });
        };
        var N = function(e) {
            var n = u.token;
            a("operator", "new");
            var t = H(false), i;
            if (c("punc", "(")) {
                p();
                i = I(")", !f.strict);
            } else {
                i = [];
            }
            var r = new Rn({
                start: n,
                expression: t,
                args: i,
                end: d()
            });
            K(r);
            return Q(r, e);
        };
        function P() {
            var e = u.token, n;
            switch (e.type) {
              case "num":
                n = new kt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new xt({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new Et({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new $t({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new Mt({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new St({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            p();
            return n;
        }
        var H = function(e) {
            if (c("operator", "new")) {
                return N(e);
            }
            var n = u.token;
            if (c("punc")) {
                switch (n.value) {
                  case "(":
                    p();
                    if (c("punc", ")")) {
                        p();
                        return D([], n);
                    }
                    var t = fe(false, true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    h(")");
                    var a = d();
                    a.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, a.comments_after);
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (t instanceof In) K(t);
                    if (c("punc", "=>")) return D(t instanceof Un ? t.expressions : [ t ], n);
                    return Q(t, e);

                  case "[":
                    return Q(R(), e);

                  case "{":
                    return Q(B(), e);
                }
                v();
            }
            var o;
            if (c("name", "async") && me(l(), "keyword", "function")) {
                p();
                o = vn;
            } else if (c("keyword", "function")) {
                o = hn;
            }
            if (o) {
                p();
                var s = O(o);
                s.start = n;
                s.end = d();
                return Q(s, e);
            }
            if (c("name")) {
                var f = V(bt, n);
                p();
                return c("punc", "=>") ? D([ f ], n) : Q(f, e);
            }
            if (ye[u.token.type]) {
                return Q(P(), e);
            }
            v();
        };
        function I(e, n, t, i) {
            if (!i) i = se;
            var r = true, a = [];
            while (!c("punc", e)) {
                if (r) r = false; else h(",");
                if (n && c("punc", e)) break;
                if (t && c("punc", ",")) {
                    a.push(new Ot({
                        start: u.token,
                        end: u.token
                    }));
                } else if (i === se && c("operator", "...")) {
                    a.push(new Vn({
                        start: u.token,
                        expression: (p(), i()),
                        end: d()
                    }));
                } else {
                    a.push(i());
                }
            }
            p();
            return a;
        }
        var R = n(function() {
            h("[");
            return new et({
                elements: I("]", !f.strict, true)
            });
        });
        var U = n(function() {
            return O(cn);
        });
        var B = n(function() {
            h("{");
            var e = true, n = [];
            while (!c("punc", "}")) {
                if (e) e = false; else h(",");
                if (!f.strict && c("punc", "}")) break;
                var t = u.token;
                if (c("operator", "...")) {
                    p();
                    n.push(new Vn({
                        start: t,
                        expression: se(),
                        end: d()
                    }));
                    continue;
                }
                if (me(l(), "operator", "=")) {
                    var i = J(bt);
                    p();
                    n.push(new st({
                        start: t,
                        key: t.value,
                        value: new Qn({
                            start: t,
                            left: i,
                            operator: "=",
                            right: se(),
                            end: d()
                        }),
                        end: d()
                    }));
                    continue;
                }
                if (me(l(), "punc", ",") || me(l(), "punc", "}")) {
                    n.push(new st({
                        start: t,
                        key: t.value,
                        value: J(bt),
                        end: d()
                    }));
                    continue;
                }
                var r = Y();
                if (c("punc", "(")) {
                    var a = u.token;
                    var o = O(hn);
                    o.start = a;
                    o.end = d();
                    n.push(new st({
                        start: t,
                        key: r,
                        value: o,
                        end: d()
                    }));
                    continue;
                }
                if (c("punc", ":")) {
                    p();
                    n.push(new st({
                        start: t,
                        key: r,
                        value: se(),
                        end: d()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    r = Y();
                    var a = u.token;
                    var o = O(vn);
                    o.start = a;
                    o.end = d();
                    n.push(new st({
                        start: t,
                        key: r,
                        value: o,
                        end: d()
                    }));
                    continue;

                  case "get":
                    n.push(new ut({
                        start: t,
                        key: Y(),
                        value: U(),
                        end: d()
                    }));
                    continue;

                  case "set":
                    n.push(new ft({
                        start: t,
                        key: Y(),
                        value: U(),
                        end: d()
                    }));
                    continue;
                }
                v();
            }
            p();
            return new at({
                properties: n
            });
        });
        function Y() {
            var e = u.token;
            switch (e.type) {
              case "operator":
                if (!ve[e.value]) v();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                p();
                return "" + e.value;

              case "punc":
                h("[");
                var n = se();
                h("]");
                return n;

              default:
                v();
            }
        }
        function L() {
            var e = u.token.value;
            a("name");
            return e;
        }
        function V(e, n) {
            var t = n.value;
            if (t === "await" && u.in_async) v(n);
            return new (t === "this" ? yt : e)({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function W(e) {
            if (e.name == "arguments" || e.name == "eval") r(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function J(e, n) {
            if (!c("name")) {
                if (!n) o("Name expected");
                return null;
            }
            var t = V(e, u.token);
            if (u.input.has_directive("use strict") && t instanceof lt) {
                W(t);
            }
            p();
            return t;
        }
        function G(e) {
            var n = u.token;
            if (c("punc", "[")) {
                p();
                return new tt({
                    start: n,
                    elements: I("]", !f.strict, true, function() {
                        return X(e);
                    }),
                    end: d()
                });
            }
            if (c("punc", "{")) {
                p();
                var t = true, i = [];
                while (!c("punc", "}")) {
                    if (t) t = false; else h(",");
                    if (!f.strict && c("punc", "}")) break;
                    var r = u.token;
                    if (c("punc", "[") || me(l(), "punc", ":")) {
                        var a = Y();
                        h(":");
                        i.push(new it({
                            start: r,
                            key: a,
                            value: X(e),
                            end: d()
                        }));
                        continue;
                    }
                    var o = J(e);
                    if (c("operator", "=")) {
                        p();
                        o = new Hn({
                            start: o.start,
                            name: o,
                            value: se(),
                            end: d()
                        });
                    }
                    i.push(new it({
                        start: r,
                        key: r.value,
                        value: o,
                        end: d()
                    }));
                }
                p();
                return new rt({
                    start: n,
                    properties: i,
                    end: d()
                });
            }
            return J(e);
        }
        function X(e) {
            var n = u.token;
            var t = G(e);
            if (!c("operator", "=")) return t;
            p();
            return new Hn({
                start: n,
                name: t,
                value: se(),
                end: d()
            });
        }
        function K(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = Ie(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var Q = function(e, n) {
            var t = e.start;
            if (c("punc", ".")) {
                p();
                return Q(new Yn({
                    start: t,
                    expression: e,
                    property: L(),
                    end: d()
                }), n);
            }
            if (c("punc", "[")) {
                p();
                var i = fe();
                h("]");
                return Q(new Ln({
                    start: t,
                    expression: e,
                    property: i,
                    end: d()
                }), n);
            }
            if (n && c("punc", "(")) {
                p();
                var r = new In({
                    start: t,
                    expression: e,
                    args: I(")", !f.strict),
                    end: d()
                });
                K(r);
                return Q(r, true);
            }
            return e;
        };
        function Z() {
            var e = u.token;
            if (c("operator") && ge[e.value]) {
                p();
                b();
                var n = ee(Jn, e, ne());
                n.start = e;
                n.end = d();
                return n;
            }
            var t = H(true);
            while (c("operator") && Ct[u.token.value] && !s(u.token)) {
                t = ee(Gn, u.token, t);
                t.start = e;
                t.end = u.token;
                p();
            }
            return t;
        }
        function ee(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!ae(t)) r(n, "Invalid use of " + i + " operator");
                break;

              case "delete":
                if (t instanceof bt && u.input.has_directive("use strict")) r(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        function ne() {
            var e = u.token;
            if (!(u.in_async && c("name", "await"))) return Z();
            if (u.in_funarg === u.in_function) o("Invalid use of await in function argument");
            u.input.context().regex_allowed = true;
            p();
            return new Zn({
                start: e,
                expression: ne(),
                end: d()
            });
        }
        var te = function(e, n, t) {
            var i = c("operator") ? u.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Nt[i] : null;
            if (r != null && r > n) {
                p();
                var a = te(ne(), r, t);
                return te(new Xn({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function ie(e) {
            return te(ne(), 0, e);
        }
        var re = function(e) {
            var n = u.token;
            var t = ie(e);
            if (c("operator", "?")) {
                p();
                var i = se();
                h(":");
                return new Kn({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: se(e),
                    end: d()
                });
            }
            return t;
        };
        function ae(e) {
            return e instanceof Bn || e instanceof bt;
        }
        function oe(e) {
            if (e instanceof et) {
                var n = e.elements.map(oe);
                return Pe(n, function(e) {
                    return e instanceof Hn || e instanceof nt || e instanceof Ot || ae(e);
                }) ? new tt({
                    start: e.start,
                    elements: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Qn) {
                var t = oe(e.left);
                return t instanceof nt || ae(t) ? new Hn({
                    start: e.start,
                    name: t,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof at)) return e;
            var i = [];
            for (var r = 0; r < e.properties.length; r++) {
                var a = e.properties[r];
                if (!(a instanceof st)) return e;
                var o = oe(a.value);
                if (!(o instanceof Hn || o instanceof nt || ae(o))) {
                    return e;
                }
                i.push(new it({
                    start: a.start,
                    key: a.key,
                    value: o,
                    end: a.end
                }));
            }
            return new rt({
                start: e.start,
                properties: i,
                end: e.end
            });
        }
        function se(e) {
            var n = u.token;
            var t = re(e), i = u.token.value;
            if (c("operator") && be[i]) {
                if (ae(t) || i == "=" && (t = oe(t)) instanceof nt) {
                    p();
                    return new Qn({
                        start: n,
                        left: t,
                        operator: i,
                        right: se(e),
                        end: d()
                    });
                }
                o("Invalid assignment");
            }
            return t;
        }
        function fe(e, n) {
            var t = u.token;
            var i = [];
            while (true) {
                i.push(se(e));
                if (!c("punc", ",")) break;
                p();
                if (n && c("punc", ")") && me(l(), "punc", "=>")) break;
            }
            return i.length == 1 ? i[0] : new Un({
                start: t,
                expressions: i,
                end: d()
            });
        }
        function ue(e) {
            ++u.in_loop;
            var n = e();
            --u.in_loop;
            return n;
        }
        if (f.expression) {
            b();
            var ce = fe();
            a("eof");
            return ce;
        }
        return function() {
            var e = u.token;
            var n = [];
            u.input.push_directives_stack();
            while (!c("eof")) n.push(y());
            u.input.pop_directives_stack();
            var t = d();
            var i = f.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new fn({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ht(e, n) {
        jt.call(this);
        this.before = e;
        this.after = n;
    }
    Ht.prototype = new jt();
    (function(e) {
        function t(e, n) {
            return je(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(Ue, Oe);
        e(Qe, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(We, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Xe, function(e, n) {
            e.body = t(e.body, n);
        });
        e(nn, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(tn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(rn, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(an, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(on, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(yn, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(kn, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(Tn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Dn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(zn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e($n, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(Mn, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Fn, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Pn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Hn, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(un, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(pn, function(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        });
        e(In, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Un, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(Zn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Yn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Ln, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Vn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Wn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Xn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Kn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(et, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(tt, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(it, function(e, n) {
            if (e.key instanceof Ue) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(rt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(at, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(ot, function(e, n) {
            if (e.key instanceof Ue) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, i) {
        this.eliminated = 0;
        this.global = false;
        this.id = e;
        this.init = i;
        this.lambda = t instanceof _t;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = b(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this.defun;
            if (!e) return;
            var n = this.name;
            var t = e.variables.get(n) || e instanceof fn && e.globals.get(n) || this.orig[0] instanceof pt && De(function(e) {
                return e.name == n;
            }, e.enclosed);
            if (t && t !== this) return t.redefined() || t;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof _t || this.orig[0] instanceof mt);
        }
    };
    var It = Ne("delete ++ --");
    fn.DEFMETHOD("figure_out_scope", function(u) {
        u = le(u, {
            cache: null,
            ie8: false
        });
        var c = this;
        var o = null;
        var t = 0;
        var s = c.parent_scope = null;
        var l = new jt(function(i, e) {
            if (mn(i)) {
                i.name.walk(l);
                r(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(l);
                    });
                    Ge(i, l);
                });
                return true;
            }
            if (i instanceof On) {
                i.init_vars(s);
                e();
                return true;
            }
            if (i instanceof $n) {
                r(function() {
                    Ge(i, l);
                });
                if (i.bcatch) i.bcatch.walk(l);
                if (i.bfinally) i.bfinally.walk(l);
                return true;
            }
            if (i instanceof on) {
                var n = s;
                do {
                    n = n.resolve();
                    if (n.uses_with) break;
                    n.uses_with = true;
                } while (n = n.parent_scope);
                r(e);
                return true;
            }
            if (i instanceof Je) {
                r(e);
                return true;
            }
            if (i instanceof ct) {
                i.scope = s;
            }
            if (i instanceof pe) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof gt) {
                s.def_variable(i).defun = o;
            } else if (i instanceof pt) {
                s.def_variable(i).defun = o;
            } else if (i instanceof mt) {
                o.def_function(i, l.parent());
                a(o, s);
            } else if (i instanceof ht) {
                o.def_variable(i);
                a(o, s);
            } else if (i instanceof _t) {
                var t = o.def_function(i, i.name == "arguments" ? undefined : o);
                if (u.ie8) t.defun = o.parent_scope.resolve();
            } else if (i instanceof dt) {
                s.def_variable(i);
            } else if (i instanceof vt) {
                o.def_variable(i, null);
                a(o, s);
            }
            function r(e) {
                i.init_vars(s);
                var n = o;
                var t = s;
                if (i instanceof sn) o = i;
                s = i;
                e();
                s = t;
                o = n;
            }
            function a(e, n) {
                if (e === n) return;
                i.mark_enclosed(u);
                var t = n.find_variable(i.name);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(u);
            }
        });
        c.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        c.walk(l);
        c.globals = new He();
        var p = [];
        var l = new jt(function(e) {
            if (e instanceof Mn) {
                if (!(e.argname instanceof nt)) return;
                p.push(e);
                e.argname.walk(l);
                p.pop();
                Ge(e, l);
                return true;
            }
            if (e instanceof un) {
                p.push(e);
                e.argnames.forEach(function(e) {
                    e.walk(l);
                });
                p.pop();
                if (e instanceof pn && e.value) {
                    e.value.walk(l);
                } else {
                    Ge(e, l);
                }
                return true;
            }
            if (e instanceof kn) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof gt) {
                var n = e.definition().redefined();
                if (n) for (var t = e.scope; t; t = t.parent_scope) {
                    Fe(t.enclosed, n);
                    if (t === n.scope) break;
                }
                return true;
            }
            if (e instanceof pt) {
                var i = e.definition().redefined();
                if (i) i.const_redefs = true;
                return true;
            }
            if (e instanceof bt) {
                var r = e.name;
                var a = e.scope.find_variable(r);
                for (var o = p.length; o > 0 && a; ) {
                    o = p.lastIndexOf(a.scope, o - 1);
                    if (o < 0) break;
                    var s = a.orig[0];
                    if (s instanceof gt || s instanceof ht || s instanceof _t) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(r);
                }
                if (!a) {
                    a = c.def_global(e);
                } else if (r == "arguments" && d(a)) {
                    var f = l.parent();
                    if (f instanceof Qn && f.left === e || f instanceof Wn && It[f.operator]) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(f instanceof Bn && f.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (r == "eval") {
                    var f = l.parent();
                    if (f.TYPE == "Call" && f.expression === e) {
                        var t = e.scope;
                        do {
                            t = t.resolve();
                            if (t.uses_eval) break;
                            t.uses_eval = true;
                        } while (t = t.parent_scope);
                    } else if (a.undeclared) {
                        c.uses_eval = true;
                    }
                }
                e.thedef = a;
                e.reference(u);
                return true;
            }
            if (e instanceof Pn) {
                if (e.value && e.name.name == "arguments") {
                    var a = e.name.scope.resolve().find_variable("arguments");
                    if (a && d(a)) a.scope.uses_arguments = 3;
                }
                return;
            }
        });
        c.walk(l);
        if (u.ie8) c.walk(new jt(function(e) {
            if (e instanceof gt) {
                var n = e.thedef.defun;
                if (n.name instanceof _t && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof _t) {
                var t = e.thedef;
                i(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function d(e) {
            return e.orig[0] instanceof ht && !(e.orig[1] instanceof ht || e.orig[2] instanceof ht) && !(e.scope instanceof pn);
        }
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!Pe(i.orig, function(e) {
                return !(e instanceof pt || e instanceof dt);
            })) return;
            var r = n.find_variable(t);
            if (r) {
                var a = r.redefined();
                if (a) r = a;
            } else {
                r = c.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = true;
                e.thedef = r;
                e.reference(u);
            });
            if (i.lambda) r.lambda = true;
            if (r.undeclared) c.variables.set(t, r);
        }
    });
    fn.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function d(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new He();
        e.variables = new He();
        if (n) e.make_def = n.make_def;
    }
    function _(e, n) {
        d(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    Je.DEFMETHOD("init_vars", function(e) {
        d(this, e);
    });
    sn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    pn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    un.DEFMETHOD("init_vars", function(e) {
        _(this, e);
        this.uses_arguments = false;
        this.def_variable(new ht({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    ct.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            Fe(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    Fe(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    ct.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Je.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Je.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || mn(t.init)) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Je.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (ln(t.init)) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function g(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function b(e, i) {
        var n = e.scope;
        var t = g(n, i);
        var r = n.cname_holes;
        var a = Object.create(null);
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (o.indexOf(n) < 0) {
                    for (var t in g(n, i)) {
                        a[t] = true;
                    }
                    o.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = w(r[f]);
            if (a[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = w(++n.cname);
            if (t[s] || D[s] || i.reserved.has[s]) continue;
            if (!a[s]) break;
            r.push(n.cname);
        }
        t[s] = true;
        return s;
    }
    ct.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    pe.DEFMETHOD("unmangleable", Ae);
    ct.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function y(e) {
        e = le(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Fe(e.reserved, "arguments");
        e.reserved.has = Ne(e.reserved);
        return e;
    }
    fn.DEFMETHOD("mangle_names", function(a) {
        a = y(a);
        var o = -1;
        if (a.cache && a.cache.props) {
            var n = g(this, a);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var s = [];
        var f = new jt(function(n, e) {
            if (n instanceof Qe) {
                var t = o;
                e();
                if (!a.v8 || !l(f)) o = t;
                return true;
            }
            if (n instanceof Je) {
                if (a.webkit && n instanceof Ze && n.init instanceof Cn) {
                    n.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof dt)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                n.to_mangle = [];
                n.variables.each(function(e) {
                    if (!c(e)) n.to_mangle.push(e);
                });
                e();
                if (a.cache && n instanceof fn) {
                    n.globals.each(u);
                }
                if (n instanceof gn && f.has_directive("use asm")) {
                    var i = new bt(n.name);
                    i.scope = n;
                    i.reference(a);
                }
                n.to_mangle.forEach(u);
                return true;
            }
            if (n instanceof pe) {
                var r;
                do {
                    r = w(++o);
                } while (D[r]);
                n.mangled_name = r;
                return true;
            }
        });
        this.walk(f);
        s.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function c(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof pt)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            s.push(n);
            n.references.forEach(r);
            if (e instanceof gt || e instanceof pt) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
        function l(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof Xe) return t instanceof fn && !a.toplevel;
                if (t instanceof Qe) return true;
            }
        }
    });
    fn.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(D);
        t.reserved.forEach(r);
        this.globals.each(a);
        this.walk(new jt(function(e) {
            if (e instanceof Je) e.variables.each(a);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    fn.DEFMETHOD("expand_names", function(i) {
        w.reset();
        w.sort();
        i = y(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(a);
        this.walk(new jt(function(e) {
            if (e instanceof Je) e.variables.each(a);
        }));
        function r() {
            var e;
            do {
                e = w(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    Ue.DEFMETHOD("tail_node", $e);
    Un.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    fn.DEFMETHOD("compute_char_frequency", function(e) {
        e = y(e);
        w.reset();
        var n = ct.prototype.add_source_map;
        try {
            ct.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) w.consider(this.name, -1);
            };
            if (e.properties) {
                Yn.prototype.add_source_map = function() {
                    w.consider(this.property, -1);
                };
                Ln.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            w.consider(this.print_to_string(), 1);
        } finally {
            ct.prototype.add_source_map = n;
            delete Yn.prototype.add_source_map;
            delete Ln.prototype.add_source_map;
        }
        w.sort();
        function t(e) {
            if (e instanceof xt) {
                w.consider(e.value, -1);
            } else if (e instanceof Kn) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Un) {
                t(e.tail_node());
            }
        }
    });
    var w = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, a;
        function o() {
            a = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = o;
        o();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function te(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function Rt(f) {
        var e = !f;
        f = le(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = Ae;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = te;
            } else {
                u = ze;
            }
        }
        var r = f.indent_start;
        var a = 0;
        var o = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (Z(r)) {
                    if (ee(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ee(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function a() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return a();

              case 3:
                return e == "'" ? n() : a();

              default:
                return i > r ? n() : a();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        var v = false;
        var h = 0;
        var m = true;
        var _ = false;
        var g = false;
        var b = false;
        var y = false;
        var w = -1;
        var x = "";
        var k, E, S = f.source_map && [];
        var T = S ? function(n, t) {
            S.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Oe;
        var D = S ? function() {
            S.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            S = [];
        } : Oe;
        function O(e) {
            var n = s.lastIndexOf("\n");
            if (h < n) h = n;
            var t = s.slice(0, h);
            var i = s.slice(h);
            T(e, i.length - a);
            o += e;
            c += e;
            a = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var A = f.max_line_len ? function() {
            if (m) {
                if (a > f.max_line_len) {
                    Ue.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (a > f.max_line_len) O(1);
            m = true;
            D();
        } : Oe;
        var z = Ne("( [ + * / - , .");
        function $(e) {
            e = String(e);
            var n = e.charAt(0);
            if (b && n) {
                b = false;
                if (n != "\n") {
                    $("\n");
                    j();
                }
            }
            if (y && n) {
                y = false;
                if (!/[\s;})]/.test(n)) {
                    M();
                }
            }
            w = -1;
            var t = x.slice(-1);
            if (g) {
                g = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        s += ";";
                        a++;
                        c++;
                    } else {
                        A();
                        s += "\n";
                        c++;
                        o++;
                        a = 0;
                        if (/^\s+$/.test(e)) {
                            g = true;
                        }
                    }
                    if (!f.beautify) _ = false;
                }
            }
            if (_) {
                if (ne(t) && (ne(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == x || e == "--" && x == "!" || e == "in" && t == "/" || x == "--" && n == ">") {
                    s += " ";
                    a++;
                    c++;
                }
                if (t != "<" || e != "!") _ = false;
            }
            if (k) {
                S.push({
                    token: k,
                    name: E,
                    line: o,
                    col: a
                });
                k = false;
                if (m) D();
            }
            s += e;
            v = e.slice(-1) == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            o += r;
            a += i[0].length;
            if (r > 0) {
                A();
                a = i[r].length;
            }
            x = e;
        }
        var M = f.beautify ? function() {
            $(" ");
        } : function() {
            _ = true;
        };
        var j = f.beautify ? function(e) {
            $(K(" ", e ? r - (f.indent_level >> 1) : r));
        } : Oe;
        var F = f.beautify ? function(e, n) {
            if (e === true) e = H();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var q = f.max_line_len || f.preserve_line ? function() {
            A();
            h = s.length;
            m = false;
        } : Oe;
        var C = f.beautify ? function() {
            if (w < 0) return $("\n");
            if (s[w] != "\n") {
                s = s.slice(0, w) + "\n" + s.slice(w);
                c++;
                o++;
            }
            w++;
        } : q;
        var N = f.beautify ? function() {
            $(";");
        } : function() {
            g = true;
        };
        function P() {
            if (g) $(";");
            $(";");
        }
        function H() {
            return r + f.indent_level;
        }
        function I(e) {
            var n;
            $("{");
            C();
            F(H(), function() {
                n = e();
            });
            j();
            $("}");
            return n;
        }
        function R(e) {
            $("(");
            q();
            var n = e();
            q();
            $(")");
            return n;
        }
        function U(e) {
            $("[");
            q();
            var n = e();
            q();
            $("]");
            return n;
        }
        function B() {
            q();
            $(",");
            q();
            M();
        }
        function Y() {
            $(":");
            M();
        }
        var L = S ? function(e, n) {
            k = e;
            E = n;
        } : Oe;
        function V() {
            if (!m) A();
            return s;
        }
        function W() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function J(e) {
            var i = this;
            var r = e instanceof yn && e.value;
            var a = s(e);
            if (!a) a = [];
            if (r) {
                var o = new jt(function(e) {
                    var n = o.parent();
                    if (n instanceof yn || n instanceof Xn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof Kn && n.condition === e || n instanceof Yn && n.expression === e || n instanceof Un && n.expressions[0] === e || n instanceof Ln && n.expression === e || n instanceof Gn) {
                        var t = s(e);
                        if (t) a = a.concat(t);
                    } else {
                        return true;
                    }
                });
                o.push(e);
                e.value.walk(o);
            }
            if (c == 0) {
                if (a.length > 0 && f.shebang && a[0].type == "comment5") {
                    $("#!" + a.shift().value + "\n");
                    j();
                }
                var n = f.preamble;
                if (n) {
                    $(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            a = a.filter(u, e);
            if (a.length == 0) return;
            var t = W();
            a.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        $("\n");
                        j();
                        t = true;
                    } else if (n > 0) {
                        M();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    j();
                    t = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    $("\n");
                    j();
                } else {
                    M();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Q();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function G(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof Be || Pe(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var a = s.length;
            r.filter(u, e).forEach(function(e, n) {
                y = false;
                if (b) {
                    $("\n");
                    j();
                    b = false;
                } else if (e.nlb && (n > 0 || !W())) {
                    $("\n");
                    j();
                } else if (n > 0 || !t) {
                    M();
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    b = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    y = true;
                }
            });
            if (s.length > a) w = a;
        }
        var X = [];
        return {
            get: V,
            toString: V,
            indent: j,
            should_break: e ? Oe : function() {
                return f.width && a - r >= f.width;
            },
            has_parens: function() {
                return v;
            },
            newline: C,
            print: $,
            space: M,
            comma: B,
            colon: Y,
            last: function() {
                return x;
            },
            semicolon: N,
            force_semicolon: P,
            to_utf8: l,
            print_name: function(e) {
                $(d(e));
            },
            print_string: function(e, n) {
                $(p(e, n));
            },
            next_indent: H,
            with_indent: F,
            with_block: I,
            with_parens: R,
            with_square: U,
            add_mapping: L,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? Oe : J,
            append_comments: e || u === Ae ? Oe : G,
            line: function() {
                return o;
            },
            col: function() {
                return a;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                X.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = X.pop();
                if (e.start && e.start.line > o) {
                    O(e.start.line - o);
                }
            } : function() {
                X.pop();
            },
            parent: function(e) {
                return X[X.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        Ue.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        Ue.DEFMETHOD("print_to_string", function(e) {
            var n = Rt(e);
            this.print(n);
            return n.get();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(Ue, Ae);
        function t(e) {
            if (!e.has_parens() && Re(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof Bn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof In && n.expression === this) return true;
            }
        }
        n(vn, t);
        n(hn, t);
        function i(e) {
            return !e.has_parens() && Re(e, true);
        }
        n(at, i);
        n(Wn, function(e) {
            var n = e.parent();
            return (n instanceof In || n instanceof Bn) && n.expression === this;
        });
        n(Un, function(e) {
            var n = e.parent();
            return n instanceof et || n instanceof pn && n.value === this || n instanceof Zn || n instanceof Xn || n instanceof In || n instanceof Kn || n instanceof Hn || n instanceof it || n instanceof ot || n instanceof Bn && n.expression === this || n instanceof Vn || n instanceof Wn || n instanceof Pn;
        });
        n(Xn, function(e) {
            var n = e.parent();
            if (n instanceof Zn) return true;
            if (n instanceof Xn) {
                var t = n.operator, i = Nt[t];
                var r = this.operator, a = Nt[r];
                return i > a || i == a && this === n.right;
            }
            if (n instanceof In) return n.expression === this;
            if (n instanceof Bn) return n.expression === this;
            if (n instanceof Wn) return true;
        });
        n(Bn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Rn && t.expression === n) {
                do {
                    n = n.expression;
                } while (n instanceof Bn);
                return n.TYPE == "Call";
            }
        });
        n(In, function(e) {
            var n = e.parent();
            if (n instanceof Rn) return n.expression === this;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof hn && n instanceof Bn && n.expression === this && t instanceof Qn && t.left === n;
            }
        });
        n(Rn, function(e) {
            if (w(this, e)) return false;
            var n = e.parent();
            if (n instanceof In) return n.expression === this;
            return n instanceof Bn;
        });
        n(kt, function(e) {
            var n = e.parent();
            if (n instanceof Bn && n.expression === this) {
                var t = this.value;
                return t < 0 || e.option("galio") && /^0/.test(k(t));
            }
        });
        function r(e, n) {
            var t = n.parent();
            if (t instanceof Zn) return true;
            if (t instanceof Xn) return !(t instanceof Qn);
            if (t instanceof In) return t.expression === e;
            if (t instanceof Kn) return t.condition === e;
            if (t instanceof Bn) return t.expression === e;
            if (t instanceof Wn) return true;
        }
        n(pn, function(e) {
            return r(this, e);
        });
        n(Qn, function(e) {
            if (r(this, e)) return true;
            if (e.option("v8")) return this.left instanceof nt;
            if (this.left instanceof rt) return i(e);
        });
        n(Kn, function(e) {
            return r(this, e);
        });
        n(Zn, function(e) {
            var n = e.parent();
            if (n instanceof In) return n.expression === this;
            if (n instanceof Bn) return n.expression === this;
        });
        e(Le, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Ye, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function a(e, t, i, n) {
            var r = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof Le) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof Ve)) {
                        if (e instanceof We && e.body instanceof xt) {
                            i.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof Ve) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = o;
        }
        e(Be, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        e(fn, function(e) {
            a(this.body, true, e, true);
            e.print("");
        });
        e(Qe, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(We, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function o(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function f(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    a(e.body, false, n, t);
                });
            } else o(e, n);
        }
        e(Ke, function(e) {
            f(this, e);
        });
        e(Ve, function(e) {
            e.semicolon();
        });
        e(nn, function(e) {
            var n = this;
            e.print("do");
            e.space();
            E(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(tn, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            y(n.body, e);
        });
        e(rn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof Fn) {
                        n.init.print(e);
                    } else {
                        h(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            e.space();
            y(n.body, e);
        });
        e(an, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                n.init.print(e);
                e.space();
                e.print("in");
                e.space();
                n.object.print(e);
            });
            e.space();
            y(n.body, e);
        });
        e(on, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            e.space();
            y(n.body, e);
        });
        e(pn, function(t) {
            var e = this;
            if (e.argnames.length == 1 && e.argnames[0] instanceof ht) {
                e.argnames[0].print(t);
            } else t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            t.print("=>");
            t.space();
            if (e.value) {
                e.value.print(t);
            } else {
                f(e, t, true);
            }
        });
        function u(e, t) {
            if (e.name) {
                t.space();
                e.name.print(t);
            }
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            f(e, t, true);
        }
        e(un, function(e) {
            e.print("function");
            u(this, e);
        });
        function c(e) {
            e.print("async");
            e.space();
            e.print("function");
            u(this, e);
        }
        e(_n, c);
        e(vn, c);
        function l(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(wn, l("return", "value"));
        e(xn, l("throw", "value"));
        e(En, l("break", "label"));
        e(Sn, l("continue", "label"));
        function p(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof qn || t instanceof Cn) || n.option("ie8") && t instanceof nn) return E(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof Tn) {
                    if (!t.alternative) {
                        E(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof T) {
                    t = t.body;
                } else break;
            }
            y(e.body, n);
        }
        e(Tn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            if (n.alternative) {
                p(n, e);
                e.space();
                e.print("else");
                e.space();
                if (n.alternative instanceof Tn) n.alternative.print(e); else y(n.alternative, e);
            } else {
                y(n.body, e);
            }
        });
        e(Dn, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) o(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function d(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(An, function(e) {
            e.print("default:");
            d(this, e);
        });
        e(zn, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            d(n, e);
        });
        e($n, function(e) {
            var n = this;
            e.print("try");
            e.space();
            f(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(Mn, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            f(n, e);
        });
        e(jn, function(e) {
            e.print("finally");
            e.space();
            f(this, e);
        });
        function v(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (n && n.init !== e || !(n instanceof rn || n instanceof an)) t.semicolon();
            };
        }
        e(qn, v("const"));
        e(Cn, v("let"));
        e(Nn, v("var"));
        function h(e, n, t) {
            var i = false;
            if (t) e.walk(new jt(function(e) {
                if (i) return true;
                if (e instanceof Xn && e.operator == "in") return i = true;
                if (e instanceof sn && !(e instanceof pn && e.value)) return true;
            }));
            e.print(n, i);
        }
        e(Pn, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof rn || t instanceof an;
                h(n.value, e, i);
            }
        });
        e(Hn, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function m(e, t) {
            if (e.expression instanceof In || e.expression instanceof un) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(In, function(e) {
            this.expression.print(e);
            m(this, e);
        });
        e(Rn, function(e) {
            var n = this;
            e.print("new");
            e.space();
            n.expression.print(e);
            if (w(n, e)) m(n, e);
        });
        e(Un, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Yn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie8") && D[i]) {
                e.print("[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof kt && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(e.last())) {
                        e.print(".");
                    }
                }
                e.print(".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(Ln, function(e) {
            this.expression.print(e);
            e.print("[");
            this.property.print(e);
            e.print("]");
        });
        e(Vn, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(Jn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof Jn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(Gn, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(Xn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Kn, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Zn, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(et, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof Ot) t.comma();
                });
                t.space();
            } : Oe);
        });
        e(tt, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof Ot) t.comma();
                });
                t.space();
            } : Oe);
        });
        e(it, g);
        e(rt, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        e(at, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        function _(e, n) {
            var t = e.key;
            if (t instanceof Ue) {
                n.with_square(function() {
                    t.print(n);
                });
            } else if (n.option("quote_keys")) {
                n.print_string(t);
            } else if ("" + +t == t && t >= 0) {
                n.print(k(t));
            } else {
                var i = e.start && e.start.quote;
                if (D[t] ? !n.option("ie8") : Ft(t)) {
                    if (i && n.option("keep_quoted_props")) {
                        n.print_string(t, i);
                    } else {
                        n.print_name(t);
                    }
                } else {
                    n.print_string(t, i);
                }
            }
        }
        function g(e) {
            var n = this;
            _(n, e);
            e.colon();
            n.value.print(e);
        }
        e(st, g);
        function b(t) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                _(n, e);
                u(n.value, e);
            };
        }
        e(ut, b("get"));
        e(ft, b("set"));
        e(ct, function(e) {
            var n = this.definition();
            e.print_name(n && n.mangled_name || this.name);
        });
        e(Ot, Oe);
        e(yt, function(e) {
            e.print("this");
        });
        e(wt, function(e) {
            e.print(this.value);
        });
        e(xt, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(kt, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(k(this.value));
            }
        });
        e(Et, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof Xn && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function y(e, n) {
            if (n.option("braces") && !(e instanceof qn || e instanceof Cn)) {
                E(e, n);
            } else if (!e || e instanceof Ve) {
                n.force_semicolon();
            } else {
                e.print(n);
            }
        }
        function w(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function x(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function k(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, a;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                a = n.slice(r);
                t.push(a + "e-" + (a.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return x(t);
        }
        function E(e, n) {
            if (!e || e instanceof Ve) n.print("{}"); else if (e instanceof Ke) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function S(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        S([ Ue, Qe ], Oe);
        S([ et, Ke, Mn, wt, Ye, Fn, nt, jn, bn, un, Rn, at, T, ct, Dn, On, $n ], function(e) {
            e.add_mapping(this.start);
        });
        S([ it, ot ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ut(e, n) {
        if (!(this instanceof Ut)) return new Ut(e, n);
        Ht.call(this, this.before, this.after);
        this.options = le(e, {
            arguments: !n,
            arrows: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            spread: !n,
            strings: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && Ie(i, r)) {
                i[r.slice(1)] = Pt(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        this.drop_fargs = this.options["keep_fargs"] ? Ae : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !Te(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = ze;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return Te(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    Ut.prototype = new Ht();
    t(Ut.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof fn)) return false;
            var n = this.toplevel;
            return !Pe(e.orig, function(e) {
                return n[e instanceof mt ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var a = 0; a < n; a++) {
                e.figure_out_scope(r);
                if (a > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var o = 0;
                    e.walk(new jt(function() {
                        o++;
                    }));
                    Ue.info("pass {pass}: last_count: {min_count}, count: {count}", {
                        pass: a,
                        min_count: t,
                        count: o
                    });
                    if (o < t) {
                        t = o;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof sn;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(Ue, function(e, n) {
            return e;
        });
        Ue.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        sn.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var a = new Ht(function(e) {
                if (t && e instanceof We) {
                    return _e(wn, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof wn) {
                    return i ? i(e) : _e(We, e, {
                        body: e.value || _e(Jn, e, {
                            operator: "void",
                            expression: _e(kt, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof un && e !== r) {
                    return e;
                }
                if (e instanceof Xe) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(a);
                    }
                } else if (e instanceof Tn) {
                    e.body = e.body.transform(a);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(a);
                    }
                } else if (e instanceof on) {
                    e.body = e.body.transform(a);
                }
                return e;
            });
            r.transform(a);
        });
        function T(e, n) {
            var t = n.getProperty();
            if (t instanceof Ue) return;
            var i;
            if (e instanceof et) {
                var r = e.elements;
                if (t == "length") return O(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof un) {
                if (t == "length") {
                    e.length_read = true;
                    return O(e.argnames.length, e);
                }
            } else if (e instanceof at) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!(s instanceof st)) return;
                    if (!i && a[o].key === t) i = a[o].value;
                }
            }
            return i instanceof bt && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof zt) return g.Boolean[n];
            if (e instanceof kt) return g.Number[n];
            if (e instanceof xt) return g.String[n];
            if (n == "valueOf") return false;
            if (e instanceof et) return g.Array[n];
            if (e instanceof un) return g.Function[n];
            if (e instanceof at) return g.Object[n];
            if (e instanceof Et) return g.RegExp[n] && !e.value.global;
        }
        function de(e, n, t, i, r, a, o) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof Yn && l(i, s.property)) {
                return;
            }
            var f = ke(t, s);
            if (f) return f;
            if (s instanceof et) return de(e, n, s, s, r + 1);
            if (s instanceof In) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!ln(i) || !(s instanceof Rn) && i.contains_this());
            }
            if (s instanceof an) return s.init === t;
            if (s instanceof st) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return de(e, n, u, u, r + 2);
            }
            if (s instanceof Bn) {
                if (s.expression !== t) return;
                var c = T(i, s);
                return (!a || o) && de(e, n, s, c, r + 1);
            }
        }
        function ve(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function D(e) {
            return e.orig[0] instanceof ht || e.orig[1] instanceof ht;
        }
        function V(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof sn) return true;
            } while (n = n.parent_scope);
        }
        function he(e, n) {
            var t = e.definition();
            if (e.in_arg && D(t)) return false;
            return Pe(t.orig, function(e) {
                return !(e instanceof pt || e instanceof dt || n && e instanceof _t);
            });
        }
        (function(e) {
            e(Ue, Oe);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(ln(t.init) && t.init !== t.scope) && t.init;
                if (mn(t.fixed) && !Pe(t.references, function(e) {
                    var n = e.scope.resolve();
                    do {
                        if (t.scope === n) return true;
                    } while (ln(n) && (n = n.parent_scope.resolve()));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function u(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        v(n, e);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        v(n, e);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Oe;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (mn(e.init) && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (e.uses_arguments) e.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function c(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!m(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function l(n, e) {
                e.functions.each(function(e) {
                    if (mn(e.init) && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function p(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function d(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function v(e, n) {
                e.safe_ids[n.id] = {};
            }
            function h(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function m(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!Ie(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (ve(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = _e(Dt, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return mn(n.fixed);
            }
            function _(e, n, t) {
                if (!(t || Pe(n.orig, function(e) {
                    return !(e instanceof pt);
                }))) return false;
                if (n.fixed === undefined) return t || Pe(n.orig, function(e) {
                    return !(e instanceof dt);
                });
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (!Ie(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read && n.scope !== e.find_parent(sn)) return false;
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return m(e, n) && Pe(n.orig, function(e) {
                    return !(e instanceof _t);
                });
            }
            function g(e, n) {
                var t = _e(bt, e, e);
                t.fixed = n || _e(Dt, e);
                return t;
            }
            function b(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(D(n) && n.scope.uses_arguments);
            }
            function y(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof un || e instanceof yt;
            }
            function w(e, n, t) {
                if (t instanceof Qn) return t.operator == "=" && t.right === n;
                if (t instanceof In) return t.expression !== n || t instanceof Rn;
                if (t instanceof yn) return t.value === n && n.scope !== e.scope;
                if (t instanceof Pn) return t.value === n;
            }
            function x(e, n) {
                if (n instanceof et) return true;
                if (n instanceof Xn) return xe[n.operator];
                if (n instanceof Kn) return n.condition !== e;
                if (n instanceof Un) return n.tail_node() === e;
            }
            function k(e, n, t, i, r, a, o) {
                var s = e.parent(a);
                if (r && r.is_constant()) return;
                if (w(n, i, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(r && r.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    return;
                } else if (x(i, s)) {
                    k(e, n, t, s, s, a + 1, o);
                } else if (s instanceof st && s.value === i) {
                    var f = e.parent(a + 1);
                    k(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Bn && s.expression === i) {
                    r = T(r, s);
                    k(e, n, t, s, r, a + 1, o + 1);
                    if (r) return;
                }
                if (a > 0) return;
                if (s instanceof In && s.expression === i) return;
                if (s instanceof Un && s.tail_node() !== i) return;
                if (s instanceof We) return;
                if (s instanceof Wn && !It[s.operator]) return;
                n.direct_access = true;
            }
            function E(e) {
                if (!(e instanceof Ln)) return;
                var n = e.expression;
                if (!(n instanceof bt)) return;
                var t = n.definition();
                if (!ve(t)) return;
                var i = e.property;
                if (i.is_constant()) i = i.value;
                if (!(i instanceof Ue) && !/^[1-9]*[0-9]$/.test(i)) return;
                t.reassigned = true;
                (i instanceof Ue ? t.scope.argnames : [ t.scope.argnames[i] ]).forEach(function(e) {
                    if (e instanceof ht) e.definition().fixed = false;
                });
            }
            function S(a, e, o, n) {
                var s = new jt(function(i) {
                    if (i instanceof Hn) {
                        f(i);
                        p(a);
                        i.value.walk(a);
                        d(a);
                        var r = o;
                        o = function() {
                            var e = r();
                            return we(e) ? X(i, [ e, i.value ]) : i.name;
                        };
                        i.name.walk(s);
                        o = r;
                        return true;
                    }
                    if (i instanceof tt) {
                        f(i);
                        var r = o;
                        i.elements.forEach(function(e, n) {
                            if (e instanceof Ot) return f(e);
                            o = function() {
                                return _e(Ln, e, {
                                    expression: r(),
                                    property: _e(kt, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(s);
                        });
                        o = r;
                        return true;
                    }
                    if (i instanceof rt) {
                        f(i);
                        var r = o;
                        i.properties.forEach(function(t) {
                            f(t);
                            if (t.key instanceof Ue) {
                                p(a);
                                t.key.walk(a);
                                d(a);
                            }
                            o = function() {
                                var e = t.key;
                                var n = Ln;
                                if (typeof e == "string") {
                                    if (Ft(e)) {
                                        n = Yn;
                                    } else {
                                        e = O(e, t);
                                    }
                                }
                                return _e(n, t, {
                                    expression: r(),
                                    property: e
                                });
                            };
                            t.value.walk(s);
                        });
                        o = r;
                        return true;
                    }
                    n(i, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        i.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                e.walk(s);
            }
            function n(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                p(e);
                u(e, t, this);
                n();
                d(e);
                l(e, this);
                return true;
            }
            function o(o, e, n) {
                var t = this;
                t.inlined = false;
                var s = o.parent();
                var i = t instanceof vn;
                var r = false;
                t.walk(new jt(function(e) {
                    if (i) return r = true;
                    if (e instanceof wn) return i = true;
                    if (e instanceof sn && e !== t) return true;
                }));
                if (r) p(o);
                u(o, n, t);
                var f = !t.uses_arguments || o.has_directive("use strict");
                t.argnames.forEach(function(r, a) {
                    var n = s.args[a];
                    S(o, r, function() {
                        var e = t.argnames.indexOf(r);
                        return (e < 0 ? n : s.args[e]) || _e(Dt, s);
                    }, function(e, n) {
                        var t = e.definition();
                        if (f && t.fixed === undefined) {
                            v(o, t);
                            o.loop_ids[t.id] = o.in_loop;
                            var i = s.args[a];
                            t.fixed = n;
                            t.fixed.assigns = [ r ];
                        } else {
                            t.fixed = false;
                        }
                    });
                });
                if (t instanceof pn && t.value) {
                    t.value.walk(o);
                } else {
                    Ge(t, o);
                }
                var a = o.safe_ids;
                d(o);
                l(o, t);
                if (!r) o.safe_ids = a;
                return true;
            }
            e(Qn, function(r, e, a) {
                var o = this;
                var s = o.left;
                if (o.operator == "=" && s.equivalent_to(o.right) && !s.has_side_effects(a)) {
                    o.right.walk(r);
                    f(s);
                    o.__drop = true;
                } else if (!(s instanceof nt || s instanceof bt)) {
                    E(s);
                    return;
                } else if (o.operator == "=") {
                    o.right.walk(r);
                    S(r, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof bt)) {
                            E(e);
                            t();
                            return;
                        }
                        var i = e.definition();
                        i.assignments++;
                        if (!de(a, r, o, o.right, 0) && _(r, i)) {
                            h(i, e);
                            v(r, i);
                            if (i.single_use && s instanceof nt) i.single_use = false;
                            r.loop_ids[i.id] = r.in_loop;
                            k(r, i, e.scope, o, o.right, 0, 1);
                            e.fixed = i.fixed = n;
                            e.fixed.assigns = [ o ];
                        } else {
                            t();
                            i.fixed = false;
                        }
                    });
                } else {
                    var n = s.definition();
                    n.assignments++;
                    var t = n.fixed;
                    if (de(a, r, o, o, 0)) {
                        n.fixed = false;
                        return;
                    }
                    var i = m(r, n);
                    o.right.walk(r);
                    if (i && _(r, n)) {
                        h(n, s);
                        v(r, n);
                        if (n.single_use) n.single_use = false;
                        s.fixed = n.fixed = function() {
                            return _e(Xn, o, {
                                operator: o.operator.slice(0, -1),
                                left: g(s, t),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !t || !t.assigns ? [] : t.assigns.slice();
                        s.fixed.assigns.push(o);
                    } else {
                        s.walk(r);
                        n.fixed = false;
                    }
                }
                return true;
                function f(e) {
                    if (e instanceof Yn) {
                        f(e.expression);
                    } else if (e instanceof Ln) {
                        f(e.expression);
                        e.property.walk(r);
                    } else if (e instanceof bt) {
                        var n = e.definition();
                        h(n, e);
                        e.fixed = n.fixed;
                    } else {
                        e.walk(r);
                    }
                }
            });
            e(_n, n);
            e(Xn, function(e) {
                if (!xe[this.operator]) return;
                this.left.walk(e);
                p(e);
                this.right.walk(e);
                d(e);
                return true;
            });
            e(Je, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
            });
            e(In, function(n, e) {
                n.find_parent(sn).may_call_this();
                var t = this.expression;
                if (ln(t)) {
                    var i = !t.name;
                    this.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Vn) i = false;
                    });
                    if (i) t.reduce_vars = o;
                    t.walk(n);
                    if (i) delete t.reduce_vars;
                    return true;
                } else if (t instanceof bt) {
                    var r = t.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) r.bool_fn++;
                    if (!mn(r.fixed)) return;
                    var a = c(n, r);
                    if (!a) return;
                    e();
                    a.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof Qn && t.operator == "=" && t.left instanceof bt && n.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(Kn, function(e) {
                this.condition.walk(e);
                p(e);
                this.consequent.walk(e);
                d(e);
                p(e);
                this.alternative.walk(e);
                d(e);
                return true;
            });
            e(Hn, function(e) {
                this.name.walk(e);
                p(e);
                this.value.walk(e);
                d(e);
                return true;
            });
            e(gn, n);
            e(nn, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                p(e);
                this.body.walk(e);
                if (F(this, e.parent())) {
                    d(e);
                    p(e);
                }
                this.condition.walk(e);
                d(e);
                e.in_loop = n;
                return true;
            });
            e(rn, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                if (this.init) this.init.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                if (this.condition) this.condition.walk(n);
                this.body.walk(n);
                if (this.step) {
                    if (F(this, n.parent())) {
                        d(n);
                        p(n);
                    }
                    this.step.walk(n);
                }
                d(n);
                n.in_loop = i;
                return true;
            });
            e(an, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                this.object.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                var r = this.init;
                if (r instanceof Fn) {
                    r.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof lt) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, n);
                } else if (r instanceof nt || r instanceof bt) {
                    r.mark_symbol(function(e) {
                        if (e instanceof bt) {
                            var n = e.definition();
                            h(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, n);
                } else {
                    r.walk(n);
                }
                this.body.walk(n);
                d(n);
                n.in_loop = i;
                return true;
            });
            e(Tn, function(e) {
                this.condition.walk(e);
                p(e);
                this.body.walk(e);
                d(e);
                if (this.alternative) {
                    p(e);
                    this.alternative.walk(e);
                    d(e);
                }
                return true;
            });
            e(Qe, function(e) {
                p(e);
                this.body.walk(e);
                d(e);
                return true;
            });
            e(un, function(e, n, t) {
                var i = this;
                i.inlined = false;
                p(e);
                u(e, t, i);
                n();
                d(e);
                if (i.name) k(e, i.name.definition(), i, i.name, i, 0, 1);
                l(e, i);
                return true;
            });
            e(Dn, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                this.expression.walk(n);
                var i = true;
                this.body.forEach(function(e) {
                    if (e instanceof An) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        p(n);
                    }
                });
                if (!i) d(n);
                Ge(this, n);
                return true;
            });
            e(On, function(e) {
                p(e);
                Ge(this, e);
                d(e);
                return true;
            });
            e(gt, function() {
                this.definition().fixed = false;
            });
            e(bt, function(e, n, t) {
                var i = this.definition();
                h(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof mt) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                if (i.fixed === false) {
                    var r = i.redefined();
                    if (r && V(i.scope, this.scope)) r.single_use = false;
                } else if (i.fixed === undefined || !m(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof _t) this.fixed = i.scope;
                    var a = this.fixed_value();
                    var o = Se(e, i);
                    if (o) {
                        i.recursive_refs++;
                    } else if (a && b(t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = a instanceof un && !a.pinned() && (!i.in_loop || e.parent() instanceof In) || !i.in_loop && i.scope === this.scope.resolve() && a.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (de(t, e, this, a, 0, y(a), o)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    k(e, i, this.scope, this, a, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (mn(i.fixed) && !((s = e.parent()) instanceof In && s.expression === this)) {
                    var f = c(e, i);
                    if (f) f.walk(e);
                }
            });
            e(fn, function(n, e, t) {
                this.globals.each(function(e) {
                    a(n, t, e);
                });
                p(n);
                u(n, t, this);
                e();
                d(n);
                l(n, this);
                return true;
            });
            e($n, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                p(n);
                Ge(this, n);
                d(n);
                if (this.bcatch) {
                    p(n);
                    this.bcatch.walk(n);
                    d(n);
                }
                if (this.bfinally) this.bfinally.walk(n);
                return true;
            });
            e(Wn, function(e, n) {
                var t = this;
                if (!Ct[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof bt)) {
                    E(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var a = r.fixed;
                if (m(e, r) && _(e, r)) {
                    h(r, i);
                    v(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return _e(Xn, t, {
                            operator: t.operator.slice(0, -1),
                            left: _e(Jn, t, {
                                operator: "+",
                                expression: g(i, a)
                            }),
                            right: _e(kt, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof Jn) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return _e(Jn, t, {
                                operator: "+",
                                expression: g(i, a)
                            });
                        };
                        i.fixed.assigns = a && a.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(Pn, function(i) {
                var r = this;
                if (!r.value) return;
                r.value.walk(i);
                S(i, r.name, function() {
                    return r.value;
                }, function(e, n) {
                    var t = e.definition();
                    if (_(i, t, true)) {
                        v(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ r ];
                        if (e instanceof pt && t.redefined() || !(he(e) || W(t))) {
                            t.single_use = false;
                        }
                    } else {
                        t.fixed = false;
                    }
                });
                return true;
            });
            e(tn, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                p(e);
                n();
                d(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function f(e) {
            e._squeezed = false;
            e._optimized = false;
            delete e.fixed;
            if (e instanceof sn) delete e._var_names;
        }
        fn.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new jt(t.option("reduce_vars") ? function(e, n) {
                f(e);
                return e.reduce_vars(i, n, t);
            } : f);
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        ct.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof Ue ? e : e();
        });
        bt.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof _t && e.scope.name === n;
        });
        Ue.DEFMETHOD("convert_symbol", Oe);
        nt.DEFMETHOD("convert_symbol", function(t, i) {
            return this.transform(new Ht(function(e, n) {
                if (e instanceof Hn) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof nt) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof it) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        });
        function n(e, n) {
            var t = _e(e, this, this);
            n(t, this);
            return t;
        }
        lt.DEFMETHOD("convert_symbol", n);
        bt.DEFMETHOD("convert_symbol", n);
        function t(n, t) {
            var i = new jt(function(e) {
                if (e instanceof Hn) {
                    e.value.walk(t);
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof it) {
                    if (e.key instanceof Ue) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        }
        Hn.DEFMETHOD("mark_symbol", t);
        nt.DEFMETHOD("mark_symbol", t);
        function i(e) {
            return e(this);
        }
        lt.DEFMETHOD("mark_symbol", i);
        bt.DEFMETHOD("mark_symbol", i);
        Ue.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        nt.DEFMETHOD("match_symbol", function(n, t) {
            var i = false;
            var r = new jt(function(e) {
                if (i) return true;
                if (e instanceof Hn) {
                    if (!t) return i = true;
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof it) {
                    if (!t && e.key instanceof Ue) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        });
        function G(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        function me(e, n) {
            if (e instanceof yt) return true;
            if (e instanceof bt) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && ne[t.name];
            }
            if (e instanceof Bn) {
                e = e.expression;
                if (e instanceof bt) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return me(e, n);
            }
            return false;
        }
        function _e(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function X(e, n) {
            if (n.length == 1) return n[0];
            return _e(Un, e, {
                expressions: n.reduce(m, [])
            });
        }
        function O(e, n) {
            switch (typeof e) {
              case "string":
                return _e(xt, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return _e(Tt, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? _e(Jn, n, {
                        operator: "-",
                        expression: _e(kt, n, {
                            value: -e
                        })
                    }) : _e(kt, n, {
                        value: e
                    });
                }
                return e < 0 ? _e(Jn, n, {
                    operator: "-",
                    expression: _e(At, n)
                }) : _e(At, n);

              case "boolean":
                return _e(e ? Mt : $t, n);

              case "undefined":
                return _e(Dt, n);

              default:
                if (e === null) {
                    return _e(St, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return _e(Et, n, {
                        value: e
                    });
                }
                throw new Error(qe("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function K(e, n) {
            return n instanceof Bn || ee(n) && n.name == "eval";
        }
        function ge(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && K(e, i);
            } else if (n instanceof Jn) {
                r = n.operator == "delete" || n.operator == "typeof" && ee(i);
            }
            return r ? X(t, [ _e(kt, t, {
                value: 0
            }), i ]) : i;
        }
        function m(e, n) {
            if (n instanceof Un) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function A(e) {
            if (e === null) return [];
            if (e instanceof Ke) return Pe(e.body, function(e) {
                return !(e instanceof qn || e instanceof Cn);
            }) ? e.body : [ e ];
            if (e instanceof Ve) return [];
            if (e instanceof Be) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function Q(e) {
            if (e === null) return true;
            if (e instanceof Ve) return true;
            if (e instanceof Ke) return e.body.length == 0;
            return false;
        }
        function x(e) {
            return Pe(e.body, function(e) {
                return Q(e) || e instanceof gn || e instanceof Nn && Pe(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function z(e) {
            if (e instanceof Ze) {
                return e.body instanceof Ke ? e.body : e;
            }
            return e;
        }
        function be(e) {
            while (e instanceof Bn) e = e.expression;
            return e;
        }
        function Z(e) {
            if (e.TYPE != "Call") return false;
            var n = e.expression;
            return n instanceof vn || n instanceof hn || Z(n);
        }
        function ee(e) {
            return e instanceof bt && e.definition().undeclared;
        }
        function ye(e) {
            return e[e instanceof Qn ? "right" : "value"];
        }
        var r = Ne("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        bt.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && r[this.name];
        });
        var ne = Ne("Infinity NaN undefined");
        function o(e) {
            return e instanceof At || e instanceof Tt || e instanceof Dt;
        }
        function _(e) {
            return Pe(e.definitions, function(e) {
                return !e.value;
            });
        }
        function $(e) {
            return e instanceof gn || e instanceof Nn && _(e);
        }
        function u(e, f) {
            var ue, ce, le;
            t();
            var pe, n = 10;
            do {
                pe = false;
                r(e);
                if (f.option("dead_code")) {
                    o(e, f);
                }
                if (f.option("if_return")) {
                    a(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    h(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (pe && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof Mn) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof jn) {
                        n++;
                    } else if (e instanceof Ze) {
                        ue = true;
                    } else if (e instanceof sn) {
                        le = e;
                        break;
                    } else if (e instanceof $n) {
                        if (!ce) ce = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, l) {
                if (le.pinned()) return o;
                var p;
                var a = Object.create(null);
                var d = [];
                var s = Object.create(null);
                var t;
                var f = o.length;
                var v = new Ht(function(e, n) {
                    if ($) return e;
                    if (!z) {
                        if (e !== u[c]) return e;
                        c++;
                        if (c < u.length) return P(e, v);
                        z = true;
                        _ = (m ? V : L)(e, 0);
                        if (_ === e) $ = true;
                        return e;
                    }
                    var t = v.parent();
                    if (I(e, t)) {
                        $ = true;
                        return e;
                    }
                    if (!g && R(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof Pn && t.value === e) return e;
                    var i;
                    if (!(e instanceof lt) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!F || g && (i || !D || !A)) {
                            if (!i && !m) $ = true;
                            return e;
                        }
                        if (ke(e, t)) {
                            if (m && !i) {
                                j = true;
                                M++;
                            }
                            return e;
                        } else if (m) {
                            if (!i) M++;
                            return e;
                        } else {
                            M++;
                        }
                        pe = $ = true;
                        Ue.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (h instanceof Gn) {
                            if (b instanceof bt) b.definition().fixed = false;
                            return _e(Jn, h, h);
                        }
                        if (h instanceof Pn) {
                            var r = h.name.definition();
                            if (r.references.length - r.replaced == 1 && !l.exposed(r)) {
                                r.replaced++;
                                return ge(l, t, e, h.value);
                            }
                            return _e(Qn, h, {
                                operator: "=",
                                left: _e(bt, h.name, h.name),
                                right: h.value
                            });
                        }
                        h.write_only = false;
                        return h;
                    }
                    if (U(e, t) || k(e)) {
                        _ = e;
                        if (e instanceof sn) $ = true;
                    }
                    if (e instanceof cn) {
                        var a = F;
                        F = false;
                        n(e, v);
                        F = a;
                        return N(e);
                    }
                    if (e instanceof nt) {
                        var a = F;
                        F = false;
                        n(e, v);
                        F = a;
                        return N(e);
                    }
                    if (e instanceof Hn) {
                        e.name = e.name.transform(v);
                        var a = F;
                        F = false;
                        e.value = e.value.transform(v);
                        F = a;
                        return N(e);
                    }
                    return P(e, v);
                }, N);
                var i = new Ht(function(e) {
                    if ($) return e;
                    if (!z) {
                        if (e !== u[c]) return e;
                        c++;
                        switch (u.length - c) {
                          case 0:
                            z = true;
                            if (j) return e;
                            if (e instanceof Pn) return e;
                            q.replaced++;
                            var n = i.parent();
                            if (n instanceof Un && n.tail_node() !== e) {
                                m.replaced++;
                                return je.skip;
                            }
                            return O;

                          case 1:
                            if (!j && e.body === h) {
                                z = true;
                                q.replaced++;
                                m.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof bt && e.name == q.name) {
                        if (!--M) $ = true;
                        if (ke(e, i.parent())) return e;
                        q.replaced++;
                        var t = O.clone();
                        m.references.push(t);
                        return t;
                    }
                    if (e instanceof An || e instanceof sn) return e;
                }, te);
                while (--f >= 0) {
                    if (f == 0 && l.option("unused")) B();
                    var u = [];
                    Y(o[f]);
                    while (d.length > 0) {
                        u = d.pop();
                        var c = 0;
                        var h = u[u.length - 1];
                        var m = null;
                        var _ = null;
                        var g = null;
                        var b = G(h);
                        var y = b && b.has_side_effects(l);
                        var w = b && !y && !me(b, l);
                        var x = K(h);
                        if (!w && !x) continue;
                        var r = h.name instanceof ht;
                        var k = Ae;
                        if (h.may_throw(l)) {
                            if (r && le instanceof vn) continue;
                            k = ce ? function(e) {
                                return e.has_side_effects(l);
                            } : fe;
                        }
                        var E = false;
                        var S = false;
                        var T = ee(h);
                        var D = ie(b);
                        var O = ye(h);
                        if (!y) y = re();
                        var A = ae(h);
                        var z = r;
                        var $ = false;
                        var M = 0;
                        var j = false;
                        var F = !p || !z;
                        if (!F) {
                            for (var e = h.arg_index + 1; !$ && e < p.length; e++) {
                                if (p[e]) p[e].transform(v);
                            }
                            F = true;
                        }
                        for (var n = f; !$ && n < o.length; n++) {
                            o[n].transform(v);
                        }
                        if (m) {
                            var q = b.definition();
                            var C = q.references.length - q.replaced;
                            if (h instanceof Qn) C--;
                            if (M && C == M) {
                                $ = false;
                            } else {
                                d.push(u);
                                t = true;
                                continue;
                            }
                            if (M) {
                                c = 0;
                                z = r;
                                for (var n = f; !$ && n < o.length; n++) {
                                    if (!o[n].transform(i)) o.splice(n--, 1);
                                }
                                if (h instanceof Pn) {
                                    M = !l.exposed(q) && q.references.length == q.replaced;
                                }
                                m.single_use = false;
                            }
                        }
                        if (M && !ne(h)) o.splice(f, 1);
                    }
                }
                function N(e) {
                    if ($) return e;
                    if (_ === e) $ = true;
                    if (g === e) g = null;
                    return e;
                }
                function P(e, n) {
                    if (!(e instanceof Je)) return;
                    if (e instanceof sn) return e;
                    if (!(e.variables && e.variables.all(function(e) {
                        return !T.has(e.name);
                    }))) {
                        $ = true;
                        return e;
                    }
                    if (e instanceof an) {
                        e.object = e.object.transform(n);
                        $ = true;
                        return e;
                    }
                    if (e instanceof Dn) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !$ && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof zn) {
                                if (!z) {
                                    if (i !== u[c]) continue;
                                    c++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!A) break;
                                x = false;
                            }
                        }
                        $ = true;
                        return e;
                    }
                }
                function H(e, n) {
                    if (n instanceof Qn) return n.operator == "=" && n.left === e;
                    if (n instanceof Hn) return n.name === e;
                    if (n instanceof tt) return true;
                    if (n instanceof it) return n.value === e;
                }
                function I(e, n) {
                    if (e === O) return true;
                    if (n instanceof rn) return e !== n.init;
                    if (e instanceof Qn) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof In) {
                        if (!(b instanceof Bn)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(O instanceof hn && !O.contains_this());
                    }
                    if (e instanceof Ye) return true;
                    if (e instanceof gn) return r && b.name === e.name.name;
                    if (e instanceof nt) return (ce || !D) && n instanceof Qn;
                    if (e instanceof it) return e.key instanceof Ue;
                    if (e instanceof en) return true;
                    if (e instanceof kn) return true;
                    if (e instanceof bt) {
                        if (e.is_declared(l)) {
                            if (e.fixed_value()) return false;
                            if (he(e)) {
                                return !(n instanceof Bn && n.expression === e) && ve(e.definition());
                            }
                        } else if (H(e, n)) {
                            return false;
                        }
                        if (!A) return true;
                        x = false;
                        return false;
                    }
                    if (e instanceof $n) return true;
                    if (e instanceof on) return true;
                    return false;
                }
                function R(e, n) {
                    if (n instanceof Xn) return xe[n.operator] && n.left !== e;
                    if (n instanceof zn) return n.expression !== e;
                    if (n instanceof Kn) return n.condition !== e;
                    return n instanceof Tn && n.condition !== e;
                }
                function U(e, n) {
                    if (e instanceof Zn) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !Ee(e.right);
                    if (e instanceof In) {
                        var t, i = e.expression;
                        if (i instanceof bt) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof un)) return true;
                        if (t && Se(l, t)) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = F;
                        F = false;
                        var a = _;
                        var o = g;
                        if (!Pe(i.argnames, function(e) {
                            if (e instanceof Hn) {
                                e.value.transform(v);
                                if ($) return false;
                                e = e.name;
                            }
                            return !(e instanceof nt);
                        })) {
                            $ = true;
                        } else if (i instanceof pn && i.value) {
                            i.value.transform(v);
                        } else for (var s = 0; !$ && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof wn) {
                                if (f.value) f.value.transform(v);
                                break;
                            }
                            f.transform(v);
                        }
                        g = o;
                        _ = a;
                        F = r;
                        delete i.collapse_scanning;
                        if (!$) return false;
                        $ = false;
                        return true;
                    }
                    if (e instanceof yn) {
                        if (ce) {
                            if (ce.bfinally) return true;
                            if (ce.bcatch && e instanceof xn) return true;
                        }
                        return y || b instanceof Bn || se(b);
                    }
                    if (e instanceof hn) {
                        return l.option("ie8") && e.name && T.has(e.name.name);
                    }
                    if (e instanceof Bn) {
                        var u = e.expression;
                        return y || !m && u.may_throw_on_access(l) || u instanceof bt && ve(u.definition());
                    }
                    if (e instanceof Vn) return true;
                    if (e instanceof bt) {
                        if (oe(e, n)) return !H(e, n);
                        if (y && se(e)) return true;
                        var t = e.definition();
                        return (ce || t.scope.resolve() !== le) && !he(e);
                    }
                    if (e instanceof yt) return oe(e, n);
                    if (e instanceof Pn) {
                        if ((ce || !D) && e.name instanceof nt) return true;
                        return (e.value || n instanceof Cn) && e.name.match_symbol(function(e) {
                            return e instanceof lt && (T.has(e.name) || y && se(e));
                        }, true);
                    }
                    var c = ke(e.left, e);
                    if (!c) return false;
                    if (c instanceof Bn) return true;
                    if ((ce || !D) && c instanceof nt) return true;
                    return c.match_symbol(function(e) {
                        return e instanceof bt && (T.has(e.name) || E && l.exposed(e.definition()));
                    }, true);
                }
                function B() {
                    var e, t = l.self();
                    if (ln(t) && !t.name && !t.uses_arguments && !t.pinned() && (e = l.parent()) instanceof In && e.expression === t && Pe(e.args, function(e) {
                        return !(e instanceof Vn);
                    })) {
                        var i = l.has_directive("use strict");
                        if (i && !Te(i, t.body)) i = false;
                        var r = t instanceof vn ? function(e) {
                            return e instanceof ct && e.name == "await";
                        } : function(e) {
                            return e instanceof Zn && !a.find_parent(sn);
                        };
                        var a = new jt(function(e) {
                            if (!f) return true;
                            if (r(e)) {
                                f = null;
                                return true;
                            }
                            if (e instanceof bt && t.variables.has(e.name)) {
                                var n = e.definition().scope;
                                if (n !== le) while (n = n.parent_scope) {
                                    if (n === le) return true;
                                }
                                f = null;
                            }
                            if (e instanceof yt && (i || !a.find_parent(sn))) {
                                f = null;
                                return true;
                            }
                        });
                        p = e.args.slice();
                        var n = Object.create(null);
                        for (var o = t.argnames.length; --o >= 0; ) {
                            var s = t.argnames[o];
                            var f = e.args[o];
                            var u;
                            if (s instanceof Hn) {
                                u = s.value;
                                s = s.name;
                                p[e.args.length + o] = u;
                            }
                            if (s instanceof nt) {
                                if (!s.match_symbol(Ae)) continue;
                                d.length = 0;
                                break;
                            }
                            if (s.name in n) continue;
                            n[s.name] = true;
                            if (u) f = !f || we(f) ? u : null;
                            if (!f && !u) {
                                f = _e(Dt, s).transform(l);
                            } else if (f instanceof un && f.pinned()) {
                                f = null;
                            } else if (f) {
                                f.walk(a);
                            }
                            if (!f) continue;
                            var c = _e(Pn, s, {
                                name: s,
                                value: f
                            });
                            c.name_index = o;
                            c.arg_index = u ? e.args.length + o : o;
                            d.unshift([ c ]);
                        }
                    }
                }
                function Y(e) {
                    u.push(e);
                    if (e instanceof et) {
                        e.elements.forEach(Y);
                    } else if (e instanceof Qn) {
                        if (!(e.left instanceof nt)) d.push(u.slice());
                        Y(e.left);
                        Y(e.right);
                        if (e.left instanceof bt) {
                            a[e.left.name] = (a[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof Zn) {
                        Y(e.expression);
                    } else if (e instanceof Xn) {
                        Y(e.left);
                        Y(e.right);
                    } else if (e instanceof In) {
                        Y(e.expression);
                        e.args.forEach(Y);
                    } else if (e instanceof zn) {
                        Y(e.expression);
                    } else if (e instanceof Kn) {
                        Y(e.condition);
                        Y(e.consequent);
                        Y(e.alternative);
                    } else if (e instanceof Fn) {
                        e.definitions.forEach(Y);
                    } else if (e instanceof Yn) {
                        Y(e.expression);
                    } else if (e instanceof en) {
                        Y(e.condition);
                        if (!(e.body instanceof Xe)) {
                            Y(e.body);
                        }
                    } else if (e instanceof yn) {
                        if (e.value) Y(e.value);
                    } else if (e instanceof rn) {
                        if (e.init) Y(e.init);
                        if (e.condition) Y(e.condition);
                        if (e.step) Y(e.step);
                        if (!(e.body instanceof Xe)) {
                            Y(e.body);
                        }
                    } else if (e instanceof an) {
                        Y(e.object);
                        if (!(e.body instanceof Xe)) {
                            Y(e.body);
                        }
                    } else if (e instanceof Tn) {
                        Y(e.condition);
                        if (!(e.body instanceof Xe)) {
                            Y(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof Xe)) {
                            Y(e.alternative);
                        }
                    } else if (e instanceof at) {
                        e.properties.forEach(function(e) {
                            u.push(e);
                            if (e.key instanceof Ue) Y(e.key);
                            if (e instanceof st) Y(e.value);
                            u.pop();
                        });
                    } else if (e instanceof Un) {
                        e.expressions.forEach(Y);
                    } else if (e instanceof We) {
                        Y(e.body);
                    } else if (e instanceof Vn) {
                        Y(e.expression);
                    } else if (e instanceof Ln) {
                        Y(e.expression);
                        Y(e.property);
                    } else if (e instanceof Dn) {
                        Y(e.expression);
                        e.body.forEach(Y);
                    } else if (e instanceof Wn) {
                        if (Ct[e.operator]) {
                            d.push(u.slice());
                        } else {
                            Y(e.expression);
                        }
                    } else if (e instanceof Pn) {
                        if (e.name instanceof vt) {
                            if (e.value) {
                                var n = e.name.definition();
                                if (n.references.length > n.replaced) {
                                    d.push(u.slice());
                                }
                            } else {
                                s[e.name.name] = (s[e.name.name] || 0) + 1;
                            }
                        }
                        if (e.value) Y(e.value);
                    }
                    u.pop();
                }
                function L(e, n) {
                    var t = v.parent(n);
                    if (t instanceof et) return e;
                    if (t instanceof Qn) return e;
                    if (t instanceof Zn) return e;
                    if (t instanceof Xn) return e;
                    if (t instanceof In) return e;
                    if (t instanceof zn) return e;
                    if (t instanceof Kn) return e;
                    if (t instanceof Fn) return W(t, n + 1);
                    if (t instanceof yn) return e;
                    if (t instanceof Tn) return e;
                    if (t instanceof Ze) return e;
                    if (t instanceof ot) return e;
                    if (t instanceof Bn) return e;
                    if (t instanceof Un) {
                        return (t.tail_node() === e ? L : W)(t, n + 1);
                    }
                    if (t instanceof We) return W(t, n + 1);
                    if (t instanceof Vn) return e;
                    if (t instanceof Dn) return e;
                    if (t instanceof Wn) return e;
                    if (t instanceof Pn) return e;
                    return null;
                }
                function V(e, n) {
                    var t = v.parent(n);
                    if (t instanceof et) return V(t, n + 1);
                    if (t instanceof Qn) return k(t) || t.left.match_symbol(function(e) {
                        return e instanceof bt && (b.name == e.name || m.name == e.name);
                    }) ? e : V(t, n + 1);
                    if (t instanceof Xn) {
                        if (xe[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = v.parent(++n);
                            } while (t instanceof Xn && t.operator == e.operator);
                            return e;
                        }
                        return V(t, n + 1);
                    }
                    if (t instanceof In) return t;
                    if (t instanceof zn) {
                        if (t.expression !== e) return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof Kn) {
                        if (t.condition !== e) return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof Fn) return W(t, n + 1);
                    if (t instanceof nn) return e;
                    if (t instanceof yn) return W(t, n + 1);
                    if (t instanceof rn) {
                        if (t.init !== e && t.condition !== e) return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof an) {
                        if (t.init !== e) return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof Tn) {
                        if (t.condition !== e) return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof ot) {
                        var i = v.parent(n + 1);
                        return Pe(i.properties, function(e) {
                            return e instanceof st;
                        }) ? V(i, n + 2) : i;
                    }
                    if (t instanceof Bn) return V(t, n + 1);
                    if (t instanceof Un) {
                        return (t.tail_node() === e ? V : W)(t, n + 1);
                    }
                    if (t instanceof We) return W(t, n + 1);
                    if (t instanceof Vn) return V(t, n + 1);
                    if (t instanceof Dn) {
                        if (t.expression !== e) return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof Wn) {
                        if (t.operator == "delete") return e;
                        return V(t, n + 1);
                    }
                    if (t instanceof Pn) return t.name.match_symbol(function(e) {
                        return e instanceof lt && (b.name == e.name || m.name == e.name);
                    }) ? e : V(t, n + 1);
                    if (t instanceof tn) {
                        if (t.condition !== e) return e;
                        return V(t, n + 1);
                    }
                    return null;
                }
                function W(r, a) {
                    var o = v.parent(a);
                    if (U(r, o)) return r;
                    if (R(r, o)) return r;
                    if (o instanceof et) return W(o, a + 1);
                    if (o instanceof Qn) return s(o.left);
                    if (o instanceof Zn) return r;
                    if (o instanceof Xn) return W(o, a + 1);
                    if (o instanceof In) return W(o, a + 1);
                    if (o instanceof zn) return W(o, a + 1);
                    if (o instanceof Kn) return W(o, a + 1);
                    if (o instanceof Fn) return W(o, a + 1);
                    if (o instanceof yn) return W(o, a + 1);
                    if (o instanceof Tn) return W(o, a + 1);
                    if (o instanceof Ze) return r;
                    if (o instanceof ot) {
                        var e = v.parent(a + 1);
                        return Pe(e.properties, function(e) {
                            return e instanceof st;
                        }) ? W(e, a + 2) : e;
                    }
                    if (o instanceof Bn) {
                        var n = o.expression;
                        if (n === r) return W(o, a + 1);
                        var t = be(n);
                        if (!(t instanceof bt)) return W(o, a + 1);
                        var i = T.get(t.name);
                        return !i || Pe(i, function(e) {
                            return !(e instanceof Bn);
                        }) ? W(o, a + 1) : r;
                    }
                    if (o instanceof Un) return W(o, a + 1);
                    if (o instanceof We) return W(o, a + 1);
                    if (o instanceof Vn) return r;
                    if (o instanceof Dn) return W(o, a + 1);
                    if (o instanceof Wn) return W(o, a + 1);
                    if (o instanceof Pn) return s(o.name);
                    return null;
                    function s(e) {
                        if (k(o)) return r;
                        if (e !== r && e instanceof nt) {
                            var n = F;
                            F = false;
                            var t = _;
                            var i = g;
                            e.transform(v);
                            g = i;
                            _ = t;
                            F = n;
                            if ($) {
                                $ = false;
                                return r;
                            }
                        }
                        return W(o, a + 1);
                    }
                }
                function J(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof bt)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (ve(n)) return;
                    return m = n;
                }
                function G(e) {
                    if (e instanceof Pn) {
                        var n = e.name.definition();
                        if (n.const_redefs) return;
                        if (!Te(e.name, n.orig)) return;
                        var t = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (a[n.name] || 0);
                        if (t > 1 && !(e.name instanceof ht)) {
                            J(e.value);
                            return _e(bt, e.name, e.name);
                        }
                        if (J(e.value) || i == 1 && !l.exposed(n)) {
                            return _e(bt, e.name, e.name);
                        }
                    } else if (e instanceof Qn) {
                        var n, r = e.left;
                        if (e.operator == "=" && r instanceof bt && (n = r.definition()).references[0] === r && !l.exposed(n)) {
                            var i = n.references.length - n.replaced;
                            if (i > 1) J(e.right);
                        }
                        return r;
                    } else {
                        return e.expression;
                    }
                }
                function X(e) {
                    if (e instanceof et) return false;
                    if (e instanceof Xn && xe[e.operator]) {
                        return X(e.left) && X(e.right);
                    }
                    if (e instanceof In) return false;
                    if (e instanceof Kn) {
                        return X(e.consequent) && X(e.alternative);
                    }
                    if (e instanceof at) return false;
                    return !e.has_side_effects(l);
                }
                function K(n) {
                    if (n instanceof Qn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new jt(function(e) {
                        if (e instanceof bt) t[e.definition().id] = true;
                    });
                    while (n instanceof Qn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof bt) {
                        var i = n.evaluate(l);
                        if (i === n) return a;
                        return Q(i, a);
                    }
                    if (n instanceof yt) return a;
                    if (n.is_truthy()) return Q(true, Ae);
                    if (n.is_constant()) {
                        return Q(n.evaluate(l), a);
                    }
                    if (!(b instanceof bt)) return false;
                    if (!X(n)) return false;
                    var r;
                    n.walk(new jt(function(e) {
                        if (r) return true;
                        if (e instanceof bt && t[e.definition().id]) r = true;
                    }));
                    return !r && a;
                    function a(e) {
                        return n.equivalent_to(e);
                    }
                }
                function Q(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(l)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(l) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function Z(e) {
                    if (e instanceof bt) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Qn) return e.operator == "=" && Z(e.right);
                    return e instanceof Bn || e instanceof yt;
                }
                function ee(i) {
                    var r = new He();
                    if (i instanceof Pn) r.add(i.name.name, b);
                    var a = le.uses_arguments && !l.has_directive("use strict");
                    var o = le instanceof fn;
                    var s = new jt(function(e) {
                        var n;
                        if (e instanceof bt) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof yt) {
                            n = e;
                        }
                        if (n) r.add(e.name, de(l, s, e, n, 0));
                        if (a && e instanceof Ln) {
                            le.each_argname(function(e) {
                                if (!l.option("reduce_vars") || e.definition().assignments) {
                                    r.add(e.name, true);
                                }
                            });
                            a = false;
                        }
                        if (!o) return;
                        if (e.TYPE == "Call") {
                            if (S) return;
                            var t = e.expression;
                            if (t instanceof Bn) return;
                            if (t instanceof hn && !t.contains_this()) return;
                            S = true;
                        } else if (e instanceof Bn && Z(e.expression)) {
                            if (e === b && !(i instanceof Wn)) {
                                S = true;
                            } else {
                                E = true;
                            }
                        }
                    });
                    i.walk(s);
                    return r;
                }
                function ne(e) {
                    var n = e.name_index;
                    if (n >= 0) {
                        var t = le.argnames[n];
                        if (t instanceof Hn) {
                            t.value = _e(kt, t, {
                                value: 0
                            });
                            t.name.definition().fixed = false;
                        } else {
                            var i = l.parent().args;
                            if (i[n]) {
                                i[n] = _e(kt, i[n], {
                                    value: 0
                                });
                                t.definition().fixed = false;
                            }
                        }
                        return true;
                    }
                    var r = u.length - 1;
                    if (u[r - 1].body === u[r]) r--;
                    var a = new Ht(function(e, n, t) {
                        if (z) return e;
                        if (e !== u[c]) return e;
                        c++;
                        if (c <= r) return P(e, a);
                        z = true;
                        if (e instanceof Pn) {
                            e.value = null;
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (m) m.replaced++;
                            return e;
                        }
                        return t ? je.skip : null;
                    }, te);
                    $ = false;
                    z = false;
                    c = 0;
                    return o[f].transform(a);
                }
                function te(e) {
                    if (e instanceof Un) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function ie(e) {
                    var n = be(e);
                    return n instanceof bt && n.definition().scope === le && !(ue && (T.has(n.name) && T.get(n.name)[0] !== e || h instanceof Wn || h instanceof Qn && h.operator != "="));
                }
                function re() {
                    if (h instanceof Wn) return false;
                    return O.has_side_effects(l);
                }
                function ae(e) {
                    if (e instanceof Wn) return false;
                    if (y) return false;
                    if (m) return true;
                    if (!(b instanceof bt)) return false;
                    var n;
                    if (e instanceof Pn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function oe(e, n) {
                    var t = T.get(e.name);
                    if (!t || Pe(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function se(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof mt) return false;
                    if (n.scope !== le) return true;
                    if (S && l.exposed(n)) return true;
                    return !Pe(n.references, function(e) {
                        return e.scope.resolve() === le;
                    });
                }
                function fe(e, n) {
                    if (e instanceof Qn) return fe(e.left, true);
                    if (e instanceof Wn) return fe(e.expression, true);
                    if (e instanceof Pn) return e.value && fe(e.value);
                    if (n) {
                        if (e instanceof Yn) return fe(e.expression, true);
                        if (e instanceof Ln) return fe(e.expression, true);
                        if (e instanceof bt) return e.definition().scope !== le;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof Ke) {
                        if (Pe(i.body, function(e) {
                            return !(e instanceof qn || e instanceof Cn);
                        })) {
                            pe = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof Le) {
                        if (Te(i.value, n)) {
                            pe = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof Ve) {
                        pe = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function a(t, r) {
                var a = r.self();
                var e = r.parent();
                var i = w(function(e) {
                    return e instanceof un;
                });
                var n = i && e && e.TYPE == "Call";
                var o = g(t);
                for (var s = t.length; --s >= 0; ) {
                    var f = t[s];
                    var u = T(s);
                    var c = t[u];
                    if (i && !c && f instanceof wn) {
                        if (!f.value) {
                            pe = true;
                            t.splice(s, 1);
                            continue;
                        }
                        if (f.value instanceof Jn && f.value.operator == "void") {
                            pe = true;
                            t[s] = _e(We, f, {
                                body: f.value.expression
                            });
                            continue;
                        }
                    }
                    if (f instanceof Tn) {
                        var l = M(f.body);
                        if (k(l)) {
                            if (l.label) Ce(l.label.thedef.references, l);
                            pe = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = S(f.body, l);
                            f.body = _e(Ke, f, {
                                body: A(f.alternative).concat(E())
                            });
                            f.alternative = _e(Ke, f, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (l && !f.alternative && f.body instanceof Ke && c instanceof bn) {
                            var d = f.condition.negate(r);
                            if (d.print_to_string().length <= f.condition.print_to_string().length) {
                                pe = true;
                                f = f.clone();
                                f.condition = d;
                                t[u] = f.body;
                                f.body = c;
                                t[s] = f;
                                t[s] = f.transform(r);
                                continue;
                            }
                        }
                        var v = M(f.alternative);
                        if (k(v)) {
                            if (v.label) Ce(v.label.thedef.references, v);
                            pe = true;
                            f = f.clone();
                            f.body = _e(Ke, f.body, {
                                body: A(f.body).concat(E())
                            });
                            var p = S(f.alternative, v);
                            f.alternative = _e(Ke, f.alternative, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (l && !v) {
                                C(f.condition, null, _e(Ke, a, {
                                    body: t.slice(s + 1)
                                }));
                            }
                            if (!l && v) {
                                C(f.condition, _e(Ke, a, {
                                    body: t.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof Tn && f.body instanceof wn) {
                        var h = f.body.value;
                        var m = f.body.in_bool || c instanceof wn && c.in_bool;
                        if (!h && !f.alternative && (i && !c || c instanceof wn && !c.value)) {
                            pe = true;
                            t[s] = _e(We, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof wn) {
                            pe = true;
                            f = f.clone();
                            f.alternative = c;
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && i && (m || h && o)) {
                            pe = true;
                            f = f.clone();
                            f.alternative = _e(wn, f, {
                                value: null
                            });
                            t.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var _ = t[D(s)];
                        if (r.option("sequences") && i && !f.alternative && (!_ && n || _ instanceof Tn && _.body instanceof wn) && T(u) == t.length && c instanceof We) {
                            pe = true;
                            f = f.clone();
                            f.alternative = _e(Ke, c, {
                                body: [ c, _e(wn, c, {
                                    value: null
                                }) ]
                            });
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                    }
                }
                function g(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof Tn && i.body instanceof wn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function b(e) {
                    return !e || e instanceof Jn && e.operator == "void";
                }
                function y(e, n) {
                    var t = e.lastIndexOf(n);
                    if (t < 0) return false;
                    while (++t < e.length) {
                        if (!$(e[t])) return false;
                    }
                    return true;
                }
                function w(e) {
                    var n = a, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof Tn && (t = n));
                    } while ((n instanceof Ke || n instanceof sn) && y(n.body, t));
                }
                function x(n) {
                    return w(function(e) {
                        return e === n;
                    });
                }
                function k(e) {
                    if (e instanceof wn) return i && b(e.value);
                    if (!(e instanceof kn)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof Sn) return x(z(n));
                    if (n instanceof Ze) return false;
                    return x(n);
                }
                function E() {
                    var e = t.slice(s + 1);
                    t.length = s + 1;
                    return e.filter(function(e) {
                        if (e instanceof gn) {
                            t.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function S(e, n) {
                    var t = A(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) i.push(_e(We, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function T(e) {
                    for (var n = e + 1; n < t.length; n++) {
                        if (!$(t[n])) break;
                    }
                    return n;
                }
                function D(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!$(t[n])) break;
                    }
                    return n;
                }
            }
            function o(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, a = 0, o = n.length; r < o; r++) {
                    var s = n[r];
                    if (s instanceof kn) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof En && !(f instanceof Ze) && z(f) === i || s instanceof Sn && z(f) === i) {
                            if (s.label) Ce(s.label.thedef.references, s);
                        } else {
                            n[a++] = s;
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (M(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = a;
                pe = a != o;
                if (e) e.forEach(function(e) {
                    k(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = X(t[0], t);
                    n[i++] = _e(We, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof We) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) m(t, f);
                    } else if ($(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != o) pe = true;
            }
            function p(e, n) {
                if (!(e instanceof Ke)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof Nn && _(r)) {
                        n.push(r);
                    } else if (t || r instanceof qn || r instanceof Cn) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    pe = true;
                    var n = r.body;
                    return X(n, [ n, e ]);
                }
                var i = 0, r;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (r) {
                        if (o instanceof yn) {
                            o.value = t(o.value || _e(Dt, o)).transform(n);
                        } else if (o instanceof rn) {
                            if (!(o.init instanceof Fn)) {
                                var s = false;
                                r.body.walk(new jt(function(e) {
                                    if (s || e instanceof sn) return true;
                                    if (e instanceof Xn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = t(o.init); else {
                                        o.init = r.body;
                                        i--;
                                        pe = true;
                                    }
                                }
                            }
                        } else if (o instanceof an) {
                            o.object = t(o.object);
                        } else if (o instanceof Tn) {
                            o.condition = t(o.condition);
                        } else if (o instanceof Dn) {
                            o.expression = t(o.expression);
                        } else if (o instanceof on) {
                            o.expression = t(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof Tn) {
                        var f = [];
                        var u = p(o.body, f);
                        var c = p(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(_e(Tn, o, {
                                condition: o.condition,
                                body: u || _e(Ve, o.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            a += l;
                            i += l + 1;
                            r = null;
                            pe = true;
                            continue;
                        }
                    }
                    e[i++] = o;
                    r = o instanceof We ? o : null;
                }
                e.length = i;
            }
            function c(e, n, t) {
                var i;
                if (n instanceof Qn) {
                    i = [ n ];
                } else if (n instanceof Un) {
                    i = n.expressions.slice();
                }
                if (!i) return;
                var r = false;
                for (var a = i.length - 1; --a >= 0; ) {
                    var o = i[a];
                    if (!(o instanceof Qn)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof bt)) continue;
                    var s = i.slice(a + 1);
                    if (!v(o.left, o.right, s)) continue;
                    r = true;
                    i = i.slice(0, a + 1).concat(s);
                }
                if (e instanceof Fn) {
                    t = t || 0;
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var f = e.definitions[a];
                        if (!f.value) continue;
                        if (v(f.name, f.value, i)) r = true;
                        if (l(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof Nn && d(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function l(e, n, t) {
                if (!f.option("conditionals")) return;
                if (e.name instanceof nt) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var a = R(f, r, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function d(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof Qn)) break;
                    if (r.operator != "=") break;
                    var a = r.left;
                    if (!(a instanceof bt)) break;
                    if (ee(a)) break;
                    if (a.scope.resolve() !== le) break;
                    var o = a.definition();
                    if (o.scope !== le) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = _e(vt, a, a);
                    e.push(_e(Pn, r, {
                        name: s,
                        value: r.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function v(e, n, t) {
                if (!(n instanceof at)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof Qn)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof Bn)) break;
                    var a = r.left.expression;
                    if (!(a instanceof bt)) break;
                    if (e.name != a.name) break;
                    if (!r.right.is_constant_expression(le)) break;
                    var o = r.left.property;
                    if (o instanceof Ue) {
                        o = o.evaluate(f);
                    }
                    if (o instanceof Ue) break;
                    o = "" + o;
                    var s = o == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return typeof e.key == "string" && e.key != o;
                    } : function(e) {
                        if (e instanceof ut || e instanceof ft) {
                            return typeof e.key == "string" && e.key != o;
                        }
                        return true;
                    };
                    if (!Pe(n.properties, s)) break;
                    n.properties.push(_e(st, r, {
                        key: o,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function h(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var a = e[t];
                    if (i instanceof Fn) {
                        if (a && a.TYPE == i.TYPE) {
                            a.definitions = a.definitions.concat(i.definitions);
                            pe = true;
                        } else if (r && r.TYPE == i.TYPE && _(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            pe = true;
                        } else {
                            e[++t] = i;
                            if (i instanceof Nn) r = i;
                        }
                        continue;
                    } else if (i instanceof yn) {
                        i.value = f(i.value);
                    } else if (i instanceof rn) {
                        var o = c(a, i.init);
                        if (o) {
                            pe = true;
                            i.init = o.length ? X(i.init, o) : null;
                        } else if (a instanceof Nn && (!i.init || i.init.TYPE == a.TYPE)) {
                            if (i.init) {
                                a.definitions = a.definitions.concat(i.init.definitions);
                            }
                            r = i.init = a;
                            e[t] = u(i);
                            pe = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && _(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            pe = true;
                        } else if (i.init instanceof Nn) {
                            r = i.init;
                        }
                    } else if (i instanceof an) {
                        if (r && r.TYPE == i.init.TYPE) {
                            var s = r.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(bt, function(e, n) {
                                s.push(_e(Pn, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            r.definitions = s;
                            pe = true;
                        }
                        i.object = f(i.object);
                    } else if (i instanceof Tn) {
                        i.condition = f(i.condition);
                    } else if (i instanceof We) {
                        var o = c(a, i.body);
                        if (o) {
                            pe = true;
                            if (!o.length) continue;
                            i.body = X(i.body, o);
                        }
                    } else if (i instanceof Dn) {
                        i.expression = f(i.expression);
                    } else if (i instanceof on) {
                        i.expression = f(i.expression);
                    }
                    e[++t] = r ? u(i) : i;
                }
                e.length = t + 1;
                function f(e) {
                    var n = c(a, e, 1);
                    if (!n) return e;
                    pe = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return X(e, n);
                }
                function u(e) {
                    return e.transform(new Ht(function(e, n, t) {
                        if (e instanceof Fn) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof an && i.init === e) return e;
                            if (!_(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            pe = true;
                            if (i instanceof rn && i.init === e) return null;
                            return t ? je.skip : _e(Ve, e);
                        }
                        if (e instanceof sn) return e;
                        if (!(e instanceof Be)) return e;
                    }));
                }
            }
        }
        function k(r, a, o) {
            if (!(a instanceof Fn || mn(a))) {
                Ue.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            }
            var s;
            a.walk(new jt(function(e, n) {
                if (e instanceof Fn) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        Ue.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        f(e);
                    }
                    return true;
                }
                if (mn(e)) {
                    f(e);
                    return true;
                }
                if (e instanceof sn) return true;
                if (e instanceof Je) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(_e(Ke, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = i;
                    return true;
                }
            }));
            function f(e) {
                if (s) {
                    s.push(e);
                    if (e instanceof qn || e instanceof Cn) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function we(e, n) {
            return e.is_undefined || e instanceof Dt || e instanceof Jn && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(Ue, Ae);
            e(et, ze);
            e(Qn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(un, ze);
            e(at, ze);
            e(Et, ze);
            e(Un, function() {
                return this.tail_node().is_truthy();
            });
            e(bt, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = Ae;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(Ue, ze);
            e(et, Ae);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof wt) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(Qn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Xn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(wt, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(un, Ae);
            e(at, Ae);
            e(Et, Ae);
            e(Un, function() {
                return this.tail_node().is_negative_zero();
            });
            e(bt, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = ze;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(Jn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            Ue.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function i(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(Ue, i);
            e(et, Ae);
            e(Qn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof bt)) return true;
                if (n instanceof Xn && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(Xn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(Kn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(wt, Ae);
            e(Yn, function(e) {
                if (!i(e)) return false;
                var n = this.expression;
                if (n instanceof bt) n = n.fixed_value();
                return !(n instanceof un && this.property == "prototype");
            });
            e(un, Ae);
            e(St, ze);
            e(at, function(e) {
                return i(e) && !Pe(this.properties, function(e) {
                    return e instanceof st;
                });
            });
            e(Un, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(bt, function(e) {
                if (this.is_undefined) return true;
                if (!i(e)) return false;
                if (ee(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var n = this.definition();
                if (ve(n) && Pe(n.scope.argnames, function(e) {
                    return e instanceof ht;
                })) return n.scope.uses_arguments > 2;
                var t = this.fixed_value();
                if (!t) return true;
                this._dot_throw = ze;
                if (t._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = Ae;
                return false;
            });
            e(yt, function(e) {
                return i(e) && !this.scope.new;
            });
            e(Jn, function() {
                return this.operator == "void";
            });
            e(Gn, Ae);
            e(Dt, ze);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(Ue, Ae);
            e(et, ze);
            e(Qn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(Xn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(Kn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(wt, ze);
            e(Ot, Ae);
            e(un, ze);
            e(at, ze);
            e(Un, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(bt, function(e) {
                if (this.is_undefined) return false;
                if (ee(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = Ae;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(Jn, function() {
                return this.operator != "void";
            });
            e(Gn, ze);
            e(Dt, Ae);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(Ue, Ae);
            e(Qn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = Ne("in instanceof == != === !== < <= >= >");
            e(Xn, function(e) {
                return n[this.operator] || xe[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(zt, ze);
            var t = Ne("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(In, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Yn && (t[n.property] || n.property == "test" && n.expression instanceof Et);
            });
            e(Kn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(Rn, Ae);
            e(Un, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(bt, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = Ae;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = Ne("! delete");
            e(Jn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(Ue, Ae);
            var n = Ne("- * / % & | ^ << >> >>>");
            e(Qn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Xn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = Ne([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(In, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Yn && (t[n.property] || ee(n.expression) && n.expression.name == "Math");
            });
            e(Kn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(Rn, Ae);
            e(kt, ze);
            e(Un, function(e) {
                return this.tail_node().is_number(e);
            });
            e(bt, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = Ae;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = Ne("+ - ~ ++ --");
            e(Wn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(Ue, Ae);
            e(Qn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Xn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = Ne([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(In, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Yn && t[n.property];
            });
            e(Kn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Un, function(e) {
                return this.tail_node().is_string(e);
            });
            e(xt, ze);
            e(bt, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = Ae;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Jn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var xe = Ne("&& ||");
        function ke(e, n) {
            if (n instanceof Qn) return n.left === e && e;
            if (n instanceof Hn) return n.name === e && e;
            if (n instanceof nt) return e;
            if (n instanceof it) return e;
            if (n instanceof Wn) return It[n.operator] && n.expression;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof Ue) return e.clone(true);
                if (Array.isArray(e)) return _e(et, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (Ie(e, i)) {
                        t.push(_e(st, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return _e(at, n, {
                        properties: t
                    });
                }
                return O(e, n);
            }
            function o(e) {
                Ue.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            fn.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: a.option("ie8")
                });
                return this.transform(new Ht(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof Bn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (ke(i, r)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(Ue, Oe);
            e(Yn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(lt, function(e) {
                if (!this.definition().global) return;
                if (Ie(e.option("global_defs"), this.name)) o(this);
            });
            e(bt, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (Ie(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function te(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function a(e, n, t) {
            return te(_e(We, e, {
                body: e
            }), _e(We, n, {
                body: n
            }), t).body;
        }
        function ie(e, n, t, i) {
            return (Re(e) ? a : te)(n, t, i);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = Ne(n[e]);
            });
            return t;
        }
        function c(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Le)) return t;
            }
        }
        pn.DEFMETHOD("first_statement", function() {
            if (this.value) return _e(wn, this.value, {
                value: this.value
            });
            return c(this.body);
        });
        un.DEFMETHOD("first_statement", function() {
            return c(this.body);
        });
        function re(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = O(t, n).optimize(e);
            return ie(e, n, t, e.eval_threshold);
        }
        var p = [ "constructor", "toString", "valueOf" ];
        var g = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(p),
            Boolean: p,
            Function: p,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(p),
            Object: p,
            RegExp: [ "exec", "test" ].concat(p),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(p)
        });
        var b = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            e(Ue, Ae);
            e(wt, ze);
            e(Et, Ae);
            var n = Ne("! ~ - + void");
            e(Jn, function() {
                return n[this.operator] && this.expression instanceof wt;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            Ue.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var u = new jt(function(e) {
                if (e instanceof Qn) c(e.left);
                if (e instanceof Wn && Ct[e.operator]) c(e.expression);
            });
            function c(e) {
                if (e instanceof Bn) {
                    c(e.expression);
                } else if (e instanceof bt) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Be, function() {
                throw new Error(qe("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(cn, $e);
            e(Ue, $e);
            e(wt, function() {
                return this.value;
            });
            e(Qn, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof bt)) return this;
                    if (!Ie(r, "_eval")) {
                        if (!r.fixed) return this;
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!Ie(r, "_eval") && r instanceof bt && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (o == "=") {
                    r.walk(u);
                    s = this.right;
                } else {
                    s = _e(Xn, this, {
                        operator: o.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                c(r);
                return f;
            });
            e(Un, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var a = 0, o = r.length - 1; a < o; a++) {
                    r[a].walk(u);
                }
                var s = r[o];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(un, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(et, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Ot) return this;
                        var s = o._eval(e, n, t, i);
                        if (o === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(at, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof st)) return this;
                        var s = o.key;
                        if (s instanceof Ue) {
                            s = s._eval(e, n, t, i);
                            if (s === o.key) return this;
                        }
                        if (o.value instanceof hn && typeof Object.prototype[s] == "function") return this;
                        r[s] = o.value._eval(e, n, t, i);
                        if (r[s] === o.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = Ne("! typeof void");
            e(Jn, function(e, n, t, i) {
                var r = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (r instanceof un || r instanceof bt && r.fixed_value() instanceof un)) {
                    return typeof function() {};
                }
                var o = r instanceof bt && r.definition();
                if (!f[a] && !(o && o.fixed)) i++;
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                    if (Ie(r, "_eval")) s = +(a[0] + 1) + +s;
                    c(r);
                    return s;
                }
                return this;
            });
            e(Gn, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof bt)) {
                    if (!n) return this;
                } else if (!Ie(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof bt && r.definition().fixed)) i++;
                var o = r._eval(e, n, t, i);
                if (o === r) return this;
                c(r);
                return +o;
            });
            var l = Ne("&& || === !==");
            e(Xn, function(e, n, t, i) {
                if (!l[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var a = n && !(r && typeof r == "object");
                var o = this.right._eval(e, a, t, i);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && o;
                    break;

                  case "||":
                    s = r || o;
                    break;

                  case "|":
                    s = r | o;
                    break;

                  case "&":
                    s = r & o;
                    break;

                  case "^":
                    s = r ^ o;
                    break;

                  case "+":
                    s = r + o;
                    break;

                  case "-":
                    s = r - o;
                    break;

                  case "*":
                    s = r * o;
                    break;

                  case "/":
                    s = r / o;
                    break;

                  case "%":
                    s = r % o;
                    break;

                  case "<<":
                    s = r << o;
                    break;

                  case ">>":
                    s = r >> o;
                    break;

                  case ">>>":
                    s = r >>> o;
                    break;

                  case "==":
                    s = r == o;
                    break;

                  case "===":
                    s = r === o;
                    break;

                  case "!=":
                    s = r != o;
                    break;

                  case "!==":
                    s = r !== o;
                    break;

                  case "<":
                    s = r < o;
                    break;

                  case "<=":
                    s = r <= o;
                    break;

                  case ">":
                    s = r > o;
                    break;

                  case ">=":
                    s = r >= o;
                    break;

                  case "in":
                    if (o && typeof o == "object" && Ie(o, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(on) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Kn, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var a = r ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, i);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new jt(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof sn) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(bt, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var a;
                if (Ie(r, "_eval")) {
                    a = r._eval();
                } else {
                    this._eval = $e;
                    a = r._eval(e, n, t, i);
                    delete this._eval;
                    if (a === r) return this;
                    r._eval = function() {
                        return a;
                    };
                    t.push(r);
                }
                return a && typeof a == "object" && !o(this, i) ? this : a;
            });
            var m = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var p = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var d = Ne("global ignoreCase multiline source");
            e(Bn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var a = this.expression;
                    if (!ee(a)) {
                        r = a._eval(e, n, t, i + 1);
                        if (r == null || r === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof Ue) {
                        o = o._eval(e, n, t, i);
                        if (o === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = p[a.name];
                        if (!s || !s[o]) return this;
                        r = m[a.name];
                    } else if (r instanceof RegExp) {
                        if (!d[o]) return this;
                    } else if (typeof r == "object") {
                        if (!Ie(r, o)) return this;
                    } else if (typeof r == "function") switch (o) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.argnames.length;

                      default:
                        return this;
                    }
                    return r[o];
                }
                return this;
            });
            e(In, function(a, o, s, f) {
                var e = this.expression;
                var n = e instanceof bt ? e.fixed_value() : e;
                if (n instanceof gn || n instanceof hn) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(a)) return this;
                    var r = h(this.args);
                    if (!Pe(n.argnames, function(e, n) {
                        if (e instanceof Hn) {
                            if (!r) return false;
                            if (r[n] !== undefined) return false;
                            var t = e.value._eval(a, o, s, f);
                            if (t === e.value) return false;
                            r[n] = t;
                            e = e.name;
                        }
                        return !(e instanceof nt);
                    })) return this;
                    if (!r && !o) return this;
                    var t = n.first_statement();
                    if (!(t instanceof wn)) {
                        if (o) {
                            var i = false;
                            n.walk(new jt(function(e) {
                                if (i) return true;
                                if (e instanceof wn) {
                                    if (e.value && e.value._eval(a, true, s, f) !== undefined) {
                                        i = true;
                                    }
                                    return true;
                                }
                                if (e instanceof sn && e !== n) return true;
                            }));
                            if (!i) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!r || Pe(n.argnames, function(e, n) {
                        if (e instanceof Hn) e = e.name;
                        var t = e.definition();
                        if (t.orig[t.orig.length - 1] !== e) return false;
                        var i = r[n];
                        t.references.forEach(function(e) {
                            e._eval = function() {
                                return i;
                            };
                            c.push(e);
                        });
                        return true;
                    }) || o) {
                        n.evaluating = true;
                        u = u._eval(a, o, s, f);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (a.option("unsafe") && e instanceof Bn) {
                    var l = e.property;
                    if (l instanceof Ue) {
                        l = l._eval(a, o, s, f);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (ee(p)) {
                        var d = b[p.name];
                        if (!d || !d[l]) return this;
                        u = m[p.name];
                    } else {
                        u = p._eval(a, o, s, f + 1);
                        if (u == null || u === p) return this;
                        var v = g[u.constructor.name];
                        if (!v || !v[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Et)) return this;
                    }
                    var r = h(this.args);
                    if (!r) return this;
                    if (l == "replace" && typeof r[1] == "function") return this;
                    try {
                        return u[l].apply(u, r);
                    } catch (e) {
                        Ue.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function h(e) {
                    var n = [];
                    for (var t = 0; t < e.length; t++) {
                        var i = e[t];
                        var r = i._eval(a, o, s, f);
                        if (i === r) return;
                        n.push(r);
                    }
                    return n;
                }
            });
            e(Rn, $e);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return _e(Jn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = a(e);
                if (t) {
                    var r = _e(We, n, {
                        body: n
                    });
                    return te(i, r) === r ? n : i;
                }
                return te(i, n);
            }
            e(Ue, function() {
                return a(this);
            });
            e(Be, function() {
                throw new Error("Cannot negate a statement");
            });
            e(pn, function() {
                return a(this);
            });
            e(vn, function() {
                return a(this);
            });
            e(hn, function() {
                return a(this);
            });
            e(Jn, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
            e(Un, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return X(this, n);
            });
            e(Kn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(Xn, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var d = Ne("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        In.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (ee(n) && d[n.name]) return true;
                if (n instanceof Yn && ee(n.expression)) {
                    var t = b[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        Ue.DEFMETHOD("is_call_pure", Ae);
        In.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Yn)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof et) {
                i = g.Array;
            } else if (t.is_boolean(e)) {
                i = g.Boolean;
            } else if (t.is_number(e)) {
                i = g.Number;
            } else if (t instanceof Et) {
                i = g.RegExp;
            } else if (t.is_string(e)) {
                i = g.String;
                if (r == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = g.Object;
            }
            return i && i[r];
        });
        function v(e) {
            while ((e = e.tail_node()) instanceof bt) {
                e = e.fixed_value();
                if (!e) return true;
            }
            return !(e instanceof et || e.TYPE == "Binary" && !xe[e.operator] || e instanceof wt || e instanceof un || e instanceof at && Pe(e.properties, function(e) {
                return !(e instanceof ut || e instanceof Vn);
            }) || e instanceof yt || e instanceof Wn);
        }
        (function(e) {
            function n(e, n, t) {
                return !Pe(e, t ? function(e) {
                    return e instanceof Vn ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function t(e, n) {
                return !e.expression.is_string(n) || e.expression.has_side_effects(n);
            }
            e(Ue, ze);
            e(et, function(e) {
                return n(this.elements, e, t);
            });
            e(Qn, function(e) {
                var n = this.left;
                if (!(n instanceof Bn)) return true;
                var t = n.expression;
                return !(t instanceof yt) || !t.scope.new || n instanceof Ln && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Xn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !Ee(this.right);
            });
            e(Xe, function(e) {
                return n(this.body, e);
            });
            e(In, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e, t);
            });
            e(zn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(Kn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(wt, Ae);
            e(Fn, function(e) {
                return n(this.definitions, e);
            });
            e(tt, function(e) {
                return n(this.elements, e);
            });
            e(it, function(e) {
                return this.key instanceof Ue && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(rt, function(e) {
                return n(this.properties, e);
            });
            e(Yn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Ve, Ae);
            e(Tn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Qe, function(e) {
                return this.body.has_side_effects(e);
            });
            e(un, Ae);
            e(at, function(e) {
                return n(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return v(t) || t.has_side_effects(n);
                });
            });
            e(ot, function(e) {
                return this.key instanceof Ue && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Un, function(e) {
                return n(this.expressions, e);
            });
            e(We, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Ln, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(Dn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(lt, Ae);
            e(bt, function(e) {
                return !this.is_declared(e) || !he(this);
            });
            e(yt, Ae);
            e($n, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Wn, function(e) {
                return It[this.operator] || this.expression.has_side_effects(e);
            });
            e(Pn, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(Ue, ze);
            e(wt, Ae);
            e(Ve, Ae);
            e(un, Ae);
            e(lt, Ae);
            e(yt, Ae);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(et, function(e) {
                return n(this.elements, e);
            });
            e(Qn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof bt) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(Xn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !Ee(this.right);
            });
            e(Xe, function(e) {
                return n(this.body, e);
            });
            e(In, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof un) || n(this.expression.body, e);
            });
            e(zn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(Kn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Fn, function(e) {
                return n(this.definitions, e);
            });
            e(Yn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(Tn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Qe, function(e) {
                return this.body.may_throw(e);
            });
            e(at, function(e) {
                return n(this.properties, e);
            });
            e(ot, function(e) {
                return this.key instanceof Ue && this.key.may_throw(e) || this.value.may_throw(e);
            });
            e(wn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Un, function(e) {
                return n(this.expressions, e);
            });
            e(We, function(e) {
                return this.body.may_throw(e);
            });
            e(Ln, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Dn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(bt, function(e) {
                return !this.is_declared(e);
            });
            e($n, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Wn, function(e) {
                if (this.operator == "typeof" && this.expression instanceof bt) return false;
                return this.expression.may_throw(e);
            });
            e(Pn, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(Ue, Ae);
            e(et, function() {
                return n(this.elements);
            });
            e(Xn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression() && (this.operator != "in" || Ee(this.right));
            });
            e(wt, ze);
            e(un, function(r) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new jt(function(e, n) {
                    if (!o) return true;
                    if (e instanceof Je) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof bt) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Te(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e.name);
                            if (t.undeclared ? !i : i === t) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof yt) {
                        if (s.length == 0 && a instanceof pn) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(at, function() {
                return n(this.properties);
            });
            e(ot, function() {
                return typeof this.key == "string" && this.value.is_constant_expression();
            });
            e(Wn, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function M(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Be, Me);
            e(bn, $e);
            function n() {
                var e = this.body.length;
                return e > 0 && M(this.body[e - 1]);
            }
            e(Ke, n);
            e(On, n);
            e(Tn, function() {
                return this.alternative && M(this.body) && M(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var h = Ne([ "use asm", "use strict" ]);
        e(Le, function(e, n) {
            if (n.option("directives") && (!h[e.value] || n.has_directive(e.value) !== e)) {
                return _e(Ve, e);
            }
            return e;
        });
        e(Ye, function(e, n) {
            if (n.option("drop_debugger")) return _e(Ve, e);
            return e;
        });
        e(Qe, function(e, n) {
            if (n.option("dead_code") && e.body instanceof En && n.loopcontrol_target(e.body) === e.body) {
                return _e(Ve, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Xe, function(e, n) {
            e.body = u(e.body, n);
            return e;
        });
        function y(e) {
            switch (e.body.length) {
              case 0:
                return _e(Ve, e);

              case 1:
                var n = e.body[0];
                if (!(n instanceof qn || n instanceof Cn)) return n;
            }
            return e;
        }
        e(Ke, function(e, n) {
            e.body = u(e.body, n);
            return y(e);
        });
        e(pn, function(e, n) {
            if (!n.option("arrows")) return e;
            var t = u(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var i = t[0];
                if (i instanceof wn) {
                    e.body.length = 0;
                    e.value = i.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        });
        e(hn, function(n, e) {
            n.body = u(n.body, e);
            if (e.option("inline")) for (var t = 0; t < n.body.length; t++) {
                var i = n.body[t];
                if (i instanceof Le) continue;
                if (i instanceof wn) {
                    var r = i.value;
                    if (!r || r.TYPE != "Call") break;
                    if (r.is_expr_pure(e)) break;
                    var a = r.expression;
                    if (a instanceof bt) {
                        if (n.name && n.name.definition() === a.definition()) break;
                        a = a.fixed_value();
                    }
                    if (!(a instanceof gn || a instanceof hn)) break;
                    if (a.uses_arguments) break;
                    if (a === r.expression) {
                        if (a.parent_scope !== n) break;
                        if (!Pe(a.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (a.contains_this()) break;
                    var o = a.argnames.length;
                    if (o > 0 && e.option("inline") < 2) break;
                    if (o > n.argnames.length) break;
                    if (!Pe(n.argnames, function(e) {
                        return e instanceof ht;
                    })) break;
                    if (!Pe(r.args, function(e) {
                        return !(e instanceof Vn);
                    })) break;
                    for (var s = 0; s < o; s++) {
                        var f = r.args[s];
                        if (!(f instanceof bt)) break;
                        if (f.definition() !== n.argnames[s].definition()) break;
                    }
                    if (s < o) break;
                    for (;s < r.args.length; s++) {
                        if (r.args[s].has_side_effects(e)) break;
                    }
                    if (s < r.args.length) break;
                    if (o < n.argnames.length && !e.drop_fargs(n, e.parent())) {
                        if (!e.drop_fargs(a, r)) break;
                        do {
                            a.argnames.push(a.make_var(ht, a, "argument_" + o));
                        } while (++o < n.argnames.length);
                    }
                    return r.expression;
                }
                break;
            }
            return n;
        });
        sn.DEFMETHOD("merge_variables", function(o) {
            if (!o.option("merge_vars")) return;
            var c = this, l = {}, p;
            var s = [], f = [], u = 0;
            var d = new He();
            var v = Object.create(null);
            var h = Object.create(null);
            var m = new jt(function(r, e) {
                if (r instanceof Qn) {
                    var n = r.left;
                    if (n instanceof nt) {
                        r.right.walk(m);
                        var t = new jt(function(e) {
                            if (e instanceof nt) return;
                            if (e instanceof it) {
                                if (e.key instanceof Ue) {
                                    w();
                                    e.key.walk(m);
                                    x();
                                    w();
                                    e.value.walk(t);
                                    x();
                                } else {
                                    e.value.walk(t);
                                }
                            } else if (e instanceof bt) {
                                k(e, false, true);
                            } else {
                                e.walk(m);
                            }
                            return true;
                        });
                        n.walk(t);
                        return true;
                    }
                    if (n instanceof bt) {
                        if (r.operator != "=") k(n, true, false);
                        r.right.walk(m);
                        k(n, false, true);
                        return true;
                    }
                    return;
                }
                if (r instanceof Xn) {
                    if (!xe[r.operator]) return;
                    r.left.walk(m);
                    w();
                    r.right.walk(m);
                    x();
                    return true;
                }
                if (r instanceof En) {
                    var i = m.loopcontrol_target(r);
                    if (!(i instanceof Ze)) E(i);
                    return true;
                }
                if (r instanceof In) {
                    var a = r.expression;
                    var o = a.tail_node();
                    if (!ln(o)) return;
                    if (a !== o) a.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(m);
                    });
                    r.args.forEach(function(e) {
                        e.walk(m);
                    });
                    o.walk(m);
                    return true;
                }
                if (r instanceof Kn) {
                    r.condition.walk(m);
                    w();
                    r.consequent.walk(m);
                    x();
                    w();
                    r.alternative.walk(m);
                    x();
                    return true;
                }
                if (r instanceof Sn) {
                    var i = m.loopcontrol_target(r);
                    if (i instanceof nn) E(i);
                    return true;
                }
                if (r instanceof nn) {
                    w();
                    l.block = r;
                    l.loop = true;
                    var s = l;
                    r.body.walk(m);
                    if (l.inserted === r) l = s;
                    r.condition.walk(m);
                    x();
                    return true;
                }
                if (r instanceof rn) {
                    if (r.init) r.init.walk(m);
                    w();
                    l.block = r;
                    l.loop = true;
                    if (r.condition) r.condition.walk(m);
                    r.body.walk(m);
                    if (r.step) r.step.walk(m);
                    x();
                    return true;
                }
                if (r instanceof an) {
                    r.object.walk(m);
                    w();
                    l.block = r;
                    l.loop = true;
                    r.init.walk(m);
                    r.body.walk(m);
                    x();
                    return true;
                }
                if (r instanceof Tn) {
                    r.condition.walk(m);
                    w();
                    r.body.walk(m);
                    x();
                    if (r.alternative) {
                        w();
                        r.alternative.walk(m);
                        x();
                    }
                    return true;
                }
                if (r instanceof Qe) {
                    w();
                    l.block = r;
                    var s = l;
                    r.body.walk(m);
                    if (l.inserted === r) l = s;
                    x();
                    return true;
                }
                if (r instanceof sn) {
                    w();
                    l.block = r;
                    if (r === c) p = l;
                    if (r instanceof un) {
                        if (r.name) v[r.name.definition().id] = false;
                        var t = r.uses_arguments && !m.has_directive("use strict") ? function(e) {
                            if (e instanceof ht) v[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof ht) k(e, false, true);
                        };
                        var f = new jt(function(e) {
                            if (e instanceof lt) v[e.definition().id] = false;
                            if (!(e instanceof bt)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e.name) === n)) {
                                v[n.id] = false;
                                v[t.id] = false;
                            } else {
                                var i = l;
                                x();
                                k(e, true, false);
                                l = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(t, f);
                        });
                    }
                    if (r instanceof pn && r.value) {
                        r.value.walk(m);
                    } else {
                        Ge(r, m);
                    }
                    x();
                    return true;
                }
                if (r instanceof Dn) {
                    r.expression.walk(m);
                    var s = l;
                    r.body.forEach(function(e) {
                        if (e instanceof An) return;
                        e.expression.walk(m);
                        if (s === l) w();
                    });
                    l = s;
                    r.body.forEach(function(e) {
                        w();
                        l.block = r;
                        var n = l;
                        Ge(e, m);
                        if (l.inserted === r) l = n;
                        x();
                    });
                    return true;
                }
                if (r instanceof bt) {
                    k(r, true, false);
                    return true;
                }
                if (r instanceof $n) {
                    w();
                    l.block = r;
                    Ge(r, m);
                    x();
                    if (r.bcatch) {
                        if (r.bcatch.argname) r.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof gt) {
                                var n = e.definition();
                                v[n.id] = false;
                                if (n = n.redefined()) v[n.id] = false;
                            }
                        }, m);
                        w();
                        if (r.bfinally) l.block = r.bcatch;
                        Ge(r.bcatch, m);
                        x();
                    }
                    if (r.bfinally) r.bfinally.walk(m);
                    return true;
                }
                if (r instanceof Wn) {
                    if (!Ct[r.operator]) return;
                    var u = r.expression;
                    if (!(u instanceof bt)) return;
                    k(u, true, true);
                    return true;
                }
                if (r instanceof Pn) {
                    if (r.value) r.value.walk(m);
                    r.name.mark_symbol(r.value ? function(e) {
                        if (!(e instanceof lt)) return;
                        if (e instanceof vt) {
                            k(e, false, true);
                        } else {
                            v[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof lt)) return;
                        var n = e.definition().id;
                        if (!(e instanceof vt)) {
                            v[n] = false;
                        } else if (!(n in v)) {
                            d.add(n, e);
                        } else if (v[n]) {
                            v[n].push(e);
                        }
                        return true;
                    }, m);
                    return true;
                }
                if (r instanceof tn) {
                    w();
                    l.block = r;
                    l.loop = true;
                    e();
                    x();
                    return true;
                }
            });
            m.directives = Object.create(o.directives);
            c.walk(m);
            var e = Object.create(null);
            while (s.length && f.length) {
                var n = s.pop();
                var t = n.definition;
                if (!(t.id in h)) continue;
                if (!v[t.id]) continue;
                var i = {
                    start: v[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = v[t.id].end;
                var r = [];
                do {
                    var a = f.pop();
                    if (!a) continue;
                    if (a.index > n.index) continue;
                    var _ = a.definition.id;
                    var g = v[_];
                    if (!g) continue;
                    if (i.start.block !== g.start.block || !T(i, g) || i.start.loop && !T(g, i) || !Pe(g, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(a);
                        continue;
                    }
                    var b = [], y = [];
                    g.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof bt) {
                            y.push(e);
                        } else {
                            b.push(e);
                        }
                    });
                    t.orig = b.concat(t.orig);
                    t.references = y.concat(t.references);
                    t.fixed = a.definition.fixed && t.fixed;
                    e[_] = t;
                    break;
                } while (f.length);
                if (r.length) f = f.concat(r);
            }
            function w() {
                l = Object.create(l);
            }
            function x() {
                l = Object.getPrototypeOf(l);
            }
            function k(e, n, t) {
                var i = e.definition(), r;
                if (i.id in v) {
                    var a = v[i.id];
                    if (!a) return;
                    if (a.start.block !== l.block) return v[i.id] = false;
                    a.push(e);
                    a.end = l;
                    if (i.id in h) {
                        f[h[i.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((r = c.variables.get(i.name)) !== i) {
                    if (r && p === l) v[r.id] = false;
                    return v[i.id] = false;
                } else if (o.exposed(i) || e.name == "arguments" || e.name == "await") {
                    return v[i.id] = false;
                } else {
                    var a = d.get(i.id) || [];
                    a.push(e);
                    v[i.id] = a;
                    if (!n) {
                        a.start = l;
                        return s.push({
                            index: u++,
                            definition: i
                        });
                    }
                    if (l.block !== c) return v[i.id] = false;
                    a.start = p;
                }
                h[i.id] = f.length;
                f.push({
                    index: u++,
                    definition: i
                });
            }
            function E(e) {
                var n = [];
                while (true) {
                    if (Ie(l, "block")) {
                        var t = l.block;
                        if (t instanceof Qe) t = t.body;
                        if (t === e) break;
                    }
                    n.push(l);
                    x();
                }
                l.inserted = l.block;
                w();
                while (n.length) {
                    var i = n.pop();
                    w();
                    if (Ie(i, "block")) l.block = i.block;
                    if (Ie(i, "loop")) l.loop = i.loop;
                }
            }
            function S(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function T(e, n) {
                return S(e.start, e.end) || S(e.start, n.start);
            }
        });
        sn.DEFMETHOD("drop_unused", function(k) {
            if (!k.option("unused")) return;
            var E = this;
            var S = !(E instanceof fn) || k.toplevel.funcs;
            var T = !(E instanceof fn) || k.toplevel.vars;
            var D = /keep_assign/.test(k.option("unused")) ? Ae : function(e, n) {
                var t, i = false;
                if (e instanceof Qn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof Wn) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(k.option("pure_getters"))) {
                    while (t instanceof Bn && !t.expression.may_throw_on_access(k)) {
                        if (t instanceof Ln) n.unshift(t.property);
                        t = t.expression;
                        i = true;
                    }
                }
                if (!(t instanceof bt)) return;
                if (k.exposed(t.definition())) return;
                if (!he(t, i)) return;
                return t;
            };
            var O = Object.create(null);
            var d = function(e) {
                d = o(E, 0, Oe);
                return d(e);
                function o(e, n, i) {
                    var t = k.parent(n);
                    if (!t) return i;
                    if (t instanceof it) {
                        var r = k.parent(n + 1);
                        if (t.key === e) {
                            var a = k.parent(n + 2);
                            if (a instanceof un) {
                                return o(a, n + 3, a.argnames.indexOf(r) >= 0 ? function(e) {
                                    var n = i(e);
                                    if (n) return n;
                                    n = a.variables.get(e);
                                    if (n) {
                                        var t = n.orig[0];
                                        if (t instanceof ht || t instanceof _t) return n;
                                    }
                                } : function(e) {
                                    return i(e) || a.variables.get(e);
                                });
                            }
                        }
                        return o(r, n + 2, i);
                    }
                    return o(t, n + 1, t.variables ? function(e) {
                        return i(e) || t.variables.get(e);
                    } : i);
                }
            };
            var A = Object.create(null);
            var v = [];
            var z = Object.create(null);
            var h = Object.create(null);
            var m = Object.create(null);
            if (E instanceof fn && k.top_retain) {
                E.variables.each(function(e) {
                    if (k.top_retain(e) && !(e.id in z)) {
                        z[e.id] = true;
                        v.push(e);
                    }
                });
            }
            var _ = new He();
            var $ = new He();
            var g = new He();
            var M = this;
            var b = new jt(function(a, e) {
                if (a instanceof un && a.uses_arguments && !b.has_directive("use strict")) {
                    a.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in z)) {
                            z[n.id] = true;
                            v.push(n);
                        }
                    });
                }
                if (a === E) return;
                if (M === E) {
                    if (mn(a)) {
                        var n = a.name.definition();
                        if (!S && !(n.id in z)) {
                            z[n.id] = true;
                            v.push(n);
                        }
                        g.add(n.id, a);
                        return true;
                    }
                    if (a instanceof Fn) {
                        a.definitions.forEach(function(i) {
                            var r = i.value && (i.name instanceof nt || i.value.has_side_effects(k));
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof lt)) return;
                                var n = e.definition();
                                $.add(n.id, i);
                                if (a instanceof Nn && n.orig[0] instanceof gt) {
                                    var t = n.redefined();
                                    if (t) $.add(t.id, i);
                                }
                                if (!(n.id in z) && (!T || (a instanceof qn ? n.redefined() : n.const_redefs) || !(a instanceof Nn || W(n)))) {
                                    z[n.id] = true;
                                    v.push(n);
                                }
                                if (i.value) {
                                    if (!r) g.add(n.id, i.value);
                                    _.add(n.id, i);
                                }
                                return true;
                            }, b);
                            if (r) i.value.walk(b);
                        });
                        return true;
                    }
                    if (a instanceof ht) {
                        var n = a.definition();
                        $.add(n.id, a);
                        _.add(n.id, a);
                        return true;
                    }
                }
                return t(a, e, true);
            });
            b.directives = Object.create(k.directives);
            E.walk(b);
            b = new jt(t);
            for (var e = 0; e < v.length; e++) {
                var n = g.get(v[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(b);
                });
            }
            Object.keys(O).forEach(function(e) {
                var t = O[e];
                if (!t) {
                    delete O[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Fe(n, e);
                    });
                    return n;
                }, []);
                var n = (_.get(e) || []).filter(function(n) {
                    return De(n instanceof Wn ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Wn) return false;
                        return ye(e) === ye(n);
                    }, t);
                });
                if (t.length == n.length) {
                    O[e] = n;
                } else {
                    delete O[e];
                }
            });
            var j = k.option("keep_fnames") ? Ae : k.option("ie8") ? function(e) {
                return !k.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in z)) return true;
                if (e.orig.length < 2) return false;
                if (e.orig[1] instanceof ht) return true;
                return Pe(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            var F = [];
            var q = [];
            var C = [];
            var N = new Ht(function(e) {
                if (e instanceof Hn) return l(N, e);
                if (e instanceof tt) {
                    var n = true;
                    for (var t = e.elements.length; --t >= 0; ) {
                        var i = e.elements[t].transform(N);
                        if (i) {
                            e.elements[t] = i;
                            n = false;
                        } else if (n) {
                            e.elements.pop();
                        } else {
                            e.elements[t] = _e(Ot, e.elements[t]);
                        }
                    }
                    return e;
                }
                if (e instanceof it) {
                    var r = false;
                    if (e.key instanceof Ue) {
                        e.key = e.key.transform(P);
                        r = e.key.has_side_effects(k);
                    }
                    if (r && c(e.value)) {
                        e.value = e.value.transform(P);
                    } else {
                        var a = e.value.transform(N);
                        if (!a) return je.skip;
                        e.value = a;
                    }
                    return e;
                }
                if (e instanceof lt) return e.definition().id in z ? e : null;
            });
            var P = new Ht(function(v, e, n) {
                var h = P.parent();
                if (T) {
                    var t = [], i = D(v, t);
                    if (i) {
                        var r = i.definition();
                        var a = r.id in z;
                        var o;
                        if (v instanceof Qn) {
                            if (!a || v.left === i && U(r, v) < 0) {
                                o = B(v);
                                if (v.write_only === true) {
                                    o = o.drop_side_effect_free(k) || _e(kt, v, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!a || v.expression === i && U(r, v) < 0) {
                            o = _e(kt, v, {
                                value: 0
                            });
                        }
                        if (o) {
                            if (h instanceof Un && h.tail_node() !== v) {
                                o = o.drop_side_effect_free(k);
                            }
                            if (o) t.push(o);
                            switch (t.length) {
                              case 0:
                                return je.skip;

                              case 1:
                                return ge(k, h, v, t[0].transform(P));

                              default:
                                return X(v, t.map(function(e) {
                                    return e.transform(P);
                                }));
                            }
                        }
                    } else if (v instanceof Gn && v.expression instanceof bt && U(v.expression.definition(), v) < 0) {
                        return _e(Jn, v, {
                            operator: "+",
                            expression: v.expression
                        });
                    }
                }
                if (v instanceof In) q.push(v);
                if (M !== E) return;
                if (v instanceof un) {
                    if (S && v !== E && mn(v)) {
                        var r = v.name.definition();
                        if (!(r.id in z)) {
                            H(v.name, "Dropping unused function {name}");
                            r.eliminated++;
                            return n ? je.skip : _e(Ve, v);
                        }
                    }
                    if (ln(v) && v.name && j(v.name.definition())) {
                        F.push(v);
                    }
                    if (!(v instanceof cn)) {
                        var s = k.drop_fargs(v, h);
                        for (var f = v.argnames, u = f.length; --u >= 0; ) {
                            var i = f[u];
                            if (!(i instanceof ht)) {
                                var c = i.transform(N);
                                if (c) {
                                    s = false;
                                } else if (s) {
                                    H(i.name, "Dropping unused function argument {name}");
                                    f.pop();
                                } else {
                                    i.name.__unused = true;
                                    f[u] = i.name;
                                }
                                continue;
                            }
                            var r = i.definition();
                            if (r.id in z) {
                                s = false;
                                if (U(r, i) < 0) i.__unused = null;
                            } else if (s) {
                                H(i, "Dropping unused function argument {name}");
                                f.pop();
                            } else {
                                i.__unused = true;
                            }
                        }
                        C.push(v);
                    }
                }
                if (v instanceof Mn && v.argname instanceof nt) {
                    v.argname.transform(N);
                }
                if (v instanceof Fn && !(h instanceof an && h.init === v)) {
                    var m = [], _ = [], g = [];
                    var b = [];
                    var y = 0;
                    var w = v instanceof Nn;
                    v.definitions.forEach(function(n) {
                        if (n.value) n.value = n.value.transform(P);
                        if (n.name instanceof nt) {
                            var e = L(n.name, n.value, function(e) {
                                if (!T) return e;
                                if (e.definition().id in z) return e;
                                if (c(e)) return e;
                                if (w && !he(e)) return e;
                                return null;
                            });
                            if (e) {
                                d();
                            } else {
                                var t = n.value.drop_side_effect_free(k);
                                if (t) b.push(t);
                            }
                            return;
                        }
                        var i = n.name.definition();
                        var r = w ? he(n.name) : W(i);
                        if (!r || !T || i.id in z) {
                            if (n.value && U(i, n) < 0) {
                                var a = n.value.write_only;
                                var t = n.value.drop_side_effect_free(k);
                                if (n.value !== t) {
                                    n.value = t && X(n.value, [ t, _e(kt, n.value, {
                                        value: 0
                                    }) ]);
                                } else if (n.value.write_only !== a) {
                                    n.value.write_only = a;
                                }
                            }
                            var o, s = $.get(i.id);
                            if (!n.value && !(v instanceof Cn)) {
                                if (r && s.length > 1) {
                                    Ue.info("Dropping declaration of variable {name} [{file}:{line},{col}]", I(n.name));
                                    Ce(s, n);
                                    i.eliminated++;
                                } else {
                                    _.push(n);
                                }
                            } else if (k.option("functions") && !k.option("ie8") && !(v instanceof qn || v instanceof Cn) && s.length == 1 && i.assignments == 0 && n.value instanceof hn && (i.references.length ? Pe(i.references, function(e) {
                                return n.value === e.fixed_value();
                            }) : n.value === n.name.fixed_value()) && (!n.value.name || (o = n.value.name.definition()).assignments == 0 && (o.name == n.name.name || Pe(o.references, function(e) {
                                return e.scope.find_variable(n.name.name) === n.name.definition();
                            }))) && p() && l(n.value, n.name.name)) {
                                Ue.warn("Declaring {name} as function [{file}:{line},{col}]", I(n.name));
                                var f = _e(gn, n, n.value);
                                f.name = _e(mt, n.name, n.name);
                                var u = n.name.scope.resolve().def_function(f.name);
                                if (o) o.references.forEach(function(e) {
                                    e.name = u.name;
                                    e.thedef = u;
                                    e.reference({});
                                });
                                m.push(f);
                            } else {
                                if (r && s.length > 1 && i.orig.indexOf(n.name) > i.eliminated) {
                                    Ce(s, n);
                                    y++;
                                }
                                d();
                            }
                        } else if (c(n.name)) {
                            var t = n.value && n.value.drop_side_effect_free(k);
                            if (t) b.push(t);
                            var s = $.get(i.id);
                            if (s.length > 1) {
                                Ue.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", I(n.name));
                                Ce(s, n);
                                i.eliminated++;
                            } else {
                                n.value = null;
                                _.push(n);
                            }
                        } else {
                            var t = n.value && !n.value.single_use && n.value.drop_side_effect_free(k);
                            if (t) {
                                Ue.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", I(n.name));
                                b.push(t);
                            } else {
                                H(n.name, "Dropping unused variable {name}");
                            }
                            i.eliminated++;
                        }
                        function c(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof gt && n.scope.resolve() === e.scope.resolve();
                        }
                        function l(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                        function p() {
                            if (k.has_directive("use strict")) return h instanceof sn;
                            return h instanceof Xe || h instanceof rn && h.init === v || h instanceof Tn;
                        }
                        function d() {
                            if (b.length > 0) {
                                if (g.length == 0) {
                                    m.push(_e(We, v, {
                                        body: X(v, b)
                                    }));
                                } else if (n.value) {
                                    b.push(n.value);
                                    n.value = X(n.value, b);
                                } else {
                                    n.value = _e(Jn, n, {
                                        operator: "void",
                                        expression: X(n, b)
                                    });
                                }
                                b = [];
                            }
                            g.push(n);
                        }
                    });
                    switch (_.length) {
                      case 0:
                        if (g.length == 0) break;
                        if (g.length == y) {
                            [].unshift.apply(b, g.map(function(e) {
                                Ue.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", I(e.name));
                                var n = e.name.definition();
                                var t = _e(bt, e.name, e.name);
                                n.references.push(t);
                                var i = _e(Qn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = U(n, e);
                                if (r >= 0) O[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (g.length == 0) {
                            var l = _[0].name.definition().id;
                            if (l in A) {
                                v.definitions = _;
                                A[l].init = v;
                                break;
                            }
                        }

                      default:
                        v.definitions = _.concat(g);
                        m.push(v);
                    }
                    if (b.length > 0) {
                        m.push(_e(We, v, {
                            body: X(v, b)
                        }));
                    }
                    return R(m, v, n);
                }
                if (v instanceof Qn) {
                    e(v, P);
                    if (v.left instanceof nt) {
                        var p = L(v.left, v.right, function(e) {
                            return e;
                        });
                        if (!p) return v.right;
                        v.left = p;
                    }
                    return v;
                }
                if (v instanceof Qe && v.body instanceof rn) {
                    e(v, P);
                    if (v.body instanceof Ke) {
                        var d = v.body;
                        v.body = d.body.pop();
                        d.body.push(v);
                        return n ? je.splice(d.body) : d;
                    }
                    return v;
                }
                if (v instanceof sn) {
                    var x = M;
                    M = v;
                    e(v, P);
                    M = x;
                    return v;
                }
            }, function(e, n) {
                if (e instanceof Ke) switch (e.body.length) {
                  case 0:
                    return n ? je.skip : _e(Ve, e);

                  case 1:
                    var t = e.body[0];
                    if (!(t instanceof qn || t instanceof Cn)) return t;
                } else if (e instanceof rn) {
                    var i;
                    if (e.init instanceof Ke) {
                        i = e.init;
                        e.init = i.body.pop();
                        i.body.push(e);
                    }
                    if (e.init instanceof gn) {
                        if (!i) {
                            i = _e(Ke, e, {
                                body: [ e ]
                            });
                        }
                        i.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof We) {
                        e.init = e.init.body;
                    } else if (Q(e.init)) {
                        e.init = null;
                    }
                    return !i ? e : n ? je.splice(i.body) : i;
                } else if (e instanceof an) {
                    if (!T || !k.option("loops")) return;
                    if (!Q(e.body)) return;
                    var r = Y(e);
                    if (!r) return;
                    var a = r.definition();
                    if (a.id in z) return;
                    H(r, "Dropping unused loop variable {name}");
                    if (A[a.id] === e) delete A[a.id];
                    var o = [];
                    var s = e.object.drop_side_effect_free(k);
                    if (s) {
                        Ue.warn("Side effects in object of for-in loop [{file}:{line},{col}]", s.start);
                        o.push(_e(We, e, {
                            body: s
                        }));
                    }
                    if (e.init instanceof Fn && a.orig[0] instanceof gt) {
                        o.push(e.init);
                    }
                    return R(o, e, n);
                } else if (e instanceof Un) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            P.push(k.parent());
            E.transform(P);
            if (E instanceof un && E.body.length == 1 && E.body[0] instanceof Le && E.body[0].value == "use strict") {
                E.body.length = 0;
            }
            F.forEach(function(e) {
                e.name = null;
            });
            q.forEach(function(e) {
                se(e, k, C);
            });
            function H(e, n) {
                Ue[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", I(e));
            }
            function I(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function R(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? je.skip : _e(Ve, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? je.splice(e) : _e(Ke, n, {
                        body: e
                    });
                }
            }
            function y(e, n) {
                if (e.scope !== E) return false;
                if (!e.fixed || !n.fixed) O[e.id] = false;
                return O[e.id] !== false;
            }
            function w(e, n) {
                if (!O[e.id]) O[e.id] = [];
                if (n.fixed.assigns) Fe(O[e.id], n.fixed.assigns);
            }
            function U(e, n) {
                var t = O[e.id];
                return t && t.indexOf(n);
            }
            function x(e, n, t) {
                if (e.id in z) return;
                if (n && t) {
                    z[e.id] = true;
                    v.push(e);
                } else {
                    h[e.id] = n;
                    m[e.id] = t;
                }
            }
            function B(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Xn && xe[n.operator])) return n;
                if (!(n.left instanceof bt)) return n;
                if (!(e.left instanceof bt)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(k)) return n;
                if (y(t, n.left)) w(t, n.left);
                return n.right;
            }
            function Y(e) {
                var n = e.init;
                if (n instanceof Fn) {
                    n = n.definitions[0].name;
                    return n instanceof lt && n;
                }
                while (n instanceof Bn) n = n.expression.tail_node();
                if (n instanceof bt) return n;
            }
            function t(e, n, t) {
                if (e instanceof Qn && e.left instanceof bt) {
                    var i = e.left.definition();
                    if (i.scope === E) _.add(i.id, e);
                }
                if (e instanceof Wn && e.expression instanceof bt) {
                    var i = e.expression.definition();
                    if (i.scope === E) _.add(i.id, e);
                }
                var r, a = [], o = D(e, a);
                if (o && E.variables.get(o.name) === (r = o.definition()) && !(ve(r) && !Pe(E.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof ht) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    a.forEach(function(e) {
                        e.walk(b);
                    });
                    if (e instanceof Qn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(k)) return;
                        var s = B(e);
                        if (t && e.write_only === true && r.scope === E && !s.has_side_effects(k)) {
                            g.add(r.id, s);
                        } else {
                            s.walk(b);
                        }
                        if (e.left === o) {
                            if (!e.write_only) {
                                x(r, true, m[r.id]);
                            }
                        } else {
                            var f = o.fixed_value();
                            if (!f || !f.is_constant()) {
                                x(r, h[r.id], true);
                            }
                        }
                    }
                    if (y(r, o) && ke(o, e) !== o) w(r, o);
                    return true;
                }
                if (e instanceof an) {
                    if (e.init instanceof bt && M === E) {
                        var u = e.init.definition().id;
                        if (!(u in A)) A[u] = e;
                    }
                    if (!T || !k.option("loops")) return;
                    if (!Q(e.body)) return;
                    if (e.init.has_side_effects(k)) return;
                    var o = Y(e);
                    if (!o) return;
                    var i = o.definition();
                    if (i.scope !== E) {
                        var c = d(o.name);
                        if ((c && c.redefined() || c) === i) return;
                    }
                    e.object.walk(b);
                    return true;
                }
                if (e instanceof bt) {
                    r = e.definition();
                    if (!(r.id in z)) {
                        z[r.id] = true;
                        v.push(r);
                    }
                    if (V(r.scope, e.scope)) {
                        var l = r.redefined();
                        if (l && !(l.id in z)) {
                            z[l.id] = true;
                            v.push(l);
                        }
                    }
                    if (y(r, e)) w(r, e);
                    return true;
                }
                if (e instanceof sn) {
                    var p = M;
                    M = e;
                    n();
                    M = p;
                    return true;
                }
            }
            function c(e) {
                return (e instanceof Hn ? e.name : e) instanceof lt;
            }
            function l(e, n) {
                n.value = n.value.transform(P);
                var t = n.name.transform(e);
                if (!t) {
                    var i = n.value.drop_side_effect_free(k);
                    if (!i) return null;
                    t = n.name;
                    if (t instanceof nt) {
                        t = t.clone();
                        t[t instanceof tt ? "elements" : "properties"] = [];
                        if (!(i instanceof et || i.is_string(k) || t instanceof rt && (i instanceof at || i.is_boolean(k) || i.is_number(k)))) {
                            i = _e(et, i, {
                                elements: [ i ]
                            });
                        }
                        n.name = t;
                    } else {
                        H(t, "Side effects in default value of unused variable {name}");
                    }
                    n.value = i;
                }
                return n;
            }
            function L(e, s, f) {
                var u = new Ht(function(e) {
                    if (e instanceof Hn) {
                        if (k.option("default_values") && s && s.is_defined(k)) {
                            e = e.name;
                        } else {
                            return l(u, e);
                        }
                    }
                    if (e instanceof tt) {
                        var n = s;
                        if (s instanceof bt) s = s.fixed_value();
                        var i = s instanceof et && s.elements;
                        var t = [];
                        e.elements.forEach(function(e, n) {
                            if (e instanceof Ot) return;
                            s = i && i[n];
                            e = e.transform(u);
                            if (e) t[n] = e;
                        });
                        s = n;
                        if (i && t.length == 0) return null;
                        for (var r = t.length; --r >= 0; ) {
                            if (!t[r]) t[r] = _e(Ot, e.elements[r] || e);
                        }
                        e.elements = t;
                        return e;
                    }
                    if (e instanceof rt) {
                        var n = s;
                        if (s instanceof bt) s = s.fixed_value();
                        var i;
                        if (s instanceof at) {
                            i = Object.create(null);
                            for (var r = 0; r < s.properties.length; r++) {
                                var a = s.properties[r];
                                if (typeof a.key != "string") {
                                    i = null;
                                    break;
                                }
                                i[a.key] = a.value;
                            }
                        }
                        var o = [];
                        e.properties.forEach(function(e) {
                            var n;
                            if (e.key instanceof Ue) {
                                e.key = e.key.transform(P);
                                s = null;
                                n = e.key.has_side_effects(k);
                            } else {
                                s = i && i[e.key];
                                n = false;
                            }
                            if (n && c(e.value)) {
                                e.value = e.value.transform(P);
                                o.push(e);
                            } else {
                                var t = e.value.transform(u);
                                if (t) {
                                    e.value = t;
                                    o.push(e);
                                }
                            }
                        });
                        s = n;
                        if (o.length == 0 && s && !s.may_throw_on_access(k)) {
                            return null;
                        }
                        e.properties = o;
                        return e;
                    }
                    return f(e);
                });
                return e.transform(u);
            }
        });
        sn.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var a = r.option("hoist_funs");
            var o = r.option("hoist_vars");
            var s = this;
            if (o) {
                var n = 0;
                s.walk(new jt(function(e) {
                    if (n > 1) return true;
                    if (e instanceof sn && e !== s) return true;
                    if (e instanceof Nn) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) o = false;
            }
            if (!a && !o) return;
            var f = Object.create(null);
            var u = [];
            var c = [];
            var l = new He(), p = 0;
            var d = new Ht(function(e) {
                if (e === s) return;
                if (e instanceof Le) {
                    u.push(e);
                    return _e(Ve, e);
                }
                if (a && e instanceof gn && (d.parent() === s || !r.has_directive("use strict"))) {
                    c.push(e);
                    return _e(Ve, e);
                }
                if (o && e instanceof Nn) {
                    if (!Pe(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof vt && !f[n.name] && s.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        l.set(e.name.name, e);
                        ++p;
                    });
                    var n = e.to_assignments();
                    var t = d.parent();
                    if (t instanceof an && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return _e(bt, i, i);
                    }
                    if (t instanceof rn && t.init === e) return n;
                    if (!n) return _e(Ve, e);
                    return _e(We, e, {
                        body: n
                    });
                }
                if (e instanceof sn) return e;
                if (e instanceof pt) {
                    f[e.name] = true;
                    return e;
                }
            });
            s.transform(d);
            if (p > 0) {
                var v = [];
                l.each(function(e, n) {
                    if (s instanceof un && !Pe(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        l.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        v.push(e);
                        l.set(n, e);
                    }
                });
                if (v.length > 0) {
                    h(s.body);
                    v = _e(Nn, s, {
                        definitions: v
                    });
                    c.push(v);
                }
            }
            s.body = u.concat(c, s.body);
            function h(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof We) {
                        var t = n.body, i, r;
                        if (t instanceof Qn && t.operator == "=" && (i = t.left) instanceof ct && l.has(i.name)) {
                            var a = l.get(i.name);
                            if (a.value) break;
                            a.value = t.right;
                            Ce(v, a);
                            v.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof Un && (r = t.expressions[0]) instanceof Qn && r.operator == "=" && (i = r.left) instanceof ct && l.has(i.name)) {
                            var a = l.get(i.name);
                            if (a.value) break;
                            a.value = r.right;
                            Ce(v, a);
                            v.push(a);
                            n.body = X(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof Ve) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof Ke && !h(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function w(n, t) {
            n.walk(new jt(function(e) {
                if (e instanceof wn) {
                    t(e);
                    return true;
                }
                if (e instanceof sn && e !== n) return true;
            }));
        }
        function E(e) {
            var i = Object.create(null);
            w(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof bt) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function S(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function j(e, i) {
            w(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? X(e.value, [ n, _e(kt, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof Ue)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? X(e.value, [ n, _e(kt, e.value, {
                            value: 1
                        }) ]) : _e(kt, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        sn.DEFMETHOD("process_boolean_returns", Oe);
        gn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = E(this);
            if (!S(this.name.definition(), n, e)) return;
            j(this, e);
        });
        hn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = E(this);
            if (this.name && !S(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof Qn) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof bt)) return;
                if (!S(i.definition(), n, e)) return;
            } else if (t instanceof In && t.expression !== this) {
                var r = t.expression;
                if (r instanceof bt) r = r.fixed_value();
                if (!(r instanceof un)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i instanceof Hn) i = i.name;
                if (i instanceof ht && !S(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            j(this, e);
        });
        Je.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        sn.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof lt) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (Te(n, i)) return;
                do {
                    Fe(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var r = t;
            for (var a = 0; !Pe(i, function(e) {
                return !e.var_names()[r];
            }); a++) r = t + "$" + a;
            var o = _e(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(o);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names()[r] = true;
            });
            return o;
        });
        sn.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof fn && e.top_retain || Ae;
            var u = Object.create(null);
            f.transform(new Ht(function(i, e) {
                if (i instanceof Qn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new He();
                    var a = [];
                    var o = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        o.push(_e(Pn, i, {
                            name: n,
                            value: null
                        }));
                        var t = _e(bt, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        a.push(_e(Qn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, _e(Nn, i, {
                        definitions: o
                    }));
                    return X(i, a);
                }
                if (i instanceof sn) return i === f ? undefined : i;
                if (i instanceof Pn) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new He();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(_e(Pn, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return je.splice(n);
                }
                function s(e, n) {
                    var t = f.make_var(vt, e, e.name + "_" + n);
                    r.set(n, t.definition());
                    return t;
                }
            }));
            f.transform(new Ht(function(i, e) {
                if (i instanceof Xn) return a("right");
                if (i instanceof Bn) {
                    if (!(i.expression instanceof bt)) return;
                    var n = u[i.expression.definition().id];
                    if (!n) return;
                    var t = n.get(i.getProperty());
                    var r = _e(bt, i, {
                        name: t.name,
                        scope: i.expression.scope,
                        thedef: t
                    });
                    r.reference({});
                    return r;
                }
                if (i instanceof Wn) {
                    if (It[i.operator]) return;
                    return a("expression");
                }
                function a(e) {
                    var n = i[e];
                    if (!(n instanceof bt)) return;
                    if (!(n.definition().id in u)) return;
                    var t = i.clone();
                    t[e] = _e(at, n, {
                        properties: []
                    });
                    return t;
                }
            }));
            function t(e, n, t) {
                if (!(e instanceof ct)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof at && n.properties.length > 0 && Pe(n.properties, function(e) {
                    return e instanceof st && typeof e.key == "string";
                }) && Pe(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && he(e);
            }
        });
        function ae(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return Pe(t.references, function(e) {
                return !(e instanceof bt);
            });
        }
        (function(e) {
            function u(e, n, t, i) {
                var r = e.length;
                if (!r) return null;
                var a = [], o = false;
                for (var s = 0; s < r; s++) {
                    var f = e[s];
                    var u;
                    if (i && f instanceof Vn) {
                        u = i(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return o ? a.length ? a : null : e;
            }
            function c(e, n, t) {
                var i = e.expression;
                if (!i.is_string(n)) return e;
                return i.drop_side_effect_free(n, t);
            }
            function l(e) {
                return e instanceof Vn ? _e(et, e, {
                    elements: [ e ]
                }) : e;
            }
            e(Ue, $e);
            e(cn, Me);
            e(et, function(e, n) {
                var t = u(this.elements, e, n, c);
                if (!t) return null;
                if (t === this.elements && Pe(t, function(e) {
                    return e instanceof Vn;
                })) return this;
                return X(this, t.map(l));
            });
            e(pn, Me);
            e(Qn, function(e) {
                var n = this.left;
                if (n instanceof Bn) {
                    var t = n.expression;
                    if (t instanceof Qn && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (be(n).is_constant_expression(e.find_parent(sn))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(vn, Me);
            e(Xn, function(e, n) {
                if (this.operator == "in" && !Ee(this.right)) {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (t === this.left) return this;
                    var i = this.clone();
                    i.left = t || _e(kt, this.left, {
                        value: 0
                    });
                    return i;
                }
                var r = this.right.drop_side_effect_free(e, n);
                if (!r) return this.left.drop_side_effect_free(e, n);
                if (xe[this.operator] && !(r instanceof hn)) {
                    var i = this;
                    if (r !== i.right) {
                        i = this.clone();
                        i.right = r.drop_side_effect_free(e);
                    }
                    return (n ? a : te)(i, _e(Xn, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (!t) return r;
                    return X(this, [ t, r.drop_side_effect_free(e) ]);
                }
            });
            e(In, function(t, e) {
                var n = this;
                if (n.is_expr_pure(t)) {
                    if (n.pure) Ue.warn("Dropping __PURE__ call [{file}:{line},{col}]", n.start);
                    var i = u(n.args, t, e, c);
                    return i && X(n, i.map(l));
                }
                var r = n.expression;
                if (n.is_call_pure(t)) {
                    var a = n.args.slice();
                    a.unshift(r.expression);
                    a = u(a, t, e, c);
                    return a && X(n, a.map(l));
                }
                var o;
                if (r instanceof hn && !(r.name && (o = r.name.definition()).references.length > o.replaced)) {
                    r.process_expression(false, function(e) {
                        var n = e.value && e.value.drop_side_effect_free(t, true);
                        return n ? _e(We, e, {
                            body: n
                        }) : _e(Ve, e);
                    });
                    w(r, function(e) {
                        if (e.value) e.value = e.value.drop_side_effect_free(t);
                    });
                    n = n.clone();
                    n.expression = r.clone();
                }
                if (n instanceof Rn) {
                    var s = r;
                    if (s instanceof bt) s = s.fixed_value();
                    if (s instanceof un) {
                        s.new = true;
                        var f = Pe(s.body, function(e) {
                            return !e.has_side_effects(t);
                        });
                        delete s.new;
                        if (f) {
                            var a = n.args.slice();
                            a.unshift(r);
                            a = u(a, t, e, c);
                            return a && X(n, a.map(l));
                        }
                        if (!s.contains_this()) return _e(In, n, n);
                    }
                }
                return n;
            });
            e(Kn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof hn) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof hn) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? _e(Xn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = _e(Xn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : X(this, i);
            });
            e(wt, Me);
            e(Yn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(hn, function(e) {
                return ae(this, e) ? null : this;
            });
            e(at, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Vn) {
                        t.push(e);
                    } else {
                        if (e.key instanceof Ue) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var i = u(t, e, n, function(e, n, t) {
                    var i = e.expression;
                    return v(i) ? e : i.drop_side_effect_free(n, t);
                });
                if (!i) return null;
                if (i === t && !Pe(i, function(e) {
                    return !(e instanceof Vn);
                })) return this;
                return X(this, i.map(function(e) {
                    return e instanceof Vn ? _e(at, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Un, function(e, n) {
                var t = u(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r, a, o;
                if (e.option("conditionals") && i > 0 && (r = t[i - 1]) instanceof Qn && r.operator == "=" && (o = r.left) instanceof bt && (a = R(e, o.definition(), r.right, t[i]))) {
                    r = r.clone();
                    r.right = a;
                    t = t.slice(0, -2);
                    t.push(r);
                }
                return t === this.expressions ? this : X(this, t);
            });
            e(Ln, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return X(this, [ t, i ]);
            });
            e(bt, function(e) {
                return this.is_declared(e) && he(this) ? null : this;
            });
            e(yt, Me);
            e(Wn, function(e, n) {
                var t = this.expression;
                if (It[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof bt && he(t)) return null;
                var i = t.drop_side_effect_free(e, n);
                if (n && i && Z(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(We, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    Ue.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return _e(Ve, e);
                }
                if (i !== t) {
                    return _e(We, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(tn, function(e, n) {
            return n.option("loops") ? _e(rn, e, e).optimize(n) : e;
        });
        function F(n, e, t) {
            if (!t) t = kn;
            var i = false;
            var r = new jt(function(e) {
                if (i || e instanceof sn) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof Qe) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(nn, function(t, e) {
            if (!e.option("loops")) return t;
            var n = t.condition.is_truthy() || t.condition.evaluate(e, true);
            if (!(n instanceof Ue)) {
                if (n && !F(t, e.parent(), Sn)) return _e(rn, t, {
                    body: _e(Ke, t.body, {
                        body: [ t.body, _e(We, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!F(t, e.parent())) return _e(Ke, t.body, {
                    body: [ t.body, _e(We, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof Ke && !F(t, e.parent(), Sn)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a instanceof Tn && !a.alternative && a.body instanceof En && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = _e(Xn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (a instanceof We) {
                        if (o(a.body)) break;
                        t.condition = X(t, [ a.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!$(a)) {
                        break;
                    }
                }
                t.body = y(t.body);
            }
            if (t.body instanceof Ve) return _e(rn, t, t).optimize(e);
            if (t.body instanceof We) return _e(rn, t, {
                condition: X(t.condition, [ t.body.body, t.condition ]),
                body: _e(Ve, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new jt(function(e) {
                    if (n) return true;
                    if (e instanceof bt) {
                        if (!Te(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function q(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof En || e instanceof Sn && s(e) || e instanceof yn)) {
                var i = [];
                if (n.init instanceof Be) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(_e(We, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof yn;
                if (n.condition && r) {
                    i.push(_e(Tn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(_e(We, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                k(t, n.body, i);
                return _e(Ke, n, {
                    body: i
                });
            }
            if (e instanceof Tn) {
                var a = o(e.body);
                if (a instanceof En && !s(a)) {
                    if (n.condition) {
                        n.condition = _e(Xn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = A(e.alternative);
                    k(t, e.body, i);
                    return f(i);
                }
                a = o(e.alternative);
                if (a instanceof En && !s(a)) {
                    if (n.condition) {
                        n.condition = _e(Xn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = A(e.body);
                    k(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function o(e) {
                return e instanceof Ke ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof Ke) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = _e(Ke, n.body, {
                        body: e
                    }).transform(t);
                }
                return q(n, t);
            }
        }
        e(rn, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof Ue) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = O(t, e.condition);
                    e.condition = te(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (e.init instanceof Be) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(_e(We, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(_e(We, e.condition, {
                            body: e.condition
                        }));
                        k(n, e.body, r);
                        return _e(Ke, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof Ue)) {
                    e.body = _e(Ke, e.body, {
                        body: [ _e(We, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return q(e, n);
        });
        e(an, function(e, n) {
            if (n.option("varify") && (e.init instanceof qn || e.init instanceof Cn)) {
                var t = e.init.definitions[0].name;
                if ((t instanceof nt || t instanceof dt) && !t.match_symbol(function(e) {
                    if (e instanceof lt) return P(n, e.definition());
                }, true)) {
                    e.init = H(e.init);
                }
            }
            return e;
        });
        function C(e, n, t) {
            if (!(e instanceof Xn)) return;
            if (!(e.left instanceof xt)) {
                switch (e.operator) {
                  case "&&":
                    C(e.left, n);
                    C(e.right, n);
                    break;

                  case "||":
                    C(f(e.left), t);
                    C(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof Jn)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!ee(i)) return;
            var r;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = a ? t : n;
                break;

              case "!=":
                r = a ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var o = i.definition();
            var s = new jt(function(e) {
                if (e instanceof sn) {
                    var n = s.parent();
                    if (n instanceof In && n.expression === e) return;
                    return true;
                }
                if (e instanceof bt && e.definition() === o) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof Xn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(Tn, function(e, f) {
            if (Q(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof Ue)) {
                var t = e.condition;
                e.condition = O(n, t);
                e.condition = te(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof Ue) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    Ue.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [ _e(We, e.condition, {
                        body: e.condition
                    }) ];
                    k(f, e.body, i);
                    if (e.alternative) i.push(e.alternative);
                    return _e(Ke, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof Ue)) {
                    Ue.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [ _e(We, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) k(f, e.alternative, i);
                    return _e(Ke, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var a = e.condition.print_to_string().length;
            var o = r.print_to_string().length;
            var s = o < a;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || _e(Ve, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = m(e.body, i, c, l);
            var d = m(e.alternative, i, c, l);
            if (p && d) {
                if (c.length > 0) i.push(_e(Nn, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(_e(We, e.condition, {
                        body: d.length > 0 ? _e(Xn, e, {
                            operator: "||",
                            left: e.condition,
                            right: X(e.alternative, d)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (d.length == 0) {
                    if (a === o && !s && e.condition instanceof Xn && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(_e(We, e, {
                        body: _e(Xn, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: X(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(_e(We, e, {
                        body: _e(Kn, e, {
                            condition: e.condition,
                            consequent: X(e.body, p),
                            alternative: X(e.alternative, d)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return _e(Ke, e, {
                    body: i
                }).optimize(f);
            }
            if (Q(e.body)) {
                e = _e(Tn, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof yn && e.alternative instanceof yn && e.body.TYPE == e.alternative.TYPE) {
                var v = _e(e.body.CTOR, e, {
                    value: _e(Kn, e, {
                        condition: e.condition,
                        consequent: e.body.value || _e(Dt, e.body).transform(f),
                        alternative: e.alternative.value || _e(Dt, e.alternative).transform(f)
                    })
                });
                if (v instanceof wn) {
                    v.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return v;
            }
            if (e.body instanceof Tn && !e.body.alternative && !e.alternative) {
                e = _e(Tn, e, {
                    condition: _e(Xn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (M(e.body)) {
                if (e.alternative) {
                    var h = e.alternative;
                    e.alternative = null;
                    return _e(Ke, e, {
                        body: [ e, h ]
                    }).optimize(f);
                }
            }
            if (M(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return _e(Ke, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) C(e.condition, e.body, e.alternative);
            return e;
            function m(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof Ke) {
                    var r = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof gn) {
                            n.push(o);
                        } else if (o instanceof Ve) {
                            continue;
                        } else if (o instanceof We) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(o.body);
                        } else if (o instanceof Nn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            o.remove_initializers(f, t);
                            o.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof gn) {
                    n.push(e);
                    return [];
                }
                if (e instanceof Ve) return [];
                if (e instanceof We) return [ e.body ];
                if (e instanceof Nn) {
                    var r = [];
                    e.remove_initializers(f, t);
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    if (!e.value) return;
                    r.push(_e(Qn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(bt, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(Dn, function(i, t) {
            if (!t.option("switches")) return i;
            var e;
            var n = i.expression.evaluate(t);
            if (!(n instanceof Ue)) {
                var r = i.expression;
                i.expression = O(n, r);
                i.expression = te(i.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return i;
            if (n instanceof Ue) {
                n = i.expression.evaluate(t, true);
            }
            var a = [];
            var o = [];
            var s;
            var f;
            for (var u = 0, c = i.body.length; u < c && !f; u++) {
                e = i.body[u];
                if (e instanceof An) {
                    var l = o[o.length - 1];
                    if (s || b(e.body[0], t) && (!l || M(l))) {
                        w(e, l);
                        continue;
                    } else {
                        s = e;
                    }
                } else if (!(n instanceof Ue)) {
                    var p = e.expression.evaluate(t);
                    if (!(p instanceof Ue) && p !== n) {
                        w(e, o[o.length - 1]);
                        continue;
                    }
                    if (p instanceof Ue) p = e.expression.evaluate(t, true);
                    if (p === n) {
                        f = e;
                        if (s) {
                            var d = o.indexOf(s);
                            o.splice(d, 1);
                            w(s, o[d - 1]);
                            s = null;
                        }
                    }
                }
                if (M(e)) {
                    var l = o[o.length - 1];
                    if (M(l) && l.body.length == e.body.length && _e(Ke, l, l).equivalent_to(_e(Ke, e, e))) {
                        l.body = [];
                    }
                }
                o.push(e);
            }
            while (u < c) w(i.body[u++], o[o.length - 1]);
            while (e = o[o.length - 1]) {
                var v = e.body[e.body.length - 1];
                if (b(v, t)) e.body.pop();
                if (e === s) {
                    if (!x(e)) break;
                } else if (e.expression.has_side_effects(t)) {
                    break;
                } else if (s) {
                    if (!x(s)) break;
                    if (o[o.length - 2] !== s) break;
                    s.body = s.body.concat(e.body);
                    e.body = [];
                } else if (!x(e)) break;
                w(e);
                if (o.pop() === s) s = null;
            }
            if (o.length == 0) {
                return _e(Ke, i, {
                    body: a.concat(_e(We, i.expression, {
                        body: i.expression
                    }))
                }).optimize(t);
            }
            o[0].body = a.concat(o[0].body);
            i.body = o;
            if (t.option("conditionals")) switch (o.length) {
              case 1:
                if (!y(o[0])) break;
                var p = o[0].expression;
                var h = o[0].body.slice();
                if (o[0] !== s && o[0] !== f) return _e(Tn, i, {
                    condition: _e(Xn, i, {
                        operator: "===",
                        left: i.expression,
                        right: p
                    }),
                    body: _e(Ke, i, {
                        body: h
                    }),
                    alternative: null
                }).optimize(t);
                if (p) h.unshift(_e(We, p, {
                    body: p
                }));
                h.unshift(_e(We, i.expression, {
                    body: i.expression
                }));
                return _e(Ke, i, {
                    body: h
                }).optimize(t);

              case 2:
                if (!Te(s, o) || !y(o[1])) break;
                var h = o[0].body.slice();
                var m = h.length && b(h[h.length - 1], t);
                if (m) h.pop();
                if (!Pe(h, y)) break;
                var _ = o[1].body.length && _e(Ke, o[1], o[1]);
                var g = _e(Tn, i, {
                    condition: _e(Xn, i, o[0] === s ? {
                        operator: "!==",
                        left: i.expression,
                        right: o[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: o[0].expression
                    }),
                    body: _e(Ke, o[0], {
                        body: h
                    }),
                    alternative: m && _ || null
                });
                if (!m && _) g = _e(Ke, i, {
                    body: [ g, _ ]
                });
                return g.optimize(t);
            }
            return i;
            function b(e, n) {
                return e instanceof En && n.loopcontrol_target(e) === i;
            }
            function y(e) {
                var n = false;
                var t = new jt(function(e) {
                    if (n || e instanceof un || e instanceof We) return true;
                    if (b(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function w(e, n) {
                if (n && !M(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    k(t, e, a);
                }
            }
        });
        e($n, function(e, n) {
            e.body = u(e.body, n);
            if (n.option("dead_code")) {
                if (x(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof gt && !he(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        k(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof Nn)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(_e(Ke, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(_e(Ke, e.bfinally, e.bfinally).optimize(n));
                    }
                    return _e(Ke, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && x(e.bfinally)) {
                    var t = _e(Ke, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return _e(Ke, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function N(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof lt) t.push(_e(Pn, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        qn.DEFMETHOD("remove_initializers", N(function(e, n) {
            return _e(Dt, n).optimize(e);
        }));
        Cn.DEFMETHOD("remove_initializers", N(Me));
        Nn.DEFMETHOD("remove_initializers", N(Me));
        Fn.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, n) {
                var t = n.name.definition();
                if (n.value) {
                    var i = _e(bt, n.name, n.name);
                    e.push(_e(Qn, n, {
                        operator: "=",
                        left: i,
                        right: n.value
                    }));
                    t.references.push(i);
                }
                t.eliminated++;
                return e;
            }, []);
            if (e.length == 0) return null;
            return X(this, e);
        });
        function W(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof _t ? 3 : 2);
        }
        function P(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names()[n.name]) return true;
            }
        }
        function H(e) {
            return _e(Nn, e, {
                definitions: e.definitions.map(function(e) {
                    return _e(Pn, e, {
                        name: e.name.convert_symbol(vt, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function I(e, t) {
            return t.option("varify") && Pe(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof lt) {
                        var n = e.definition();
                        return !e.fixed_value() || !W(n) || P(t, n);
                    }
                }, true);
            }) ? H(e) : e;
        }
        e(qn, I);
        e(Cn, I);
        function oe(e, n) {
            var t = e.expression;
            if (!(t instanceof Un)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return X(e, i);
        }
        function se(e, t, n) {
            var i = e.expression;
            var r = i instanceof bt ? i.fixed_value() : i;
            if (!(r instanceof un)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (n && n.indexOf(r) < 0) return;
            var a = e.args;
            if (!Pe(a, function(e) {
                return !(e instanceof Vn);
            })) return;
            var o = 0, s = 0;
            var f = r === i && !r.name && t.drop_fargs(r, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof tt) {
                    return e.elements.length == 0 && n instanceof et;
                }
                if (e instanceof rt) {
                    return e.properties.length == 0 && n && !n.may_throw_on_access(t);
                }
                return e.__unused;
            } : Ae;
            var u = [];
            for (var c = 0; c < a.length; c++) {
                var l = r.argnames[c];
                if (t.option("default_values") && l instanceof Hn && a[c].is_defined(t)) {
                    r.argnames[c] = l = l.name;
                }
                if (!l || "__unused" in l) {
                    var p = a[c].drop_side_effect_free(t);
                    if (f(l)) {
                        if (l) r.argnames.splice(c, 1);
                        a.splice(c, 1);
                        if (p) u.push(p);
                        c--;
                        continue;
                    } else if (p) {
                        u.push(p);
                        a[o++] = X(e, u);
                        u = [];
                    } else if (l) {
                        if (u.length) {
                            a[o++] = X(e, u);
                            u = [];
                        } else {
                            a[o++] = _e(kt, a[c], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (l && f(l, a[c])) {
                    var p = a[c].drop_side_effect_free(t);
                    r.argnames.splice(c, 1);
                    a.splice(c, 1);
                    if (p) u.push(p);
                    c--;
                    continue;
                } else {
                    u.push(a[c]);
                    a[o++] = X(e, u);
                    u = [];
                }
                s = o;
            }
            for (;c < r.argnames.length; c++) {
                if (f(r.argnames[c])) r.argnames.splice(c--, 1);
            }
            a.length = s;
            if (!u.length) return;
            var d = X(e, u);
            a.push(a.length < r.argnames.length ? _e(Jn, e, {
                operator: "void",
                expression: d
            }) : d);
        }
        e(In, function(u, c) {
            var o = u.expression;
            if (c.option("sequences")) {
                if (o instanceof Bn) {
                    var e = oe(o, c);
                    if (e !== o) {
                        var n = u.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(c);
                    }
                } else if (!K(c, o.tail_node())) {
                    var e = oe(u, c);
                    if (e !== u) return e.optimize(c);
                }
            }
            if (c.option("unused")) se(u, c);
            if (c.option("unsafe")) {
                if (ee(o)) switch (o.name) {
                  case "Array":
                    if (u.args.length == 1) {
                        var t = u.args[0];
                        if (t instanceof kt) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var a = 0; a < i; a++) r[a] = _e(Ot, u);
                            return _e(et, u, {
                                elements: r
                            });
                        } catch (e) {
                            Ue.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: u.start.file,
                                line: u.start.line,
                                col: u.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(c) && !t.is_string(c)) break;
                    }
                    return _e(et, u, {
                        elements: u.args
                    });

                  case "Object":
                    if (u.args.length == 0) {
                        return _e(at, u, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (u.args.length == 0) return _e(xt, u, {
                        value: ""
                    });
                    if (u.args.length <= 1) return _e(Xn, u, {
                        left: u.args[0],
                        operator: "+",
                        right: _e(xt, u, {
                            value: ""
                        })
                    }).optimize(c);
                    break;

                  case "Number":
                    if (u.args.length == 0) return _e(kt, u, {
                        value: 0
                    });
                    if (u.args.length == 1) return _e(Jn, u, {
                        expression: u.args[0],
                        operator: "+"
                    }).optimize(c);

                  case "Boolean":
                    if (u.args.length == 0) return _e($t, u);
                    if (u.args.length == 1) return _e(Jn, u, {
                        expression: _e(Jn, u, {
                            expression: u.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(c);
                    break;

                  case "RegExp":
                    var s = [];
                    if (Pe(u.args, function(e) {
                        var n = e.evaluate(c);
                        s.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return ie(c, u, _e(Et, u, {
                                value: RegExp.apply(RegExp, s)
                            }));
                        } catch (e) {
                            Ue.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: u,
                                file: u.start.file,
                                line: u.start.line,
                                col: u.start.col
                            });
                        }
                    }
                    break;
                } else if (o instanceof Yn) switch (o.property) {
                  case "toString":
                    if (u.args.length == 0 && !o.expression.may_throw_on_access(c)) {
                        return _e(Xn, u, {
                            left: _e(xt, u, {
                                value: ""
                            }),
                            operator: "+",
                            right: o.expression
                        }).optimize(c);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof et) e: {
                        var f;
                        if (u.args.length > 0) {
                            f = u.args[0].evaluate(c);
                            if (f === u.args[0]) break e;
                        }
                        var r = [];
                        var l = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(c);
                            if (n !== e) {
                                l.push(n);
                            } else {
                                if (l.length > 0) {
                                    r.push(_e(xt, u, {
                                        value: l.join(f)
                                    }));
                                    l.length = 0;
                                }
                                r.push(e);
                            }
                        });
                        if (l.length > 0) {
                            r.push(_e(xt, u, {
                                value: l.join(f)
                            }));
                        }
                        if (r.length == 0) return _e(xt, u, {
                            value: ""
                        });
                        if (r.length == 1) {
                            if (r[0].is_string(c)) {
                                return r[0];
                            }
                            return _e(Xn, r[0], {
                                operator: "+",
                                left: _e(xt, u, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (f == "") {
                            var t;
                            if (r[0].is_string(c) || r[1].is_string(c)) {
                                t = r.shift();
                            } else {
                                t = _e(xt, u, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return _e(Xn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(c);
                        }
                        var p = u.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = r;
                        return ie(c, u, p);
                    }
                    break;

                  case "charAt":
                    if (u.args.length < 2) {
                        var p = _e(Ln, u, {
                            expression: o.expression,
                            property: u.args.length ? _e(Xn, u.args[0], {
                                operator: "|",
                                left: _e(kt, u, {
                                    value: 0
                                }),
                                right: u.args[0]
                            }) : _e(kt, u, {
                                value: 0
                            })
                        });
                        p.is_string = ze;
                        return p.optimize(c);
                    }
                    break;

                  case "apply":
                    if (u.args.length == 2 && u.args[1] instanceof et) {
                        var d = u.args[1].elements.slice();
                        d.unshift(u.args[0]);
                        return _e(In, u, {
                            expression: _e(Yn, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: d
                        }).optimize(c);
                    }
                    break;

                  case "call":
                    var v = o.expression;
                    if (v instanceof bt) {
                        v = v.fixed_value();
                    }
                    if (v instanceof un && !v.contains_this()) {
                        return (u.args.length ? X(this, [ u.args[0], _e(In, u, {
                            expression: o.expression,
                            args: u.args.slice(1)
                        }) ]) : _e(In, u, {
                            expression: o.expression,
                            args: []
                        })).optimize(c);
                    }
                    break;
                }
            }
            if (c.option("unsafe_Function") && ee(o) && o.name == "Function") {
                if (u.args.length == 0) return _e(hn, u, {
                    argnames: [],
                    body: []
                }).init_vars(o.scope);
                if (Pe(u.args, function(e) {
                    return e instanceof xt;
                })) {
                    try {
                        var h = "n(function(" + u.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + u.args[u.args.length - 1].value + "})";
                        var m = Pt(h);
                        var _ = {
                            ie8: c.option("ie8")
                        };
                        m.figure_out_scope(_);
                        var g = new Ut(c.options);
                        m = m.transform(g);
                        m.figure_out_scope(_);
                        m.compute_char_frequency(_);
                        m.mangle_names(_);
                        var b;
                        m.walk(new jt(function(e) {
                            if (b) return true;
                            if (e instanceof un) {
                                b = e;
                                return true;
                            }
                        }));
                        var h = Rt();
                        Ke.prototype._codegen.call(b, h);
                        u.args = [ _e(xt, u, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), _e(xt, u.args[u.args.length - 1], {
                            value: h.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return u;
                    } catch (e) {
                        if (e instanceof qt) {
                            Ue.warn("Error parsing code passed to new Function [{file}:{line},{col}]", u.args[u.args.length - 1].start);
                            Ue.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = o instanceof bt ? o.fixed_value() : o;
            var w = y instanceof pn || y instanceof gn || y instanceof hn;
            var x = w && y.first_statement();
            var k = false;
            var E = w && Pe(y.argnames, function(e, n) {
                if (e instanceof Hn) {
                    k = true;
                    var t = u.args[n];
                    if (t && !we(t)) return false;
                    var i = false;
                    e.value.walk(new jt(function(e) {
                        if (i) return true;
                        if (e instanceof bt && y.find_variable(e.name) === e.definition()) {
                            return i = true;
                        }
                    }));
                    if (i) return false;
                    e = e.name;
                }
                return !(e instanceof nt);
            });
            var S = E && c.option("inline") && !u.is_expr_pure(c);
            if (S && x instanceof wn) {
                var T = x.value;
                if (o === y && (!T || T.is_constant_expression() && C(T))) {
                    return X(u, q(T)).optimize(c);
                }
            }
            if (w) {
                var D, T, O = false;
                if (S && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof hn) && (o === y || !Se(c, D = o.definition()) && y.is_constant_expression(G(c))) && Pe(u.args, function(e) {
                    return !(e instanceof Vn);
                }) && (T = P(x)) && !y.contains_this()) {
                    var A = o === y || D.single_use && D.references.length - D.replaced == 1;
                    if (I()) {
                        var d = u.args.slice();
                        var z = [];
                        d.push(T.clone(true).transform(new Ht(function(e) {
                            if (e instanceof bt) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    z.push(e);
                                    return e;
                                }
                                var t = H(n);
                                var i = d[t];
                                if (!i) return _e(Dt, u);
                                d[t] = null;
                                var r = this.parent();
                                return r ? ge(c, r, e, i) : i;
                            }
                        })));
                        var p = X(u, d.filter(function(e) {
                            return e;
                        })).optimize(c);
                        p = ge(c, c.parent(), c.self(), p);
                        if (A || te(p, u) === p) {
                            z.forEach(function(e) {
                                var n = e.definition();
                                n.references.push(e);
                                if (A) {
                                    n.replaced++;
                                } else {
                                    n.single_use = false;
                                }
                            });
                            return p;
                        }
                    }
                    var $, M, j;
                    if (A && Y()) {
                        y._squeezed = true;
                        if (o !== y) y.parent_scope = o.scope;
                        var p = X(u, J()).optimize(c);
                        return ge(c, c.parent(), c.self(), p);
                    }
                }
                if (c.option("side_effects") && E && Pe(y.body, Q) && (y !== o || ae(y, c)) && !(y instanceof pn && y.value)) {
                    return X(u, q()).optimize(c);
                }
            }
            if (c.option("drop_console")) {
                if (o instanceof Bn) {
                    var F = o.expression;
                    while (F.expression) {
                        F = F.expression;
                    }
                    if (ee(F) && F.name == "console") {
                        return _e(Dt, u).optimize(c);
                    }
                }
            }
            if (c.option("negate_iife") && c.parent() instanceof We && Z(u)) {
                return u.negate(c, true);
            }
            return re(c, u);
            function q(e) {
                var t = u.args.map(function(e) {
                    return e instanceof Vn ? _e(et, e, {
                        elements: [ e ]
                    }) : e;
                });
                y.argnames.forEach(function(e, n) {
                    if (e instanceof Hn) t.push(e.value);
                });
                t.push(e || _e(Dt, u));
                return t;
            }
            function C(e) {
                if (!dn(j || c.find_parent(sn))) return true;
                var t = true;
                var i = new jt(function(e) {
                    if (!t) return true;
                    if (e instanceof sn) {
                        if (e === y) return;
                        if (e instanceof pn) {
                            for (var n = 0; t && n < e.argnames.length; n++) e.argnames[n].walk(i);
                        } else if (mn(e) && e.name.name == "await") {
                            t = false;
                        }
                        return true;
                    }
                    if (e instanceof ct && e.name == "await" && e !== y.name) t = false;
                });
                e.walk(i);
                return t;
            }
            function N(e) {
                if (!e) return _e(Dt, u);
                if (e instanceof wn) return e.value || _e(Dt, u);
                if (e instanceof We) return _e(Jn, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function P(e) {
                var n = y.body.length;
                if (n < 2) {
                    e = N(e);
                    if (e) return e;
                }
                if (c.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = y.body[t];
                    if (i instanceof Nn) {
                        var r = O || !Pe(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            O = true;
                            if (e) return false;
                        }
                    } else if (i instanceof _n || i instanceof gn || i instanceof Ve) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return N(e);
            }
            function H(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function I() {
                if (k) return;
                if (O) return;
                if (c.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof ht;
                })) return;
                var r = false;
                var a;
                var o = [];
                var s = false;
                var f = true;
                T.walk(new jt(function(e, n) {
                    if (r) return true;
                    if (e instanceof Xn && xe[e.operator] || e instanceof Kn) {
                        o = null;
                        return;
                    }
                    if (e instanceof sn) return r = true;
                    if (f && e instanceof ct && e.name == "await") {
                        if (dn(c.find_parent(sn))) return r = true;
                        f = false;
                    }
                    if (e instanceof bt) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            o = null;
                            return;
                        }
                        if (mn(t.init)) return r = true;
                        if (ke(e, this.parent())) return r = true;
                        var i = H(t);
                        if (!(a < i)) a = i;
                        if (!o) return;
                        if (s) {
                            o = null;
                        } else {
                            o.push(y.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(c)) {
                        n();
                        s = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = u.args.length;
                if (o && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > a && y.argnames[e] === o.pop()) ;
                    e++;
                }
                var n = s && !o && c.find_parent(sn);
                return e <= a || Pe(u.args.slice(a, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(c);
                });
            }
            function R(e, n) {
                return e[n] || ne[n] || j.var_names()[n];
            }
            function U(e, n, t) {
                for (var i = 0; i < y.argnames.length; i++) {
                    var r = y.argnames[i];
                    if (r.__unused) continue;
                    if (r instanceof Hn) r = r.name;
                    if (!t || R(e, r.name)) return false;
                    n[r.name] = true;
                    if (M) M.push(r.definition());
                }
                return true;
            }
            function B(n, e, t) {
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (mn(r)) {
                        if (!t || R(e, r.name.name)) return false;
                        if (!Pe(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        continue;
                    }
                    if (!(r instanceof Nn)) continue;
                    if (!t) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var o = r.definitions[a].name;
                        if (R(n, o.name)) return false;
                        if (M) M.push(o.definition());
                    }
                }
                return true;
            }
            function Y() {
                var n = Object.create(null);
                var e = 0, t;
                j = c.self();
                do {
                    if (j.variables) j.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    t = j;
                    j = c.parent(e++);
                    if (j instanceof en) {
                        M = [];
                    } else if (j instanceof rn) {
                        if (j.init === t) continue;
                        M = [];
                    } else if (j instanceof an) {
                        if (j.init === t) continue;
                        if (j.object === t) continue;
                        M = [];
                    } else if (j instanceof bt) {
                        if (j.fixed_value() instanceof sn) return false;
                    }
                } while (!(j instanceof sn));
                $ = j.body.indexOf(t) + 1;
                if (!$) return false;
                if (!C(y)) return false;
                var i = o !== y || y.parent_scope.resolve() === j;
                if (j instanceof fn) {
                    if (c.toplevel.vars) {
                        n["arguments"] = true;
                    } else {
                        i = false;
                    }
                }
                var r = c.option("inline");
                var a = Object.create(n);
                if (!U(n, a, r >= 2 && i)) return false;
                if (!B(n, a, r >= 3 && i)) return false;
                return !M || M.length == 0 || !ue(y, M);
            }
            function L(e, n, t, i) {
                var r = t.definition();
                j.variables.set(t.name, r);
                j.enclosed.push(r);
                if (!j.var_names()[t.name]) {
                    j.var_names()[t.name] = true;
                    e.push(_e(Pn, t, {
                        name: t,
                        value: null
                    }));
                }
                if (!i) return;
                var a = _e(bt, t, t);
                r.references.push(a);
                n.push(_e(Qn, u, {
                    operator: "=",
                    left: a,
                    right: i
                }));
            }
            function V(e, n) {
                var t = y.argnames.length;
                for (var i = u.args.length; --i >= t; ) {
                    n.push(u.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = y.argnames[i];
                    var a = u.args[i];
                    if (r instanceof Hn) {
                        a = a ? X(u, [ a, r.value ]) : r.value;
                        r = r.name;
                    }
                    if (r.__unused || j.var_names()[r.name]) {
                        if (a) n.push(a);
                    } else {
                        var o = _e(vt, r, r);
                        r.definition().orig.push(o);
                        if (!a && M) a = _e(Dt, u);
                        if ("__unused" in r) {
                            L(e, n, o);
                            if (a) n.push(a);
                        } else {
                            L(e, n, o, a);
                        }
                    }
                }
                e.reverse();
                n.reverse();
            }
            function W(e, n) {
                var t = n.length;
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (!(r instanceof Nn)) continue;
                    for (var a = 0; a < r.definitions.length; a++) {
                        var o = r.definitions[a];
                        var s = o.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        L(e, n, s, o.value);
                        if (M && Pe(y.argnames, function(e) {
                            if (e instanceof Hn) e = e.name;
                            return e.name != s.name;
                        })) {
                            var u = y.variables.get(s.name);
                            var c = _e(bt, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, _e(Qn, o, {
                                operator: "=",
                                left: c,
                                right: _e(Dt, s)
                            }));
                        }
                    }
                }
            }
            function J() {
                var e = [];
                var n = [];
                V(e, n);
                W(e, n);
                n.push(T);
                var t = y.body.filter(function(e) {
                    if (mn(e)) {
                        var n = e.name.definition();
                        j.functions.set(n.name, n);
                        j.variables.set(n.name, n);
                        j.enclosed.push(n);
                        j.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift($, 0);
                if (e.length) t.push(_e(Nn, y, {
                    definitions: e
                }));
                [].splice.apply(j.body, t);
                y.enclosed.forEach(function(e) {
                    if (j.var_names()[e.name]) return;
                    j.enclosed.push(e);
                    j.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(Rn, function(e, n) {
            if (n.option("sequences")) {
                var t = oe(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (ee(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return _e(In, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function R(t, i, e, n) {
            if (!(n instanceof Xn)) return;
            if (!xe[n.operator]) return;
            if (!(n.right instanceof Qn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof bt)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? _e(Kn, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : _e(Kn, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new jt(function(e) {
                    if (n) return true;
                    if (e instanceof bt && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(Un, function(e, a) {
            var r = n();
            var o = r.length - 1;
            i();
            t();
            if (o == 0) {
                e = ge(a, a.parent(), a.self(), r[0]);
                if (!(e instanceof Un)) e = e.optimize(a);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var i = Re(a);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(a, i);
                    if (e) {
                        m(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (o > 0 && we(r[o], a)) o--;
                if (o < r.length - 1) {
                    r[o] = _e(Jn, e, {
                        operator: "void",
                        expression: r[o]
                    });
                    r.length = o + 1;
                }
            }
            function i() {
                if (!a.option("conditionals")) return;
                for (var e = 1; e < o; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof Qn)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof bt)) continue;
                    var t = n.left.definition();
                    var i = R(a, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    o--;
                }
            }
        });
        e(Gn, function(e, n) {
            if (n.option("sequences")) {
                var t = oe(e, n);
                if (t !== e) return t.optimize(n);
            }
            return re(n, e);
        });
        var U = Ne("+ -");
        var B = Ne("* / %");
        e(Jn, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !(i instanceof bt || i instanceof Bn || o(i))) {
                if (i instanceof Un) {
                    i = i.expressions.slice();
                    i.push(_e(Mt, e));
                    return X(e, i).optimize(n);
                }
                return X(e, [ i, _e(Mt, e) ]).optimize(n);
            }
            if (n.option("sequences") && !(t == "typeof" && ee(i.tail_node()))) {
                var r = oe(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return _e(Dt, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return X(e, [ i, _e($t, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof Jn && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof Xn) {
                        e = ie(n, e, i.negate(n, Re(n)));
                    }
                    break;

                  case "typeof":
                    Ue.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    var a = [ _e(Mt, e) ];
                    if (!(i instanceof bt && he(i))) a.unshift(i);
                    return X(e, a).optimize(n);
                }
            }
            if (t == "-" && i instanceof At) i = i.transform(n);
            if (n.option("evaluate") && i instanceof Xn && U[t] && B[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return _e(Xn, e, {
                    operator: i.operator,
                    left: _e(Jn, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof kt || i instanceof At) ? e : re(n, e);
        });
        Xn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Bn) {
                if (!(this.left.expression instanceof Un)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return X(this, n);
            }
            if (this.left instanceof Un) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return X(this, n);
            }
            if (this.right instanceof Un) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof bt;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var a = 0; a < r; a++) {
                    if (!i && n[a].has_side_effects(e)) break;
                }
                if (a == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return X(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = X(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return X(this, n);
                }
            }
            return this;
        });
        var Y = Ne("indexOf lastIndexOf");
        var L = Ne("== === != !== * & | ^");
        function Ee(e) {
            if (e instanceof Qn) return e.operator == "=" && Ee(e.right);
            if (e instanceof Un) return Ee(e.tail_node());
            if (e instanceof bt) return Ee(e.fixed_value());
            return e instanceof et || e instanceof un || e instanceof Rn || e instanceof at;
        }
        function J(e, n) {
            if (n instanceof Yn) return J(e, n.expression);
            if (n instanceof Ln) {
                return J(e, n.expression) && J(e, n.property);
            }
            if (n instanceof ct) return true;
            return !n.has_side_effects(e);
        }
        e(Xn, function(i, o) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(o) && !i.right.has_side_effects(o);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = _e(Xn, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(o);
            }
            if (L[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof Xn && Nt[i.left.operator] >= Nt[i.operator])) {
                e();
            }
            if (o.option("sequences")) {
                var r = i.lift_sequences(o);
                if (r !== i) return r.optimize(o);
            }
            if (o.option("assignments") && xe[i.operator]) {
                var a = i.right;
                if (i.left instanceof bt && a instanceof Qn && a.operator == "=" && i.left.equivalent_to(a.left)) {
                    i.right = a.right;
                    a.right = i;
                    return a;
                }
            }
            if (o.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if (we(i.left, o) && i.right.is_defined(o)) {
                    Ue.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return X(i, [ i.right, _e(i.operator == "===" ? $t : Mt, i) ]).optimize(o);
                }
                var s = true;
                if (i.left.is_string(o) && i.right.is_string(o) || i.left.is_number(o) && i.right.is_number(o) || i.left.is_boolean(o) && i.right.is_boolean(o) || J(o, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && we(i.left, o)) {
                    i.left = _e(St, i.left);
                } else if (o.option("typeofs") && i.left instanceof xt && i.left.value == "undefined" && i.right instanceof Jn && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof bt ? f.is_declared(o) : !(f instanceof Bn && o.option("ie8"))) {
                        i.right = f;
                        i.left = _e(Dt, i.left).optimize(o);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof bt && i.right instanceof bt && i.left.definition() === i.right.definition() && Ee(i.left)) {
                    return _e(i.operator[0] == "=" ? Mt : $t, i).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof Xn && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof Xn && u.operator == i.right.operator && (we(u.left, o) && i.right.left instanceof St || u.left instanceof St && we(i.right.left, o)) && !u.right.has_side_effects(o) && u.right.equivalent_to(i.right.right)) {
                    var c = _e(Xn, i, {
                        operator: u.operator.slice(0, -1),
                        left: _e(St, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = _e(Xn, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = o.option("booleans") && o.in_boolean_context();
            if (l) switch (i.operator) {
              case "+":
                var p = i.left.evaluate(o);
                var d = i.right.evaluate(o);
                if (p && typeof p == "string") {
                    Ue.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return X(i, [ i.right, _e(Mt, i) ]).optimize(o);
                }
                if (d && typeof d == "string") {
                    Ue.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return X(i, [ i.left, _e(Mt, i) ]).optimize(o);
                }
                break;

              case "==":
                if (i.left instanceof xt && i.left.value == "" && i.right.is_string(o)) {
                    return _e(Jn, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (i.left instanceof xt && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                break;
            }
            var v = o.parent();
            if (o.option("comparisons") && i.is_boolean(o)) {
                if (!(v instanceof Xn) || v instanceof Qn) {
                    var h = ie(o, i, _e(Jn, i, {
                        operator: "!",
                        expression: i.negate(o, Re(o))
                    }));
                    if (h !== i) return h;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (o.option("conditionals") && xe[i.operator] && i.right instanceof Xn && i.operator == i.right.operator) {
                n();
            }
            if (o.option("strings") && i.operator == "+") {
                if (i.right instanceof xt && i.right.value == "" && i.left.is_string(o)) {
                    return i.left.optimize(o);
                }
                if (i.left instanceof xt && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                if (i.left instanceof Xn && i.left.operator == "+" && i.left.left instanceof xt && i.left.left.value == "" && i.right.is_string(o)) {
                    i.left = i.left.right;
                    return i.optimize(o);
                }
                if (i.right instanceof Xn && i.operator == i.right.operator && (i.left.is_string(o) && i.right.is_string(o) || i.right.left.is_string(o) && (i.left.is_constant() || !i.right.right.has_side_effects(o)))) {
                    n();
                }
            }
            if (o.option("evaluate")) {
                var m = true;
                switch (i.operator) {
                  case "&&":
                    var p = T(i.left);
                    if (!p) {
                        Ue.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return ge(o, v, o.self(), i.left).optimize(o);
                    } else if (!(p instanceof Ue)) {
                        Ue.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return X(i, [ i.left, i.right ]).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l) {
                            Ue.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return X(i, [ i.left, _e($t, i) ]).optimize(o);
                        } else i.falsy = true;
                    } else if (!(d instanceof Ue)) {
                        if (l || v.operator == "&&" && v.left === o.self()) {
                            Ue.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    }
                    if (i.left.operator == "||") {
                        var _ = i.left.right.evaluate(o, true);
                        if (!_) return _e(Kn, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(o);
                    }
                    break;

                  case "||":
                    var p = T(i.left);
                    if (!p) {
                        Ue.warn("Condition left of || always false [{file}:{line},{col}]", i.start);
                        return X(i, [ i.left, i.right ]).optimize(o);
                    } else if (!(p instanceof Ue)) {
                        Ue.warn("Condition left of || always true [{file}:{line},{col}]", i.start);
                        return ge(o, v, o.self(), i.left).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l || v.operator == "||" && v.left === o.self()) {
                            Ue.warn("Dropping side-effect-free || [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    } else if (!(d instanceof Ue)) {
                        if (l) {
                            Ue.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return X(i, [ i.left, _e(Mt, i) ]).optimize(o);
                        } else i.truthy = true;
                    }
                    if (i.left.operator == "&&") {
                        var _ = i.left.right.is_truthy() || i.left.right.evaluate(o, true);
                        if (_ && !(_ instanceof Ue)) return _e(Kn, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (i.left instanceof wt && i.right instanceof Xn && i.right.operator == "+" && i.right.left instanceof wt && i.right.is_string(o)) {
                        i = _e(Xn, i, {
                            operator: "+",
                            left: _e(xt, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof wt && i.left instanceof Xn && i.left.operator == "+" && i.left.right instanceof wt && i.left.is_string(o)) {
                        i = _e(Xn, i, {
                            operator: "+",
                            left: i.left.left,
                            right: _e(xt, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof Jn && i.right.operator == "-" && i.left.is_number(o)) {
                        i = _e(Xn, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof Jn && i.left.operator == "-" && t() && i.right.is_number(o)) {
                        i = _e(Xn, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && i.left instanceof Xn && Nt[i.left.operator] == Nt[i.operator] && i.right.is_constant() && (i.right.is_boolean(o) || i.right.is_number(o)) && i.left.is_number(o) && !i.left.right.is_constant() && (i.left.left.is_boolean(o) || i.left.left.is_number(o))) {
                        i = _e(Xn, i, {
                            operator: i.left.operator,
                            left: _e(Xn, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof Jn && i.right.operator == "-" && i.left.is_number(o) && i.right.expression.is_number(o)) {
                        i = _e(Xn, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    m = o.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof Jn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(o) || i.left.is_number(o)) && (i.right.is_boolean(o) || i.right.is_number(o)) && t() && !(i.left instanceof Xn && i.left.operator != i.operator && Nt[i.left.operator] >= Nt[i.operator])) {
                        var g = _e(Xn, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof wt && !(i.left instanceof wt)) {
                            i = ie(o, g, i);
                        } else {
                            i = ie(o, i, g);
                        }
                    }
                    if (!m || !i.is_number(o)) break;
                    if (i.right instanceof Xn && i.right.operator != "%" && Nt[i.right.operator] == Nt[i.operator] && i.right.is_number(o) && (i.operator != "+" || i.right.left.is_boolean(o) || i.right.left.is_number(o)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(o))) {
                        i = _e(Xn, i, {
                            operator: E(i.operator, i.right.operator),
                            left: _e(Xn, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(o) && !i.right.is_number(o)) {
                            i.right = _e(Jn, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof wt && i.left instanceof Xn && i.left.operator != "%" && Nt[i.left.operator] == Nt[i.operator] && i.left.is_number(o)) {
                        if (i.left.left instanceof wt) {
                            var u = S(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = S(i, i.left.operator, re(o, u), i.left.right);
                        } else if (i.left.right instanceof wt) {
                            var b = E(i.left.operator, i.operator);
                            var y = re(o, S(i.left, b, i.left.right, i.right));
                            if (y.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +y.value == 0 && i.left.left.is_negative_zero())) {
                                i = S(i, i.left.operator, i.left.left, y);
                            }
                        }
                    }
                    break;
                }
                if (!(v instanceof Jn && v.operator == "delete")) {
                    if (i.left instanceof kt && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(o)) return _e(Jn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                            if (i.right.is_number(o) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(o) ? i.right : _e(Jn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (i.right instanceof kt && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(o)) return _e(Jn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                            if (i.left.is_number(o) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(o) ? i.left : _e(Jn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(o) ? i.left : _e(Jn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (i.operator) {
              case "&&":
                C(i.left, i.right, null);
                break;

              case "||":
                C(i.left, null, i.right);
                break;
            }
            if (o.option("unsafe")) {
                var w = D(i.right);
                if (l && w && (i.operator == "==" || i.operator == "!=") && i.left instanceof kt && i.left.value == 0) {
                    return (i.operator == "==" ? _e(Jn, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(o);
                }
                var x = D(i.left);
                if (o.option("comparisons") && O()) {
                    var k = _e(Jn, i, {
                        operator: "!",
                        expression: _e(Jn, i, {
                            operator: "~",
                            expression: x ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (x) break;

                      case "<=":
                      case "!=":
                        k = _e(Jn, i, {
                            operator: "!",
                            expression: k
                        });
                        break;
                    }
                    return k.optimize(o);
                }
            }
            return re(o, i);
            function E(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function S(e, n, t, i, r, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = _e(Jn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(o) && !i.is_number(o)) {
                        i = _e(Jn, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return _e(Xn, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: a
                });
            }
            function T(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(o, true);
            }
            function D(e) {
                return e.TYPE == "Call" && e.expression instanceof Yn && Y[e.expression.property];
            }
            function O() {
                switch (i.operator) {
                  case "<=":
                    return w && i.left instanceof kt && i.left.value == 0;

                  case "<":
                    if (x && i.right instanceof kt && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!w) return false;
                    return i.left instanceof kt && i.left.value == -1 || i.left instanceof Jn && i.left.operator == "-" && i.left.expression instanceof kt && i.left.expression.value == 1;
                }
            }
        });
        function Se(e, n) {
            var t = 0, i = e.self();
            do {
                if (i instanceof un && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(t++));
        }
        e(bt, function(e, n) {
            if (!n.option("ie8") && ee(e) && !(e.scope.resolve().uses_with && n.find_parent(on))) {
                switch (e.name) {
                  case "undefined":
                    return _e(Dt, e).optimize(n);

                  case "NaN":
                    return _e(Tt, e).optimize(n);

                  case "Infinity":
                    return _e(At, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && ke(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var a = i.single_use && !(t instanceof In && t.is_expr_pure(n));
                if (a) {
                    if (r instanceof un) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            a = false;
                        } else if (Se(n, i)) {
                            a = false;
                        } else if (r.name && r.name.definition() !== i) {
                            a = false;
                        } else if (r.parent_scope !== e.scope.resolve() || D(i)) {
                            a = r.is_constant_expression(e.scope);
                            if (a == "f") {
                                var o = e.scope;
                                do {
                                    if (mn(o) || ln(o)) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (r.name && r.name.name == "await" && dn(r)) {
                            a = false;
                        }
                        if (a) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression()) {
                        a = false;
                    }
                }
                if (a) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof _n) {
                        r = _e(vn, r, r);
                        r.name = _e(_t, r.name, r.name);
                    } else if (r instanceof gn) {
                        r = _e(hn, r, r);
                        r.name = _e(_t, r.name, r.name);
                    }
                    if (r instanceof un) {
                        var o = e.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (o.var_names()[e.name]) return;
                            o.enclosed.push(e);
                            o.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof _t)) {
                            c = _e(_t, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new jt(function(e) {
                            if (!(e instanceof bt)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof un)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = s.transform(new Ht(function(e, n) {
                            if (e instanceof sn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var l = e.fixed !== i.fixed;
                if (r && (l || i.should_replace !== false)) {
                    var p;
                    if (r instanceof yt) {
                        if (!D(i) && g(i)) {
                            p = r;
                        }
                    } else {
                        var d = r.evaluate(n, true);
                        if (d !== r && typeof d != "function" && (typeof d != "object" || d instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && g(i))) {
                            p = O(d, r);
                        }
                    }
                    if (p) {
                        if (!l && i.should_replace === undefined) {
                            var v = p.optimize(n).print_to_string().length;
                            if (!b(r)) {
                                v = Math.min(v, r.print_to_string().length);
                            }
                            var h = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var m = i.references.length - i.replaced;
                                h += (h + 2 + v) / (m - i.assignments);
                            }
                            var _ = v - Math.floor(h);
                            i.should_replace = _ < n.eval_threshold;
                        }
                        if (l || i.should_replace) {
                            var s;
                            if (b(r)) {
                                s = p.optimize(n);
                                if (s === p) s = s.clone(true);
                            } else {
                                s = te(p.optimize(n), r);
                                if (s === p || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function g(e) {
                var n = e.scope.resolve();
                return Pe(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function b(e) {
                var n;
                e.walk(new jt(function(e) {
                    if (e instanceof bt) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function fe(e, n) {
            return e instanceof bt || e.TYPE === n.TYPE;
        }
        e(Dt, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = G(n).find_variable("undefined");
                if (t) {
                    var i = _e(bt, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = ke(n.self(), n.parent());
            if (r && fe(r, e)) return e;
            return _e(Jn, e, {
                operator: "void",
                expression: _e(kt, e, {
                    value: 0
                })
            });
        });
        e(At, function(e, n) {
            var t = ke(n.self(), n.parent());
            if (t && fe(t, e)) return e;
            if (n.option("keep_infinity") && !t && !G(n).find_variable("Infinity")) {
                return e;
            }
            return _e(Xn, e, {
                operator: "/",
                left: _e(kt, e, {
                    value: 1
                }),
                right: _e(kt, e, {
                    value: 0
                })
            });
        });
        e(Tt, function(e, n) {
            var t = ke(n.self(), n.parent());
            if (t && fe(t, e)) return e;
            if (!t && !G(n).find_variable("NaN")) return e;
            return _e(Xn, e, {
                operator: "/",
                left: _e(kt, e, {
                    value: 0
                }),
                right: _e(kt, e, {
                    value: 0
                })
            });
        });
        function ue(t, n) {
            var i = false;
            var r = new jt(function(e) {
                if (i) return true;
                if (e instanceof bt && Te(e.definition(), n)) {
                    return i = true;
                }
            });
            var a = new jt(function(e) {
                if (i) return true;
                if (e instanceof sn && e !== t) {
                    var n = a.parent();
                    if (n instanceof In && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(a);
            return i;
        }
        var ce = Ne("+ - * / % >> << >>> | ^ &");
        var le = Ne("* | ^ &");
        e(Qn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof Bn) {
                    if (a.operator == "=") {
                        if (a.__drop) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof Ln) e.push(a.left.property);
                            e.push(a.right);
                            return X(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof un || !o.has_directive("use strict") && n instanceof wt && !n.may_throw_on_access(o)) {
                            return a.left instanceof Yn ? a.right : X(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof bt && Pe(a.left.definition().orig, function(e) {
                    return !(e instanceof pt);
                })) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof Jn && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return v();
                    var i = a.left.definition();
                    var s = i.scope.resolve();
                    var r = s === o.find_parent(un);
                    var f = 0, u;
                    t = a;
                    do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Qn) {
                            var c = false;
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Bn) return true;
                                if (!c && e instanceof bt && e.definition() === i) {
                                    if (d(f, t)) return true;
                                    i.fixed = false;
                                    c = true;
                                }
                            })) break;
                            if (c) return v();
                        } else if (t instanceof yn) {
                            if (!r) break;
                            if (d(f, t)) break;
                            if (ue(s, [ i ])) break;
                            i.fixed = false;
                            return v();
                        } else if (t instanceof Pn) {
                            if (!(t.name instanceof lt)) continue;
                            if (t.name.definition() !== i) continue;
                            if (d(f, t)) break;
                            i.fixed = false;
                            return v();
                        }
                    } while (t instanceof Xn && t.right === u || t instanceof Un && t.tail_node() === u || t instanceof Jn);
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof bt && a.right instanceof Xn) {
                    if (a.right.left instanceof bt && a.right.left.name == a.left.name && ce[a.right.operator]) {
                        return _e(Qn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        }).optimize(o);
                    } else if (a.right.right instanceof bt && a.right.right.name == a.left.name && le[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        return _e(Qn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        }).optimize(o);
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof kt && a.right.value == 1) {
                    var p = a.operator.slice(0, -1);
                    return _e(Jn, a, {
                        operator: p + p,
                        expression: a.left
                    });
                }
            }
            return re(o, a);
            function d(e, n) {
                var t = a.right;
                a.right = _e(St, t);
                var i = n.may_throw(o);
                a.right = t;
                var r;
                while (r = o.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof $n) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function v() {
                return (a.operator != "=" ? _e(Xn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : ge(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Kn, function(a, n) {
            if (n.option("sequences") && a.condition instanceof Un) {
                var e = a.condition.expressions.slice();
                a.condition = e.pop();
                e.push(a);
                return X(a, e);
            }
            if (!n.option("conditionals")) return a;
            var o = a.condition.is_truthy() || a.condition.evaluate(n, true);
            if (!o) {
                Ue.warn("Condition always false [{file}:{line},{col}]", a.start);
                return X(a, [ a.condition, a.alternative ]).optimize(n);
            } else if (!(o instanceof Ue)) {
                Ue.warn("Condition always true [{file}:{line},{col}]", a.start);
                return X(a, [ a.condition, a.consequent ]).optimize(n);
            }
            var t = o.negate(n, Re(n));
            if (ie(n, o, t) === t) {
                a = _e(Kn, a, {
                    condition: t,
                    consequent: a.alternative,
                    alternative: a.consequent
                });
                t = o;
                o = a.condition;
            }
            var i = a.consequent;
            var r = a.alternative;
            if (J(n, o)) {
                if (o.equivalent_to(i)) return _e(Xn, a, {
                    operator: "||",
                    left: o,
                    right: r
                }).optimize(n);
                if (o.equivalent_to(r)) return _e(Xn, a, {
                    operator: "&&",
                    left: o,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof Qn) {
                var f = s.operator == "=";
                var u = f ? r.tail_node() : r;
                if ((f || i === s) && u instanceof Qn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof bt || !o.has_side_effects(n) && y(i) && y(r))) {
                    return _e(Qn, a, {
                        operator: s.operator,
                        left: s.left,
                        right: _e(Kn, a, {
                            condition: o,
                            consequent: w(i),
                            alternative: w(r)
                        })
                    });
                }
            }
            if (i.equivalent_to(r)) return X(a, [ o, i ]).optimize(n);
            var c = b(i, r, true);
            if (c) return c;
            var l;
            if (i instanceof In && r.TYPE == i.TYPE && (l = _(i, r)) >= 0 && i.expression.equivalent_to(r.expression) && !o.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                p.args[l] = _e(Kn, a, {
                    condition: o,
                    consequent: i.args[l],
                    alternative: r.args[l]
                });
                return p;
            }
            if (i instanceof Kn && i.alternative.equivalent_to(r)) {
                return _e(Kn, a, {
                    condition: _e(Xn, a, {
                        left: o,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: r
                });
            }
            if (i instanceof Kn && i.consequent.equivalent_to(r)) {
                return _e(Kn, a, {
                    condition: _e(Xn, a, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: r,
                    alternative: i.alternative
                });
            }
            if (r instanceof Kn && i.equivalent_to(r.consequent)) {
                return _e(Kn, a, {
                    condition: _e(Xn, a, {
                        left: o,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: i,
                    alternative: r.alternative
                });
            }
            if (r instanceof Kn && i.equivalent_to(r.alternative)) {
                return _e(Kn, a, {
                    condition: _e(Xn, a, {
                        left: t,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: i
                });
            }
            if ((i instanceof Un || r instanceof Un) && i.tail_node().equivalent_to(r.tail_node())) {
                return X(a, [ _e(Kn, a, {
                    condition: o,
                    consequent: x(i),
                    alternative: x(r)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof Xn && i.operator == "&&" && i.right.equivalent_to(r)) {
                return _e(Xn, a, {
                    operator: "&&",
                    left: _e(Xn, a, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (i instanceof Xn && i.operator == "||" && i.right.equivalent_to(r)) {
                return _e(Xn, a, {
                    operator: "||",
                    left: _e(Xn, a, {
                        operator: "&&",
                        left: o,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (r instanceof Xn && r.operator == "&&" && r.right.equivalent_to(i)) {
                return _e(Xn, a, {
                    operator: "&&",
                    left: _e(Xn, a, {
                        operator: "||",
                        left: o,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (r instanceof Xn && r.operator == "||" && r.right.equivalent_to(i)) {
                return _e(Xn, a, {
                    operator: "||",
                    left: _e(Xn, a, {
                        operator: "&&",
                        left: t,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            var d = n.option("booleans") && n.in_boolean_context();
            if (h(i)) {
                if (m(r)) {
                    return v(o);
                }
                return _e(Xn, a, {
                    operator: "||",
                    left: v(o),
                    right: r
                });
            }
            if (m(i)) {
                if (h(r)) {
                    return v(o.negate(n));
                }
                return _e(Xn, a, {
                    operator: "&&",
                    left: v(o.negate(n)),
                    right: r
                });
            }
            if (h(r)) {
                return _e(Xn, a, {
                    operator: "||",
                    left: v(o.negate(n)),
                    right: i
                });
            }
            if (m(r)) {
                return _e(Xn, a, {
                    operator: "&&",
                    left: v(o),
                    right: i
                });
            }
            if (n.option("typeofs")) C(o, i, r);
            return a;
            function v(e) {
                if (e.is_boolean(n)) return e;
                return _e(Jn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function h(e) {
                return e instanceof Mt || d && e instanceof wt && e.value || e instanceof Jn && e.operator == "!" && e.expression instanceof wt && !e.expression.value;
            }
            function m(e) {
                return e instanceof $t || d && (e instanceof wt && !e.value || e instanceof Jn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof Jn && e.operator == "!" && e.expression instanceof wt && e.expression.value;
            }
            function _(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var a = 0; a < r; a++) {
                    if (!t[a].equivalent_to(i[a])) {
                        for (var o = a + 1; o < r; o++) {
                            if (!t[o].equivalent_to(i[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function g(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e instanceof In) {
                    if (_(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Bn || n.expression instanceof Bn) || g(e.expression, n.expression);
                }
                if (e instanceof Yn) return e.property == n.property;
                if (e instanceof Ln) return e.property.equivalent_to(n.property);
            }
            function b(e, n, t) {
                if (!g(e, n)) return !t && _e(Kn, a, {
                    condition: o,
                    consequent: e,
                    alternative: n
                });
                var i = b(e.expression, n.expression);
                if (!i) return;
                var r = e.clone();
                r.expression = i;
                return r;
            }
            function y(e) {
                return e === e.tail_node() || Pe(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function w(e) {
                if (!(e instanceof Un)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return X(e, n);
            }
            function x(e) {
                if (!(e instanceof Un)) return _e(kt, e, {
                    value: 0
                });
                return X(e, e.expressions.slice(0, -1));
            }
        });
        e(zt, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return _e(kt, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Xn && (t.operator == "==" || t.operator == "!=")) {
                Ue.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return _e(kt, e, {
                    value: +e.value
                });
            }
            return _e(Jn, e, {
                operator: "!",
                expression: _e(kt, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Vn, function(e, n) {
            var t = e.expression;
            if (n.option("spread") && t instanceof et && !(n.parent() instanceof at)) {
                return je.splice(t.elements.map(function(e) {
                    return e instanceof Ot ? _e(Dt, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function pe(e, n) {
            if (e instanceof bt) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof un)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(Ln, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var a = parseFloat(r);
                            if (a.toString() == r) {
                                r = a;
                            }
                        }
                    }
                    i = e.property = te(i, O(r, i).transform(t));
                    var o = "" + r;
                    if (Ft(o) && o.length <= i.print_to_string().length + 1) {
                        return _e(Yn, e, {
                            expression: n,
                            property: o
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f = ke(t.self(), s);
            var u, c, l;
            if (t.option("arguments") && n instanceof bt && ve(u = n.definition()) && !n.in_arg && i instanceof kt && (c = u.scope) === E() && c.uses_arguments < (f ? 2 : 3)) {
                var p = i.value;
                if (s instanceof Jn && s.operator == "delete") {
                    if (!u.deleted) u.deleted = [];
                    u.deleted[p] = true;
                }
                var d = c.argnames[p];
                if (u.deleted && u.deleted[p]) {
                    d = null;
                } else if (d) {
                    var v;
                    if (!(d instanceof ht)) {
                        d = null;
                    } else if (n.scope.find_variable(d.name) !== (v = d.definition())) {
                        d = null;
                    } else if (t.has_directive("use strict") || c.name || !(l instanceof In && p < l.args.length) || !Pe(c.argnames, function(e) {
                        return e instanceof ht;
                    })) {
                        if (!t.option("reduce_vars") || u.reassigned || v.assignments || v.orig.length > 1) {
                            d = null;
                        }
                    }
                } else if (p < c.argnames.length + 5 && t.drop_fargs(c, l)) {
                    while (p >= c.argnames.length) {
                        d = c.make_var(ht, c, "argument_" + c.argnames.length);
                        c.argnames.push(d);
                    }
                }
                if (d && De(function(e) {
                    return e.name === d.name;
                }, c.argnames) === d) {
                    u.reassigned = false;
                    var h = _e(bt, e, d);
                    h.reference({});
                    delete d.__unused;
                    return h;
                }
            }
            if (f) return e;
            if (t.option("sequences") && s.TYPE != "Call" && !(s instanceof an && s.init === e)) {
                var m = oe(e, t);
                if (m !== e) return m.optimize(t);
            }
            if (r !== i) {
                var _ = e.flatten_object(o, t);
                if (_) {
                    n = e.expression = _.expression;
                    i = e.property = _.property;
                }
            }
            var g;
            if (t.option("properties") && t.option("side_effects") && i instanceof kt && n instanceof et && Pe(g = n.elements, function(e) {
                return !(e instanceof Vn);
            })) {
                var p = i.value;
                var b = g[p];
                if (pe(b, t)) {
                    var y = b instanceof Ot;
                    var w = !y;
                    var x = [];
                    for (var k = g.length; --k > p; ) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                            if (w && a.has_side_effects(t)) w = false;
                        }
                    }
                    if (!w) x.unshift(b);
                    while (--k >= 0) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                        } else if (y) {
                            x.unshift(_e(Ot, g[k]));
                        } else {
                            p--;
                        }
                    }
                    if (w) {
                        x.push(b);
                        return X(e, x).optimize(t);
                    } else return _e(Ln, e, {
                        expression: _e(et, n, {
                            elements: x
                        }),
                        property: _e(kt, i, {
                            value: p
                        })
                    });
                }
            }
            return re(t, e);
            function E() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof un) {
                        if (n instanceof cn) return;
                        if (n instanceof pn) continue;
                        l = t.parent(e);
                        return n;
                    }
                }
            }
        });
        pn.DEFMETHOD("contains_this", Ae);
        sn.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new jt(function(e) {
                if (n) return true;
                if (e instanceof yt) return n = true;
                if (e !== t && e instanceof sn && !(e instanceof pn)) return true;
            }));
            return n;
        });
        Bn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof at) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a.key != e) continue;
                    if (!Pe(i, function(e) {
                        return e instanceof st && typeof e.key == "string";
                    })) break;
                    if (!pe(a.value, n)) break;
                    return _e(Ln, this, {
                        expression: _e(et, t, {
                            elements: i.map(function(e) {
                                return e.value;
                            })
                        }),
                        property: _e(kt, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(Yn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                Ue.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (ke(n.self(), t)) return e;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof an && t.init === e)) {
                var i = oe(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Yn && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (ee(r)) switch (r.name) {
                  case "Array":
                    e.expression = _e(et, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = _e(hn, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(r.scope);
                    break;

                  case "Number":
                    e.expression = _e(kt, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = _e(at, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = _e(Et, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = _e(xt, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var a = e.flatten_object(e.property, n);
            if (a) return a.optimize(n);
            return re(n, e);
        });
        e(it, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof Ue) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(at, function(t, i) {
            if (!i.option("objects")) return t;
            var r = false;
            var a = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = new He();
            var u = [];
            t.properties.forEach(function(e) {
                if (!(e instanceof Vn)) return l(e);
                a = true;
                var n = e.expression;
                if (i.option("spread") && n instanceof at && Pe(n.properties, function(e) {
                    return !(e instanceof ut || e instanceof Vn);
                })) {
                    r = true;
                    n.properties.forEach(function(e) {
                        l(e instanceof ft ? _e(st, e, {
                            key: e.key,
                            value: _e(Dt, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!r) return t;
            if (a && o && u.length == 1) {
                var e = u[0];
                if (e instanceof ot && e.key instanceof kt) {
                    e.key = "" + e.key.value;
                }
            }
            return r ? _e(at, t, {
                properties: u
            }) : t;
            function c() {
                f.each(function(e) {
                    if (e.length == 1) return u.push(e[0]);
                    r = true;
                    var n = s && !o && e.pop();
                    u.push(e.length == 1 ? e[0] : _e(st, t, {
                        key: e[0].key,
                        value: X(t, e.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (n) u.push(n);
                });
                f = new He();
            }
            function l(e) {
                var n = e.key;
                if (n instanceof Ue) {
                    a = true;
                    n = n.evaluate(i);
                    if (n === e.key) {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (e instanceof st && typeof n == "string") {
                    if (e.value.has_side_effects(i)) c();
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (a && !o && typeof n == "string" && /^[1-9]*[0-9]$/.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = _e(kt, e, {
                        value: +n
                    });
                }
            }
        });
        e(wn, function(e, n) {
            if (e.value && we(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var x = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var k = x.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function E(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, a = 0; r < n.length; r++) {
            var o = k[n[r]];
            t += (o & 31) << i;
            if (o & 32) {
                i += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return a;
    }
    function S(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += x[t];
        } while (e);
        return n;
    }
    function O() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!Ie(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function A(l) {
        var f = O();
        var a = l.includeSources && Object.create(null);
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, E(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) a[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var v = 0;
        var h = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, i, r, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                a[e] = n;
            } : Oe,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                v = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += S(t - v);
            v = t;
            if (e == null) return;
            var o = f.index(e);
            c += S(o - h);
            h = o;
            c += S(i - m);
            m = i;
            c += S(r - _);
            _ = r;
            if (l.names && a != null) {
                var s = u.index(a);
                c += S(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof Be && e[t].body instanceof xt) {
                    e[t] = new Le({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof Be && e[t].body instanceof xt)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new fn({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new gn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new hn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new We({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new $n({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new jn(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new st(t);
                t.value = new cn(t.value);
                if (e.kind == "get") return new ut(t);
                if (e.kind == "set") return new ft(t);
            },
            ArrayExpression: function(e) {
                return new et({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Ot() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new at({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new Un({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Ln : Yn)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? zn : An)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new Nn({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new St(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new Et(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new Et(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new xt(t);

                  case "number":
                    t.value = n;
                    return new kt(t);

                  case "boolean":
                    return new (n ? Mt : $t)(t);
                }
            },
            Identifier: function(e) {
                var n = a[a.length - 2];
                return new (n.type == "LabeledStatement" ? pe : n.type == "VariableDeclarator" && n.id === e ? vt : n.type == "FunctionExpression" ? n.id === e ? _t : ht : n.type == "FunctionDeclaration" ? n.id === e ? mt : ht : n.type == "CatchClause" ? gt : n.type == "BreakStatement" || n.type == "ContinueStatement" ? de : bt)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new yt({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? Jn : Gn)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Ve);
        e("BlockStatement", Ke, "body@body");
        e("IfStatement", Tn, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Qe, "label>label, body>body");
        e("BreakStatement", En, "label>label");
        e("ContinueStatement", Sn, "label>label");
        e("WithStatement", on, "object>expression, body>body");
        e("SwitchStatement", Dn, "discriminant>expression, cases@body");
        e("ReturnStatement", wn, "argument>value");
        e("ThrowStatement", xn, "argument>value");
        e("WhileStatement", tn, "test>condition, body>body");
        e("DoWhileStatement", nn, "test>condition, body>body");
        e("ForStatement", rn, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", an, "left>init, right>object, body>body");
        e("DebuggerStatement", Ye);
        e("VariableDeclarator", Pn, "id>name, init>value");
        e("CatchClause", Mn, "param>argname, body%body");
        e("BinaryExpression", Xn, "operator=operator, left>left, right>right");
        e("LogicalExpression", Xn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", Qn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", Kn, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", Rn, "callee>expression, arguments@args");
        e("CallExpression", In, "callee>expression, arguments@args");
        c(fn, function e(n) {
            return d("Program", n);
        });
        c(gn, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(hn, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(Le, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(We, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(On, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c($n, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(Mn, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(Fn, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(Un, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(Bn, function e(n) {
            var t = n instanceof Ln;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(Wn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof Jn,
                argument: l(n.expression)
            };
        });
        c(Xn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(et, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(at, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(ot, function e(n) {
            var t = {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof st) {
                i = "init";
            } else if (n instanceof ut) {
                i = "get";
            } else if (n instanceof ft) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(ct, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(yt, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(Et, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(wt, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(h, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        zt.DEFMETHOD("to_mozilla_ast", wt.prototype.to_mozilla_ast);
        St.DEFMETHOD("to_mozilla_ast", wt.prototype.to_mozilla_ast);
        Ot.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        Xe.DEFMETHOD("to_mozilla_ast", Ke.prototype.to_mozilla_ast);
        un.DEFMETHOD("to_mozilla_ast", hn.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var a = "function From_Moz_" + e + "(M){\n";
            a += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var o = "function To_Moz_" + e + "(M){\n";
            o += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                a += ",\n" + r + ": ";
                o += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    a += "M." + t + ".map(from_moz)";
                    o += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    a += "from_moz(M." + t + ")";
                    o += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    a += "M." + t;
                    o += "M." + r;
                    break;

                  case "%":
                    a += "from_moz(M." + t + ").body";
                    o += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            a += "\n})\n}";
            o += "\n}\n}";
            a = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + a + ")")(v, s, f, u);
            o = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + o + ")")(l, p, d);
            i[e] = a;
            c(n, o);
        }
        var a = null;
        function u(e) {
            a.push(e);
            var n = e != null ? i[e.type](e) : null;
            a.pop();
            return n;
        }
        Ue.from_mozilla_ast = function(e) {
            var n = a;
            a = [];
            var t = u(e);
            a = n;
            t.walk(new jt(function(e) {
                if (e instanceof de) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof sn) break;
                        if (t instanceof Qe && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        he("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof We && n.body[0].body instanceof xt) {
                t.unshift(l(new Ve(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var z = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return Ne(n);
        function t(e) {
            n.push(e);
        }
    }();
    function $(e, n) {
        e.walk(new jt(function(e) {
            if (e instanceof ot) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Ln) {
                Y(e.property, t);
            }
        }));
        function t(e) {
            Fe(n, e);
        }
    }
    function Y(e, n) {
        if (e instanceof Kn) {
            Y(e.consequent, n);
            Y(e.alternative, n);
        } else if (e instanceof Un) {
            Y(e.tail_node(), n);
        } else if (e instanceof xt) {
            n(e.value);
        }
    }
    function L(e, t) {
        t = le(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : z);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new He();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new jt(function(e) {
            if (e instanceof Xn) {
                if (e.operator == "in") Y(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Yn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof bt)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    Y(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    Y(e.args[0], p);
                    break;
                }
            } else if (e instanceof Yn) {
                p(e.property);
            } else if (e instanceof ot) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Ln) {
                Y(e.property, p);
            }
        }));
        e.walk(new jt(function(e) {
            if (e instanceof Xn) {
                if (e.operator == "in") v(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Yn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof bt)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    v(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    v(e.args[0]);
                    break;
                }
            } else if (e instanceof Yn) {
                e.property = d(e.property);
            } else if (e instanceof ot) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Ln) {
                if (!t.keep_quoted) v(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (a && !a.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = w(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function v(e) {
            if (e instanceof Un) {
                v(e.expressions.tail_node());
            } else if (e instanceof xt) {
                e.value = d(e.value);
            } else if (e instanceof Kn) {
                v(e.consequent);
                v(e.alternative);
            }
        }
    }
    "use strict";
    var V, W;
    if (typeof Buffer == "undefined") {
        V = atob;
        W = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        V = function(e) {
            return new Buffer(e, "base64").toString();
        };
        W = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        V = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        W = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function J(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(a[2]);
                if (!a) break;
                return V(a[2]);
            }
        }
        Ue.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function G(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function X(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function ie(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new He();
        } else if (!(e.props instanceof He)) {
            e.props = He.fromObject(e.props);
        }
    }
    function re(e) {
        return {
            props: e.props.toObject()
        };
    }
    function ae(i, r) {
        try {
            r = le(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) Ue.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            X("ie8", r, [ "compress", "mangle", "output" ]);
            X("keep_fnames", r, [ "compress", "mangle" ]);
            X("toplevel", r, [ "compress", "mangle" ]);
            X("v8", r, [ "mangle", "output" ]);
            X("webkit", r, [ "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = le(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                ie(r.mangle.cache);
                ie(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = le(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) Ue.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (i instanceof fn) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var o = r.sourceMap && r.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = G(o);
                }
                if (o) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (Ie(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = a = Pt(i[s], r.parse);
                    if (o == "inline") {
                        var f = J(s, a);
                        if (f) {
                            r.sourceMap.orig[s] = G(f);
                        }
                    } else if (o) {
                        r.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                $(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (r.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                a = new Ut(r.compress).compress(a);
                if (r.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) L(a, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = a;
            }
            if (!Ie(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = A(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof fn) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (Ie(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = Rt(r.output);
                a.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + W(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = re(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = re(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            Ue.log_function();
            Ue.disable_validation();
        }
    }
    v["Dictionary"] = He;
    v["List"] = je;
    v["minify"] = ae;
    v["parse"] = Pt;
    v["push_uniq"] = Fe;
    v["TreeTransformer"] = Ht;
    v["TreeWalker"] = jt;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
